package sra.gl4jun.test;

import java.awt.*;
import javax.swing.*;
import sra.gl4jun.*;

/**
 * GLjJImageTest class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/09/01 (by MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: GLjJImageTest.java,v 6.0 2003/10/28 10:52:02 nisinaka Exp $
 */
public class GLjJImageTest extends JPanel {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		JMenuBar menuBar = new JMenuBar();
		frame.setJMenuBar(menuBar);

		JMenu fileMenu = new JMenu("File");
		menuBar.add(fileMenu);
		fileMenu.add(new JMenuItem("Exit"));

		GLjJImageTest canvas = new GLjJImageTest();
		canvas.setPreferredSize(new Dimension(256, 256));
		frame.getContentPane().add(canvas);
		frame.getContentPane().add("East", new JButton("East"));
		frame.getContentPane().add("West", new JButton("West"));
		frame.pack();
		frame.show();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param gc java.awt.Graphics
	 */
	public synchronized void paint(Graphics gc) {
		Dimension size = this.getSize();
		GLjImageSource imageSource = new GLjImageSource(size.width, size.height);
		GLjRenderingContext rc = new GLjRenderingContext(imageSource);
		synchronized (rc.OpenGLInterface()) {
			rc.gljInitialize();
			rc.gljCurrent();

			//
			GLjInterface gl = rc.OpenGLInterface();
			gl.glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
			gl.glClear(gl.GL_COLOR_BUFFER_BIT);
			gl.glColor3f(1.0f, 0.0f, 0.0f);
			gl.glPolygonMode(gl.GL_FRONT, gl.GL_LINE);
			gl.glPolygonMode(gl.GL_BACK, gl.GL_FILL);
			gl.glFrontFace(gl.GL_CW);
			gl.glBegin(gl.GL_POLYGON);
			gl.glVertex2f(-0.5f, 0.5f);
			gl.glVertex2f(-0.5f, -0.5f);
			gl.glVertex2f(0.5f, -0.5f);
			gl.glVertex2f(0.5f, 0.5f);
			gl.glEnd();

			//
			rc.gljFlush();
			rc.gljRelease();
		}

		gc.drawImage(imageSource.getImage(), 0, 0, null);
	}
}
