package sra.jun.collections.linkedlist;

/**
 * JunDoubleLink class
 * 
 *  @author    nisinaka
 *  @created   2002/01/21 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDoubleLink.java,v 6.0 2003/10/28 10:52:02 nisinaka Exp $
 */
public class JunDoubleLink extends JunSingleLink {
	/** The link to the previous entity. */
	protected JunDoubleLink backLink = null;

	/**
	 * Create a new instance of JunDoubleLink and initialize it with the entity
	 * object.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunDoubleLink(Object anObject) {
		this(anObject, null, null);
	}

	/**
	 * Create a new instance of JunDoubleLink and initialize it with the entity
	 * object and the next link.
	 * 
	 * @param anObject java.lang.Object
	 * @param nextLink sra.jun.collections.linkedlist.JunDoubleLink
	 */
	public JunDoubleLink(Object anObject, JunDoubleLink nextLink) {
		this(anObject, nextLink, null);
	}

	/**
	 * Create a new instance of JunDoubleLink and initialize it with the entity
	 * object, the next link, and the back link.
	 * 
	 * @param anObject java.lang.Object
	 * @param nextLink sra.jun.collections.linkedlist.JunDoubleLink
	 * @param backLink sra.jun.collections.linkedlist.JunDoubleLink
	 */
	public JunDoubleLink(Object anObject, JunDoubleLink nextLink, JunDoubleLink backLink) {
		this.entityObject_(anObject);
		this.nextLink_(nextLink);
		this.backLink_(backLink);
	}

	/**
	 * Answer the back link.
	 * 
	 * @return sra.jun.collections.linkedlist.JunDoubleLink
	 */
	public JunDoubleLink backLink() {
		return backLink;
	}

	/**
	 * Set the back link.
	 * 
	 * @param aLink sra.jun.collections.linkedlist.JunDoubleLink
	 */
	public void backLink_(JunDoubleLink aLink) {
		backLink = aLink;
	}
}
