package sra.jun.collections.linkedlist;

import java.io.*;
import sra.smalltalk.StObject;

/**
 * JunSingleLink class
 * 
 *  @author    nisinaka
 *  @created   1998/11/09 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSingleLink.java,v 6.0 2003/10/28 10:52:02 nisinaka Exp $
 */
public class JunSingleLink extends StObject {
	/** The entity object. */
	protected Object entityObject = null;

	/** The link to the next entity. */
	protected JunSingleLink nextLink = null;

	/**
	 * Create a new instance of JunSingleLink and initialize it with the
	 * Object.
	 * 
	 * @param anObject java.lang.Object
	 * 
	 * @return sra.jun.collections.linkedlist.JunSingleLink
	 */
	public static JunSingleLink Entity_(Object anObject) {
		JunSingleLink newLink = new JunSingleLink();
		newLink.entityObject = anObject;
		newLink.nextLink = null;

		return newLink;
	}

	/**
	 * Create a new instance of JunSingleLink and initialize it with the Object
	 * and the Link.
	 * 
	 * @param anObject java.lang.Object
	 * @param aLink sra.jun.collections.linkedlist.JunSingleLink
	 * 
	 * @return sra.jun.collections.linkedlist.JunSingleLink
	 */
	public static JunSingleLink Entity_next_(Object anObject, JunSingleLink aLink) {
		JunSingleLink newLink = new JunSingleLink();
		newLink.entityObject = anObject;
		newLink.nextLink = aLink;

		return newLink;
	}

	/**
	 * Answer the entity object.
	 * 
	 * @return java.lang.Object
	 */
	public Object entityObject() {
		return entityObject;
	}

	/**
	 * Set the entity object.
	 * 
	 * @param anObject java.lang.Object
	 */
	public void entityObject_(Object anObject) {
		entityObject = anObject;
	}

	/**
	 * Answer the next link.
	 * 
	 * @return sra.jun.collections.linkedlist.JunSingleLink
	 */
	public JunSingleLink nextLink() {
		return nextLink;
	}

	/**
	 * Set the next link.
	 * 
	 * @param aLink sra.jun.collections.linkedlist.JunSingleLink
	 */
	public void nextLink_(JunSingleLink aLink) {
		nextLink = aLink;
	}

	/**
	 * Print my string representation on the Writer.
	 * 
	 * @param aWriter java.io.Writer
	 * 
	 * @throws IOException DOCUMENT ME!
	 */
	public void printOn_(Writer aWriter) throws IOException {
		if (entityObject instanceof StObject) {
			((StObject) entityObject).printOn_(aWriter);
		} else {
			aWriter.write(entityObject.toString());
		}

		if (nextLink != null) {
			aWriter.write(" ");
			nextLink.printOn_(aWriter);
		}
	}
}
