package sra.jun.csg.abstracts;

import sra.jun.solid.abstracts.JunSolid;

/**
 * JunBinaryCSG class
 * 
 *  @author    nisinaka
 *  @created   1998/10/18 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBinaryCSG.java,v 6.0 2003/10/28 10:52:03 nisinaka Exp $
 */
public abstract class JunBinaryCSG extends JunCSG {
	protected JunSolid solid1;
	protected JunSolid solid2;

	/**
	 * Create a new instance of JunBinaryCSG.
	 * 
	 * @param aSolid1 sra.jun.solid.abstracts.JunSolid
	 * @param aSolid2 sra.jun.solid.abstracts.JunSolid
	 */
	public JunBinaryCSG(JunSolid aSolid1, JunSolid aSolid2) {
		this.solid1_(aSolid1);
		this.solid2_(aSolid2);
	}

	/**
	 * A default constructor.
	 */
	protected JunBinaryCSG() {
	}

	/**
	 * Answer the solid1.
	 * 
	 * @return sra.jun.solid.abstracts.JunSolid
	 */
	public JunSolid solid1() {
		return solid1;
	}

	/**
	 * Set the solid1.
	 * 
	 * @param aSolid sra.jun.solid.abstracts.JunSolid
	 */
	public void solid1_(JunSolid aSolid) {
		solid1 = aSolid;
	}

	/**
	 * Answer the solid2.
	 * 
	 * @return sra.jun.solid.abstracts.JunSolid
	 */
	public JunSolid solid2() {
		return solid2;
	}

	/**
	 * Set the solid2.
	 * 
	 * @param aSolid sra.jun.solid.abstracts.JunSolid
	 */
	public void solid2_(JunSolid aSolid) {
		solid2 = aSolid;
	}
}
