package sra.jun.csg.atoms;

import sra.jun.csg.abstracts.JunCSG;
import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.solid.abstracts.JunSolid;

/**
 * JunSolidCSG class
 * 
 *  @author    nisinaka
 *  @created   1998/10/19 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSolidCSG.java,v 6.0 2003/10/28 10:52:03 nisinaka Exp $
 */
public class JunSolidCSG extends JunCSG {
	protected JunSolid solid;

	/**
	 * Create a new instance of JunSolidCSG.
	 * 
	 * @param aJunSolid sra.jun.solid.abstracts.JunSolid
	 */
	public JunSolidCSG(JunSolid aJunSolid) {
		this.setSolid_(aJunSolid);
	}

	/**
	 * Create a new instance of JunSolidCSG.
	 * 
	 * @param aJunSolid sra.jun.solid.abstracts.JunSolid
	 * 
	 * @return sra.jun.csg.atoms.JunSolidCSG
	 */
	public static JunSolidCSG On_(JunSolid aJunSolid) {
		return new JunSolidCSG(aJunSolid);
	}

	/**
	 * Answer the solid.
	 * 
	 * @return sra.jun.solid.abstracts.JunSolid
	 */
	public JunSolid solid() {
		return solid;
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return solid.valueAt_(aJun3dPoint);
	}

	/**
	 * Set the solid.
	 * 
	 * @param aJunSolid sra.jun.solid.abstracts.JunSolid
	 */
	protected void setSolid_(JunSolid aJunSolid) {
		solid = aJunSolid;
	}
}
