package sra.jun.csg.compound;

import sra.jun.csg.abstracts.JunBinaryCSG;
import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.solid.abstracts.JunSolid;

/**
 * JunCSGDifference class
 * 
 *  @author    nisinaka
 *  @created   1998/10/18 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCSGDifference.java,v 6.0 2003/10/28 10:52:03 nisinaka Exp $
 */
public class JunCSGDifference extends JunBinaryCSG {

	/**
	 * Create a new instance of JunCSGDifference.
	 * 
	 * @param aSolid1 sra.jun.solid.abstracts.JunSolid
	 * @param aSolid2 sra.jun.solid.abstracts.JunSolid
	 */
	public JunCSGDifference(JunSolid aSolid1, JunSolid aSolid2) {
		super(aSolid1, aSolid2);
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return Math.min(solid1.valueAt_(aJun3dPoint), solid2.valueAt_(aJun3dPoint) * -1);
	}
}
