package sra.jun.delaunay.twoD;

import sra.smalltalk.StObject;

/**
 * Jun2dDelaunayElement class
 * 
 *  @author    Ryouichi Matsuda
 *  @created   2002/01/14 (by Ryouichi Matsuda)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: Jun2dDelaunayElement.java,v 6.0 2003/10/28 10:52:03 nisinaka Exp $
 */
public abstract class Jun2dDelaunayElement extends StObject {
	// 1.0d-8
	public static final double DECIMAL_8 = 0.00000001d;
	// 1.0d-12
	public static final double DECIMAL_12 = 0.000000000001d;
	protected Jun2dDelaunayElement next;
	protected Jun2dDelaunayElement prev;

	/**
	 * display.
	 */
	protected void display() {
		// should not implement...
	}

	/**
	 * Get next element.
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	protected Jun2dDelaunayElement next() {
		return next;
	}

	/**
	 * Get previous element.
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	protected Jun2dDelaunayElement prev() {
		return prev;
	}

	/**
	 * Removed from List.
	 * 
	 * @return DOCUMENT ME!
	 */
	protected Jun2dDelaunayElement removedFromList() {
		prev.setNext_(next);
		next.setPrev_(prev);
		next = null;
		prev = null;

		return this;
	}

	/**
	 * Set next element.
	 * 
	 * @param aJun2dDelaunayElement sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	protected void setNext_(Jun2dDelaunayElement aJun2dDelaunayElement) {
		next = aJun2dDelaunayElement;
	}

	/**
	 * Set previous element.
	 * 
	 * @param aJun2dDelaunayElement sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	protected void setPrev_(Jun2dDelaunayElement aJun2dDelaunayElement) {
		prev = aJun2dDelaunayElement;
	}
}
