package sra.jun.delaunay.twoD;

import sra.smalltalk.*;

/**
 * Jun2dDelaunayList class
 * 
 *  @author    Ryouichi Matsuda
 *  @created   2002/01/14 (by Ryouichi Matsuda)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: Jun2dDelaunayList.java,v 6.0 2003/10/28 10:52:03 nisinaka Exp $
 */
public class Jun2dDelaunayList extends Jun2dDelaunayElement {

	/**
	 * Create a new instance of Jun2dDelaunayList.
	 */
	public Jun2dDelaunayList() {
		super();
		this.initialize();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aJun2dDelaunayElement sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement add_(Jun2dDelaunayElement aJun2dDelaunayElement) {
		if (aJun2dDelaunayElement.next() != null) {
			aJun2dDelaunayElement.removedFromList();
		}

		prev.setNext_(aJun2dDelaunayElement);
		aJun2dDelaunayElement.setPrev_(prev);
		aJun2dDelaunayElement.setNext_(this);
		this.setPrev_(aJun2dDelaunayElement);

		return aJun2dDelaunayElement;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param anInteger int
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement at_(int anInteger) {
		Jun2dDelaunayElement element;

		element = this;

		for (int i = 0; i < anInteger; i++) {
			element = element.next();

			if (element == this) {
				throw SmalltalkException.Error("out of bounds");
			}
		}

		return element;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param anInteger int
	 * @param aJun2dDelaunayElement sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public void at_put_(int anInteger, Jun2dDelaunayElement aJun2dDelaunayElement) {
		throw SmalltalkException.ShouldNotImplement();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aBlock sra.smalltalk.StBlockClosure
	 * @param errorBlock sra.smalltalk.StBlockClosure
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement detect_ifNone_(final StBlockClosure aBlock, StBlockClosure errorBlock) {
		Object o;

		o = this.do_(new StBlockClosure() {
			public Object value_(Object element) {
				if (aBlock.value_(element) == Boolean.TRUE) {
					return element;
				}

				return null;
			}
		});

		if (o != null) {
			return (Jun2dDelaunayElement) o;
		}

		return (Jun2dDelaunayElement) errorBlock.value();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aBlock sra.smalltalk.StBlockClosure
	 * 
	 * @return DOCUMENT ME!
	 */
	public Object do_(StBlockClosure aBlock) {
		Jun2dDelaunayElement element;

		element = next;

		while (element != this) {
			Jun2dDelaunayElement nextElement;
			Object o;

			nextElement = element.next();
			o = aBlock.value_(element);

			if (o != null) {
				return o;
			}

			element = nextElement;
		}

		return null;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement first() {
		if (next == this) {
			SmalltalkException.Error("out of bounds");
		}

		return next;
	}

	/**
	 * DOCUMENT ME!
	 */
	public void initialize() {
		next = this;
		prev = this;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement last() {
		if (prev == this) {
			SmalltalkException.Error("out of bounds");
		}

		return prev;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aJun2dDelaunayElement sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 * 
	 * @return sra.jun.delaunay.twoD.Jun2dDelaunayElement
	 */
	public Jun2dDelaunayElement remove_(Jun2dDelaunayElement aJun2dDelaunayElement) {
		return aJun2dDelaunayElement.removedFromList();
	}
}
