package sra.jun.geometry.basic;

import sra.jun.system.support.*;

/**
 * Jun3dBoundingBoxTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/10/05 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: Jun3dBoundingBoxTestExamples.java,v 6.0 2003/10/28 10:52:04 nisinaka Exp $
 */
public class Jun3dBoundingBoxTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		Jun3dPoint originPoint = new Jun3dPoint(0, 0, 0);
		Jun3dPoint cornerPoint = new Jun3dPoint(100, 100, 100);
		Jun3dBoundingBox aBoundingBox = Jun3dBoundingBox.Origin_corner_(originPoint, cornerPoint);
		System.out.println(aBoundingBox.printString());

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		Jun3dPoint aPoint1 = new Jun3dPoint(0, 100, 0);
		Jun3dPoint aPoint2 = new Jun3dPoint(100, 0, 100);
		Jun3dBoundingBox aBoundingBox = Jun3dBoundingBox.Vertex_vertex_(aPoint1, aPoint2);
		System.out.println(aBoundingBox.printString());

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example3() {
		Jun3dPoint aPoint1 = new Jun3dPoint(0, 100, 0);
		Jun3dPoint aPoint2 = new Jun3dPoint(100, 0, 100);
		Jun3dBoundingBox aBoundingBox = Jun3dBoundingBox.Vertex_vertex_(aPoint1, aPoint2);
		System.out.println(aBoundingBox.expandedBy_(10).printString());

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example4() {
		Jun3dPoint aPoint1 = new Jun3dPoint(0, 100, 0);
		Jun3dPoint aPoint2 = new Jun3dPoint(100, 0, 100);
		Jun3dBoundingBox aBoundingBox = Jun3dBoundingBox.Vertex_vertex_(aPoint1, aPoint2);
		System.out.println(aBoundingBox.insetBy_(10).printString());

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * 
	 * @throws Exception DOCUMENT ME!
	 */
	public static void main(String[] args) throws Exception {
		new Jun3dBoundingBoxTestExamples();
	}
}
