package sra.jun.geometry.basic;

import sra.jun.geometry.abstracts.*;

/**
 * JunBoundingBox class
 * 
 *  @author    nisinaka
 *  @created   1998/10/01 (by nisinaka)
 *  @updated   1999/08/05 (by nisinaka)
 *  @updated   2000/01/06 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBoundingBox.java,v 6.0 2003/10/28 10:52:04 nisinaka Exp $
 */
public abstract class JunBoundingBox extends JunGeometry {

	/**
	 * Answer the depth of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double depth();

	/**
	 * Answer the height of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double height();

	/**
	 * Answer the width of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double width();

}
