package sra.jun.geometry.boundaries;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.smalltalk.StBlockClosure;

/**
 * JunBorderGenerator06 class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/1/8 (by Hirotsugu Kondo)
 *  @updated   1999/5/28 (by MATSUDA Ryouichi)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBorderGenerator06.java,v 6.0 2003/10/28 10:52:05 nisinaka Exp $
 */
public class JunBorderGenerator06 {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param marchingCubes DOCUMENT ME!
	 */
	static final void InitializeMarchingCubes6_(StBlockClosure[] marchingCubes) {
		marchingCubes[95] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[96] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[97] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[98] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[99] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[100] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[101] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[102] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[103] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[104] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[105] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[106] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[107] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[108] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[109] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[110] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[111] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

	}
}
