package sra.jun.geometry.boundaries;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.smalltalk.StBlockClosure;

/**
 * JunBorderGenerator08 class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/1/8 (by Hirotsugu Kondo)
 *  @updated   1999/5/28 (by MATSUDA Ryouichi)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBorderGenerator08.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public class JunBorderGenerator08 {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param marchingCubes DOCUMENT ME!
	 */
	static final void InitializeMarchingCubes8_(StBlockClosure[] marchingCubes) {
		marchingCubes[127] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[1][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[128] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[129] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[130] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[131] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);

				return triangles;
			}
		};

		marchingCubes[132] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[133] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[134] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[135] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[136] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[137] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);

				return triangles;
			}
		};

		marchingCubes[138] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[139] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[140] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[141] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[142] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[143] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

	}
}
