package sra.jun.geometry.boundaries;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.smalltalk.StBlockClosure;

/**
 * JunBorderGenerator12 class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/1/8 (by Hirotsugu Kondo)
 *  @updated   1999/5/28 (by MATSUDA Ryouichi)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBorderGenerator12.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public class JunBorderGenerator12 {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param marchingCubes DOCUMENT ME!
	 */
	static final void InitializeMarchingCubes12_(StBlockClosure[] marchingCubes) {
		marchingCubes[191] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[192] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[193] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[5][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[4][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[4][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[4][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[194] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[195] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[196] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[197] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[198] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[199] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[200] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[201] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[202] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[203] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[204] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[205] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[206] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[207] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 1)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

	}
}
