package sra.jun.geometry.boundaries;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.smalltalk.StBlockClosure;

/**
 * JunBorderGenerator14 class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/1/8 (by Hirotsugu Kondo)
 *  @updated   1999/5/28 (by MATSUDA Ryouichi)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBorderGenerator14.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public class JunBorderGenerator14 {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param marchingCubes DOCUMENT ME!
	 */
	static final void InitializeMarchingCubes14_(StBlockClosure[] marchingCubes) {
		marchingCubes[223] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[224] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[225] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[226] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[227] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[228] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[229] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[230] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[231] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[4][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[3][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[3][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[232] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[233] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[234] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[235] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[3][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[2][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[2][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[236] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 1, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[237] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 0)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 1, 0)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);

				return triangles;
			}
		};

		marchingCubes[238] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[1][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(1, 0, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 1)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);

				return triangles;
			}
		};

		marchingCubes[239] = new StBlockClosure() {
			public Object value_value_(Object aPoint, Object anInteger) {
				Jun3dPoint point = (Jun3dPoint) aPoint;
				double label = ((Double) anInteger).doubleValue();
				JunBorderVertex[][] triangles = new JunBorderVertex[2][3];
				triangles[0][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[0][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 1, 0)), point.plus_(new Jun3dPoint(0, 1, 1)), label);
				triangles[0][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][0] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(0, 0, 0)), point.plus_(new Jun3dPoint(0, 0, 1)), label);
				triangles[1][1] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 1, 0)), point.plus_(new Jun3dPoint(1, 1, 1)), label);
				triangles[1][2] = JunBorderVertex.Vertex_vertex_label_(point.plus_(new Jun3dPoint(1, 0, 0)), point.plus_(new Jun3dPoint(1, 0, 1)), label);

				return triangles;
			}
		};

	}
}
