package sra.jun.geometry.boundaries;

import sra.jun.geometry.abstracts.*;
import sra.jun.geometry.basic.*;
import sra.smalltalk.SmalltalkException;

/**
 * JunBoundingBall class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/24 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBoundingBall.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public abstract class JunBoundingBall extends JunGeometry {
	/**
	 * center point. In subclass, this should be Jun2dPoint, Jun3dPoint or so,
	 */
	protected JunPoint center;

	/** radius. */
	protected double radius;

	/**
	 * Answer true if the Object is equal to the receiver, otherwise false.
	 * 
	 * @param other java.lang.Object
	 * 
	 * @return boolean
	 */
	public abstract boolean equals(Object other);

	// Hash Function

	/**
	 * Computes a hash code for this object.
	 * 
	 * @return int
	 */
	public int hashCode() {
		long bitsRadius = Double.doubleToLongBits(this.radius);
		int radiusHash = (int) (bitsRadius ^ (bitsRadius >> 32));

		return this.center.hashCode() | radiusHash;
	}

	/**
	 * Do an extra copy of the receiver.
	 * 
	 * @return sra.smalltalk.StObject
	 */
	public sra.smalltalk.StObject postCopy() {
		throw SmalltalkException.SubclassResponsibility();
	}

	/**
	 * answer the radius.
	 * 
	 * @return double
	 */
	public double radius() {
		return this.radius;
	}

	/**
	 * set the radius.
	 * 
	 * @param aNumber
	 */
	public void radius_(double aNumber) {
		this.radius = aNumber;
	}
}
