package sra.jun.geometry.surfaces;

import sra.jun.geometry.basic.*;
import sra.jun.geometry.curves.Jun3dLine;

/**
 * JunPlaneTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/11/09 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPlaneTestExamples.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public class JunPlaneTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 10, 0), new Jun3dPoint(10, 20, 30));
		System.out.println(aPlane.printString());

		return true;
	}

	/**
	 * Starts the application.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunPlaneTestExamples();
	}

	/**
	 * Test case of the method "intersectingPointWithLine_()".
	 * 
	 * @return boolean
	 */
	public static boolean Test1() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(-2, -2, 0), new Jun3dPoint(0, 2, 0), new Jun3dPoint(2, 0, 0));
		Jun3dLine aLine = new Jun3dLine(new Jun3dPoint(0, 0, -2), new Jun3dPoint(0, 0, 2));
		Jun3dPoint aPoint = aPlane.intersectingPointWithLine_(aLine);

		return (aPoint.x() == 0) && (aPoint.y() == 0) && (aPoint.z() == 0);
	}

	/**
	 * Test case of the method "intersectingPointWithLine_()".
	 * 
	 * @return boolean
	 */
	public static boolean Test2() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		Jun3dLine aLine = new Jun3dLine(new Jun3dPoint(0, 0, -2), new Jun3dPoint(0, 0, -1));
		Jun3dPoint aPoint = aPlane.intersectingPointWithLine_(aLine);

		return (aPoint.x() == 0) && (aPoint.y() == 0) && (aPoint.z() == 0);
	}

	/**
	 * Test case of the method "normalUnitVector()".
	 * 
	 * @return boolean
	 */
	public static boolean Test3() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(-2, -2, 0), new Jun3dPoint(2, 0, 0), new Jun3dPoint(-2, 2, 0));
		Jun3dPoint aPoint = aPlane.normalUnitVector();

		return (aPoint.x() == 0) && (aPoint.y() == 0) && (aPoint.z() == 1);
	}

	/**
	 * Test case of the method "normalUnitVector()".
	 * 
	 * @return boolean
	 */
	public static boolean Test4() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(2, 0, 0), new Jun3dPoint(0, 2, 0), new Jun3dPoint(0, 0, 2));
		Jun3dPoint aPoint = aPlane.normalUnitVector();

		return (aPoint.x() == 0.5773502691896258) && (aPoint.y() == 0.5773502691896258) && (aPoint.z() == 0.5773502691896258);
	}

	/**
	 * Test case of the method "angleWithLine_()".
	 * 
	 * @return boolean
	 */
	public static boolean Test5() {
		JunPlane aPlane = new JunPlane(new Jun3dPoint(-2, -2, 0), new Jun3dPoint(0, 2, 0), new Jun3dPoint(2, 0, 0));
		Jun3dLine aLine = new Jun3dLine(new Jun3dPoint(0, 0, -2), new Jun3dPoint(0, 0, 2));
		JunAngle anAngle = aPlane.angleWithLine_(aLine);

		return anAngle.deg() == -90.0d;
	}
}
