package sra.jun.geometry.transformations;

import sra.jun.collections.sequences.*;
import sra.jun.geometry.abstracts.*;

/**
 * JunTransformation class
 * 
 *  @author    nisinaka
 *  @created   1998/09/28 (by nisinaka)
 *  @updated   2000/01/06 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTransformation.java,v 6.0 2003/10/28 10:52:06 nisinaka Exp $
 */
public abstract class JunTransformation extends JunGeometry {

	/**
	 * Convert this transformation as an array.
	 * 
	 * @return double[]
	 */
	public abstract double[] asArray();

	/**
	 * Convert this transformation as a matrix.
	 * 
	 * @return sra.jun.collections.sequences.JunDoubleMatrix
	 */
	public abstract JunDoubleMatrix asMatrix();
}
