package sra.jun.goodies.bulletinboard;

import sra.smalltalk.*;

/**
 * JunBulletinBoardController class
 * 
 *  @author    nisinaka
 *  @created   2002/11/27 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBulletinBoardController.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunBulletinBoardController extends StController {

	protected boolean bulletinState;
	protected Thread bulletinProcess;

	/**
	 * Create a new instance of JunBulletinBoardController and initialize it.
	 */
	public JunBulletinBoardController() {
		bulletinState = false;
		bulletinProcess = null;
	}

	/**
	 * Make sure to terminate the process when finalizing.
	 */
	protected void finalize() throws Throwable {
		this.terminate();
		super.finalize();
	}

	/**
	 * Resure the process.
	 */
	protected void resume() {
		bulletinState = true;
		bulletinProcess = new Thread() {
			public void run() {
				try {
					while (bulletinState && view() != null && model().dependents().length > 0) {
						((JunBulletinBoardView) view()).display();
						Thread.yield();
						try {
							Thread.sleep(tickTime());
						} catch (InterruptedException e) {
							bulletinState = false;
						}
					}
				} finally {
					terminate();
				}
			}
		};
		// bulletinProcess.setPriority(Thread.NORM_PRIORITY + 1);
		bulletinProcess.setPriority(Thread.MAX_PRIORITY);
		bulletinProcess.start();
	}

	/**
	 * Terminate the process.
	 */
	protected void terminate() {
		bulletinState = false;
		Thread.yield();
	}

	/**
	 * Answer the time for ticking the bulletin process.
	 *
	 * @return int
	 */
	protected int tickTime() {
		return 20;
	}
}
