package sra.jun.goodies.button;

import sra.smalltalk.*;
import sra.jun.goodies.cursors.JunCursors;

/**
 * JunButtonModelTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/10/xx (by nisinaka)
 *  @updated   2002/11/03 (by nisinaka)
 *  @updated   2002/11/21 (by nisinaka)
 *  @updated   2003/03/24 (by nisinaka)
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunButtonModelTestExamples.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunButtonModelTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Example1: the button label is a String.
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunButtonModel buttonModel = new JunButtonModel(false, "test", new StBlockClosure() {
			public Object value_(Object o) {
				JunButtonModel model = (JunButtonModel) o;
				model.value_(!model.value());
				return model;
			}
		});
		buttonModel.open();
		return true;
	}

	/**
	 * Example2: the button label is an image.
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunButtonModel buttonModel = new JunButtonModel(true, JunCursors.ExecuteCursorImage(), new StBlockClosure() {
			public Object value_(Object o) {
				JunButtonModel model = (JunButtonModel) o;
				model.value_(!model.value());
				return model;
			}
		});
		buttonModel.open();
		return true;
	}

	/**
	 * Example3: the button label is an image.
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunButtonModel buttonModel = new JunButtonModel(false, StImage._FromUser(), new StBlockClosure() {
			public Object value_(Object o) {
				JunButtonModel model = (JunButtonModel) o;
				model.value_(!model.value());
				return model;
			}
		});
		buttonModel.open();
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunButtonModelTestExamples();
	}
}
