package sra.jun.goodies.calendar;

import java.awt.Toolkit;
import java.awt.datatransfer.*;
import java.io.IOException;

import sra.jun.system.support.JunTestExamples;
import sra.smalltalk.SmalltalkException;

/**
 * JunCalendarClockDateAndTimeTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockDateAndTimeTestExamples.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarClockDateAndTimeTestExamples extends JunTestExamples {
	/**
	 * Example2: Set up and open a JunCalendarDateAndTime.
	 *
	 * @return boolean
	 */
	public static boolean Example3() {
		JunCalendarDateAndTimeModel cal =
			JunCalendarDateAndTimeModel.Year_month_day_hours_minutes_seconds_(
				1999,
				11,
				11,
				23,
				59,
				59);
		cal.open();
		return true;
	}

	/**
	 * Example2: Create a instance of JunCalendarDateAndTimeModel.
	 * And print standard out self. Copy date and time and print out standard out.
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		JunCalendarDateAndTimeModel cal = new JunCalendarDateAndTimeModel();
		System.out.println(cal);
		cal.copyDateAndTime();
		Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
		try {
			System.out.println(
				(String) (clip
					.getContents(null)
					.getTransferData(DataFlavor.stringFlavor)));
		} catch (IOException e) {
			throw new SmalltalkException(e);
		} catch (UnsupportedFlavorException e) {
		}
		return true;
	}

	/**
	 * Example1: Open a JunCalendarDateAndTime.
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarClockDateAndTime cal = new JunCalendarClockDateAndTime();
		cal.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(String argv[]) {
		new JunCalendarClockDateAndTimeTestExamples();
	}
}
