package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;

/**
 * JunCalendarClockDateViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockDateViewAwt.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarClockDateViewAwt
	extends StViewPanel
	implements JunCalendarClockDateView {
	protected JunCalendarDateViewAwt dateView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarClockDate JunCalendarClockDate
	 * @category instance creation
	 */
	public JunCalendarClockDateViewAwt(JunCalendarClockDate aCalendarClockDate) {
		super(aCalendarClockDate);
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category defaults
	 */
	public JunCalendarDateViewAwt dateView() {
		if (dateView == null) {
			dateView =
				new JunCalendarDateViewAwt(this.getModel().calendarDateModel());
		}
		return dateView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarTimeModel
	* @category accessing
	*/
	public JunCalendarClockDate getModel() {
		return (JunCalendarClockDate) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.dateView().setBounds(1, 1, 300, 200);
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.dateView());
		this.setSize(300, 200);
	}
}
