package sra.jun.goodies.calendar;

import java.awt.Dimension;

import sra.smalltalk.StViewJPanel;

/**
 * JunCalendarClockTimeViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockTimeViewSwing.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarClockTimeViewSwing
	extends StViewJPanel
	implements JunCalendarClockTimeView {
	protected JunCalendarTimeViewSwing timeView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarClockTime JunCalendarClockTime
	 * @category instance creation
	 */
	public JunCalendarClockTimeViewSwing(JunCalendarClockTime aCalendarClockTime) {
		super(aCalendarClockTime);
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	public JunCalendarTimeViewSwing timeView() {
		if (timeView == null) {
			timeView =
				new JunCalendarTimeViewSwing(
					this.getModel().calendarTimeModel());
		}
		return timeView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarTimeModel
	* @category accessing
	*/
	public JunCalendarClockTime getModel() {
		return (JunCalendarClockTime) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 * @category interface opening
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.timeView().setBounds(1, 1, 150, 200);
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.timeView());
		this.setPreferredSize(new Dimension(150, 200));
	}
}
