package sra.jun.goodies.calendar;

import java.util.Calendar;

import sra.jun.system.support.JunTestExamples;

/**
 * JunCalendarDateAndTimeIntervalModelTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeIntervalModelTestExamples.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarDateAndTimeIntervalModelTestExamples
	extends JunTestExamples {
	/**
	 * Example1: Open a JunCalendarDateAndTimeIntervalModel.
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarDateAndTimeIntervalModel calendarDateAndTimeIntervalModel =
			new JunCalendarDateAndTimeIntervalModel();
		calendarDateAndTimeIntervalModel.open();
		return true;
	}

	/**
	 * Example2: Set time and open a JunCalendarDateAndTimeIntervalModel.
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		Calendar[] now = { Calendar.getInstance(), Calendar.getInstance()};
		Calendar[] after7days =
			{ Calendar.getInstance(), Calendar.getInstance()};
		int[] ampm = { 0, 12 };
		after7days[0].set(
			after7days[0].get(Calendar.YEAR),
			after7days[0].get(Calendar.MONTH),
			after7days[0].get(Calendar.DATE + 7),
			after7days[0].get(Calendar.HOUR)
				+ ampm[after7days[0].get(Calendar.AM_PM)],
			after7days[0].get(Calendar.MINUTE),
			after7days[0].get(Calendar.SECOND));
		JunCalendarDateAndTimeIntervalModel calendarDateAndTimeIntervalModel =
			JunCalendarDateAndTimeIntervalModel.From_to_(now, after7days);
		calendarDateAndTimeIntervalModel.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(String argv[]) {
		new JunCalendarDateAndTimeIntervalModelTestExamples();
	}
}
