package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;

/**
 * JunCalendarDateAndTimeIntervalViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeIntervalViewAwt.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarDateAndTimeIntervalViewAwt
	extends StViewPanel
	implements JunCalendarDateAndTimeIntervalView {
	protected JunCalendarDateAndTimeViewAwt fromView;
	protected JunCalendarDateAndTimeViewAwt toView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarDateAndTimeInterval JunCalendarDateAndTimeInterval
	 * @category instance creation
	 */
	public JunCalendarDateAndTimeIntervalViewAwt(JunCalendarDateAndTimeIntervalModel aCalendarDateAndTimeIntervalModel) {
		super(aCalendarDateAndTimeIntervalModel);
	}

	/**
	 * Answer a fromView.
	 *
	 * @return JunCalendarDateAndTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarDateAndTimeViewAwt fromView() {
		if (fromView == null) {
			fromView =
				new JunCalendarDateAndTimeViewAwt(
					this.getModel().fromCalendarDateAndTimeModel());
		}
		return fromView;
	}

	/**
	 * Answer a toView.
	 *
	 * @return JunCalendarDateAndTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarDateAndTimeViewAwt toView() {
		if (toView == null) {
			toView =
				new JunCalendarDateAndTimeViewAwt(
					this.getModel().toCalendarDateAndTimeModel());
		}
		return toView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarDateAndTimeModel
	* @category accessing
	*/
	public JunCalendarDateAndTimeIntervalModel getModel() {
		return (JunCalendarDateAndTimeIntervalModel) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.fromView().setBounds(1, 1, 450, 200);
		this.toView().setBounds(1, 201, 450, 200);
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.fromView());
		this.add(this.toView());
		this.setSize(450, 400);
	}
}
