package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;

/**
 * JunCalendarDateAndTimeViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeViewAwt.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarDateAndTimeViewAwt
	extends StViewPanel
	implements JunCalendarDateAndTimeView {
	protected JunCalendarDateViewAwt dateView;
	protected JunCalendarTimeViewAwt timeView;

	/**
	 * Create a new instance of JunCalendarDateAndTimeViewAwt and initialize it.
	 *
	 * @param aCalendarDateAndTimeModel JunCalendarDateAndTimeModel
	 * @category instance creation
	 */
	public JunCalendarDateAndTimeViewAwt(JunCalendarDateAndTimeModel aCalendarDateAndTimeModel) {
		super(aCalendarDateAndTimeModel);
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category accessing
	 */
	public JunCalendarDateViewAwt dateView() {
		if (dateView == null) {
			dateView =
				new JunCalendarDateViewAwt(this.getModel().calendarDateModel());
		}
		return dateView;
	}

	/**
	 * Answer my time view.
	 *
	 * @return JunCalendarTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarTimeViewAwt timeView() {
		if (timeView == null) {
			timeView =
				new JunCalendarTimeViewAwt(this.getModel().calendarTimeModel());
		}
		return timeView;
	}

	/**
	* Get model.
	* @category accessing
	*
	* @return JunCalendarTimeModel
	*/
	public JunCalendarDateAndTimeModel getModel() {
		return (JunCalendarDateAndTimeModel) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.dateView().setBounds(1, 1, 300, 200);
		this.timeView().setBounds(301, 1, 150, 200);
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.dateView());
		this.add(this.timeView());
		this.setSize(450, 200);
	}
}
