package sra.jun.goodies.calendar;

import java.awt.Dimension;

import sra.smalltalk.StViewJPanel;

/**
 * JunCalendarDateIntervalViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateIntervalViewSwing.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarDateIntervalViewSwing
	extends StViewJPanel
	implements JunCalendarDateIntervalView {
	protected JunCalendarDateViewSwing fromView;
	protected JunCalendarDateViewSwing toView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarDateInterval JunCalendarDateInterval
	 * @category instance creation
	 */
	public JunCalendarDateIntervalViewSwing(JunCalendarDateIntervalModel aCalendarDateIntervalModel) {
		super(aCalendarDateIntervalModel);
	}

	/**
	 * Answer a fromView.
	 *
	 * @return JunCalendarDateViewSwing
	 * @category accessing
	 */
	public JunCalendarDateViewSwing fromView() {
		if (fromView == null) {
			fromView =
				new JunCalendarDateViewSwing(
					this.getModel().fromCalendarDateModel());
		}
		return fromView;
	}

	/**
	 * Answer a toView.
	 *
	 * @return JunCalendarDateViewSwing
	 * @category accessing
	 */
	public JunCalendarDateViewSwing toView() {
		if (toView == null) {
			toView =
				new JunCalendarDateViewSwing(
					this.getModel().toCalendarDateModel());
		}
		return toView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarDateModel
	 * @category accessing
	*/
	public JunCalendarDateIntervalModel getModel() {
		return (JunCalendarDateIntervalModel) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.fromView().setBounds(1, 1, 300, 200);
		this.toView().setBounds(1, 201, 300, 200);
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.fromView());
		this.add(this.toView());
		this.setPreferredSize(new Dimension(300, 400));
	}
}
