package sra.jun.goodies.calendar;

import java.awt.Point;
import java.awt.event.*;

import sra.smalltalk.*;

/**
 * JunCalendarTimeController class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarTimeController.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarTimeController
	extends StController
	implements MouseListener {
	private MouseEvent mEvent;
	
	/**
	 * Mouse button pressed event.
	 * @param e MouseEvent
	 * @category control defaults
	 */
	public void mousePressed(MouseEvent e) {
		mEvent = e;
		if (mEvent.isMetaDown()) {
			this.view()._showPopupMenu(mEvent.getX(), mEvent.getY());
		} else {
			this.buttonActivity();
		}
	}

	/**
	 * Execute active button event
	 * @category activities
	 */
	public void buttonActivity() {
		Point point = new Point(mEvent.getX(), mEvent.getY());
		String key;
		StRectangle box;
		for (int i = 0; i < this.getView().frames().size(); ++i) {
			Object[] array = (Object[]) this.getView().frames().get(i);
			key = (String) array[0];
			box = (StRectangle) array[array.length - 1];
			if (box.containsPoint_(point)) {
				if (key.equals("label")) {
					this.labelActivity_(array);
				}
				if (key.equals("hours")) {
					this.hoursActivity_(array);
				}
				if (key.equals("minutes")) {
					this.minutesActivity_(array);
				}
				if (key.equals("seconds")) {
					this.secondsActivity_(array);
				}
				if (key.equals("button")) {
					this.buttonActivity_(array);
				}
			}
		}
	}

	/**
	 * Execute active button event
	 * @category activities
	 */
	public void buttonActivity_(Object[] anArray) {
		String symbol = (String) anArray[1];
		if (symbol.equals("hourDown")) {
			this.getModel().hourDown();
		}
		if (symbol.equals("hourUp")) {
			this.getModel().hourUp();
		}
		if (symbol.equals("minuteDown")) {
			this.getModel().minuteDown();
		}
		if (symbol.equals("minuteUp")) {
			this.getModel().minuteUp();
		}
		if (symbol.equals("secondDown")) {
			this.getModel().secondDown();
		}
		if (symbol.equals("secondUp")) {
			this.getModel().secondUp();
		}
	}
	
	/**
	 * Execute active button event
	 * @category activities
	 */
	public void labelActivity_(Object[] array) {
		return;
	}

	/**
	 * Execute active button event
	 * @category activities
	 */
	public void hoursActivity_(Object[] array) {
		return;
	}

	/**
	 * Execute active button event
	 * @category activities
	 */
	public void minutesActivity_(Object[] array) {
		return;
	}

	/**
	 * Execute active button event
	 * @category activities
	 */
	public void secondsActivity_(Object[] array) {
		return;
	}

	/**
	 * Execute active button event
	 * @category accessing
	 */
	public JunCalendarTimeView getView() {
		return (JunCalendarTimeView) this.view();
	}

	/**
	 * Execute active button event
	 * @category accessing
	 */
	public JunCalendarTimeModel getModel() {
		return (JunCalendarTimeModel) this.model();
	}
}
