package sra.jun.goodies.calendar;

import java.awt.Dimension;

import sra.smalltalk.StViewJPanel;

/**
 * JunCalendarTimeIntervalViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarTimeIntervalViewSwing.java,v 6.0 2003/10/28 10:52:07 nisinaka Exp $
 */
public class JunCalendarTimeIntervalViewSwing
	extends StViewJPanel
	implements JunCalendarTimeIntervalView {
	protected JunCalendarTimeViewSwing fromView;
	protected JunCalendarTimeViewSwing toView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarTimeInterval JunCalendarTimeInterval
	 * @category instance creation
	 */
	public JunCalendarTimeIntervalViewSwing(JunCalendarTimeIntervalModel aCalendarTimeIntervalModel) {
		super(aCalendarTimeIntervalModel);
	}

	/**
	 * Answer a fromView.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	public JunCalendarTimeViewSwing fromView() {
		if (fromView == null) {
			fromView =
				new JunCalendarTimeViewSwing(
					this.getModel().fromCalendarTimeModel());
		}
		return fromView;
	}

	/**
	 * Answer a toView.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	public JunCalendarTimeViewSwing toView() {
		if (toView == null) {
			toView =
				new JunCalendarTimeViewSwing(
					this.getModel().toCalendarTimeModel());
		}
		return toView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarTimeModel
	 * @category accessing
	*/
	public JunCalendarTimeIntervalModel getModel() {
		return (JunCalendarTimeIntervalModel) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 * @category accessing
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.fromView().setBounds(1, 1, 150, 200);
		this.toView().setBounds(1, 201, 150, 200);
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(null);
		this.add(this.fromView());
		this.add(this.toView());
		this.setPreferredSize(new Dimension(150, 400));
	}
}
