package sra.jun.goodies.colors;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunColorChoiceView interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/21 (by MATSUDA Ryouichi)
 *  @updated   2003/04/02 (by Mituhiro Asada)
 *  @version   406b (with StPL6.0) based on Jun490 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunColorChoiceView.java,v 6.0 2003/10/28 10:52:08 nisinaka Exp $
 */
public interface JunColorChoiceView extends StView {

	/**
	 * Answer the area of color bar.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle barArea();

	/**
	 * Answer the area of color brightness.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle brightnessArea();

	/**
	 * Answer the model's brightness string.
	 * 
	 * @return java.lang.String
	 */
	public String brightnessString();

	/**
	 * Answer the area of color plate.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle colorArea();

	/**
	 * Answer the string of a color.
	 * 
	 * @return java.lang.String
	 */
	public String colorString();

	/**
	 * model property accessing.
	 * 
	 * @return sra.jun.goodies.colors.JunColorChoiceModel
	 */
	public JunColorChoiceModel getModel();

	/**
	 * Answer the area of color hue.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle hueArea();

	/**
	 * Answer the model's brightness string.
	 * 
	 * @return java.lang.String
	 */
	public String hueString();

	/**
	 * Answer the area of plate.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle plateArea();

	/**
	 * Answer the area of saturation.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle saturationArea();

	/**
	 * Answer the model's saturation string.
	 * 
	 * @return java.lang.String
	 */
	public String saturationString();

	/**
	 * model property accessing.
	 * 
	 * @param aModel sra.jun.goodies.colors.JunColorChoiceModel
	 */
	public void setModel(JunColorChoiceModel aModel);

	/**
	 * Answer the area of squit.
	 * 
	 * @return java.awt.Rectangle
	 */
	public Rectangle spuitArea();
}
