package sra.jun.goodies.dump;

import java.awt.*;
import sra.smalltalk.StViewPanel;

/**
 * JunDumpViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2003/03/18 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun436 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDumpViewAwt.java,v 6.0 2003/10/28 10:52:09 nisinaka Exp $
 */
public class JunDumpViewAwt extends StViewPanel implements JunDumpView {

	protected TextArea textView;

	/**
	 * Create a new instance of JunDumpViewAwt and initialize it.
	 *
	 * @param aDumpModel sra.jun.goodies.dump.JunDumpModel
	 */
	public JunDumpViewAwt(JunDumpModel aDumpModel) {
		super(aDumpModel);
	}

	/**
	 * Answer my model as JunDumpModel.
	 *
	 * @return sra.jun.goodies.dump.JunDumpModel
	 */
	public JunDumpModel getDumpModel() {
		return (JunDumpModel) this.model();
	}

	/**
	 * Set the bounds of myself and my components.
	 *
	 * @param x int
	 * @param y int
	 * @param width int
	 * @param height int
	 */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);

		System.out.println(new Rectangle(x, y, width, height));
	}

	/**
	 * Answer my text view.
	 *
	 * @return java.awt.TextArea
	 */
	public TextArea textView() {
		if (textView == null) {
			textView = new TextArea((String) this.getDumpModel().textModel().value()) {
				public Dimension getPreferredSize() {
					return new Dimension(520, 250);
				}
			};
		}
		return textView;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());
		this.add(this.textView(), BorderLayout.CENTER);
		// this.setSize(520, 250);
	}
}
