package sra.jun.goodies.dump;

import java.awt.Font;
import java.awt.Dimension;
import javax.swing.JScrollPane;
import java.awt.BorderLayout;
import javax.swing.JTextArea;
import sra.smalltalk.StViewJPanel;

/**
 * JunDumpViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2003/03/18 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun436 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDumpViewSwing.java,v 6.0 2003/10/28 10:52:09 nisinaka Exp $
 */
public class JunDumpViewSwing extends StViewJPanel implements JunDumpView {

	protected JTextArea textView;

	/**
	 * Create a new instance of JunDumpViewSwing and initialize it.
	 *
	 * @param aDumpModel sra.jun.goodies.dump.JunDumpModel
	 */
	public JunDumpViewSwing(JunDumpModel aDumpModel) {
		super(aDumpModel);
	}

	/**
	 * Answer my model as JunDumpModel.
	 *
	 * @return sra.jun.goodies.dump.JunDumpModel
	 */
	public JunDumpModel getDumpModel() {
		return (JunDumpModel) this.model();
	}

	/**
	 * Answer my text view.
	 *
	 * @return javax.swing.JTextArea
	 */
	public JTextArea textView() {
		if (textView == null) {
			textView = new JTextArea((String) this.getDumpModel().textModel().value());
			textView.setFont(new Font("monospaced", Font.PLAIN, 12));
		}
		return textView;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(this.textView()), BorderLayout.CENTER);
		this.setPreferredSize(new Dimension(520, 250));
	}
}
