package sra.jun.goodies.files;

import java.io.File;
import sra.smalltalk.*;
import sra.jun.system.support.JunTestExamples;

/**
 * JunFileDialogTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2000/12/18 (by nisinaka)
 *  @updated   2003/03/09 (by nisinaka)
 *  @version   406b (with StPL6.0) based on Jun373 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFileDialogTestExamples.java,v 6.0 2003/10/28 10:52:09 nisinaka Exp $
 */
public class JunFileDialogTestExamples extends JunTestExamples {

	/**
	 * Example_RequestNewDirectory: Call Request().
	 * 
	 * @return boolean
	 */
	public static boolean Example_RequestNewDirectory() {
		File answer = JunFileDialog.RequestNewDirectory("Input a directory.", new File("Jun999"));
		System.out.println(answer);
		return true;
	}

	/**
	 * Example1: Call Request().
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		File answer = JunFileDialog.Request();
		System.out.println(answer);
		return true;
	}

	/**
	 * Example2: Request to select a file.
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		File answer = JunFileDialog.Request("Select a file.");
		System.out.println(answer);
		return true;
	}

	/**
	 * Example3: Request to select a file.
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		File answer = JunFileDialog.Request(null, new File(JunFileModel.DefaultDirectory(), "zzz.st"), null, null, null, null);
		System.out.println(answer);
		return true;
	}

	/**
	 * Example4: Request to select a file.
	 * 
	 * @return boolean
	 */
	public static boolean Example4() {
		JunFileModel.FileType[] fileTypes =
			new JunFileModel.FileType[] { JunFileModel.FileType.All("All files"), new JunFileModel.FileType("Java files", new String[] { ".java", ".JAVA" }), new JunFileModel.FileType("Text files", new String[] { ".txt", ".TXT" })
		};
		File answer = JunFileDialog.Request("Select a file.", fileTypes, fileTypes[2]);
		System.out.println(answer);
		return true;
	}

	/**
	 * Example5: Request to select a file.
	 * 
	 * @return boolean
	 */
	public static boolean Example5() {
		JunFileModel.FileType[] fileTypes =
			new JunFileModel.FileType[] { JunFileModel.FileType.All("All files"), new JunFileModel.FileType("Java files", new String[] { ".java", ".JAVA" }), new JunFileModel.FileType("Text files", new String[] { ".txt", ".TXT" })
		};
		File answer = JunFileDialog.Request("Select a file.", JunFileModel.DefaultDirectory(), "zzz.java", fileTypes, fileTypes[2], new StBlockClosure() {
			public Object value_(Object model) {
				System.out.println("Accept button was pressed.");
				System.out.println("\t" + ((JunFileModel) model).value());
				return Boolean.TRUE;
			}
		}, new StBlockClosure() {
			public Object value_(Object model) {
				System.out.println("Cancel button was pressed.");
				System.out.println("\t" + ((JunFileModel) model).value());
				return Boolean.TRUE;
			}
		});
		System.out.println(answer);
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunFileDialogTestExamples();
	}
}
