package sra.jun.goodies.font;

import java.awt.*;
import java.awt.event.*;
import sra.smalltalk.*;

/**
 * JunFontDialogViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2003/02/28 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun433 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFontDialogViewAwt.java,v 6.0 2003/10/28 10:52:09 nisinaka Exp $
 */
public class JunFontDialogViewAwt extends StSimpleDialogViewAwt implements JunFontDialogView {

	protected JunFontViewAwt fontView;
	protected Button acceptButton;
	protected Button cancelButton;

	/**
	 * Create a new instance of JunFontDialogViewAwt and initialize it with the JunFontDialog.
	 *
	 * @param newFontDialog sra.jun.goodies.font.JunFontDialog
	 */
	public JunFontDialogViewAwt(JunFontDialog newFontDialog) {
		super(newFontDialog);
	}

	/**
	 * Answer my model as a JunFontDialog.
	 *
	 * @return sra.jun.goodies.font.JunFontDialog
	 */
	public JunFontDialog getFontDialog() {
		return (JunFontDialog) this.model();
	}

	/**
	 * Answer my accpet button.
	 *
	 * @return java.awt.Button
	 */
	protected Button acceptButton() {
		if (acceptButton == null) {
			acceptButton = new Button("Accept");
			acceptButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getFontDialog().acceptButtonPressed()) {
						getFontDialog().accept().value_(true);
					}
				}
			});
		}
		return acceptButton;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fontView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -50));
		this.add(this.acceptButton(), WindowSpecLayout.Position(0.3f, -44, 1f, -40, 0.3f, 44, 1f, -8));
		this.add(this.cancelButton(), WindowSpecLayout.Position(0.7f, -44, 1f, -40, 0.7f, 44, 1f, -8));
		this.setSize(350, 250);

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my cancel button.
	 *
	 * @return java.awt.Button
	 */
	protected Button cancelButton() {
		if (cancelButton == null) {
			cancelButton = new Button("Cancel");
			cancelButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getFontDialog().cancelButtonPressed()) {
						getFontDialog().cancel().value_(true);
					}
				}
			});
		}
		return cancelButton;
	}

	/**
	 * Answer my font view.
	 *
	 * @return sra.jun.goodies.font.JunFontViewAwt
	 */
	protected JunFontViewAwt fontView() {
		if (fontView == null) {
			fontView = new JunFontViewAwt(this.getFontDialog().fontModel());
		}
		return fontView;
	}
}
