package sra.jun.goodies.gauge;

import java.awt.*;
import sra.smalltalk.*;
import sra.jun.goodies.track.JunSimpleSliderViewAwt;

/**
 * JunSimpleGaugeViewAwt class
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/28 (by Hoshi Takanori)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun433 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSimpleGaugeViewAwt.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public class JunSimpleGaugeViewAwt extends StViewPanel implements JunSimpleGaugeView {

	protected Label valueView;
	protected JunSimpleSliderViewAwt sliderView;

	/**
	 * Create a new instance of JunSimpleGaugeViewAwt and initialize it.
	 *
	 * @param aSimpleGaugeModel sra.jun.goodies.gauge.JunSimpleGaugeViewAwt
	 */
	public JunSimpleGaugeViewAwt(JunSimpleGaugeModel aSimpleGaugeModel) {
		super(aSimpleGaugeModel);
	}

	/**
	 * Answer my model as JunSimpleGaugeModel.
	 *
	 * @return sra.jun.goodies.gauge.JunSimpleGaugeModel
	 */
	public JunSimpleGaugeModel getSimpleGaugeModel() {
		return (JunSimpleGaugeModel) this.model();
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.valueView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -20));
		this.add(this.sliderView(), WindowSpecLayout.Position(0f, 1, 1f, -19, 1f, -1, 1f, -1));
		this.setSize(124, 45);

		// postBuildWith:
		this.updateValueView();
	}

	/**
	 * Answer the slider view.
	 *
	 * @return sra.jun.goodies.track.JunSimpleSliderViewAwt
	 */
	protected JunSimpleSliderViewAwt sliderView() {
		if (sliderView == null) {
			sliderView = new JunSimpleSliderViewAwt(this.getSimpleGaugeModel().simpleSlider());
		}
		return sliderView;
	}

	/**
	 * Answer the value view.
	 *
	 * @return java.awt.Label
	 */
	protected Label valueView() {
		if (valueView == null) {
			valueView = new Label();
			valueView.setAlignment(Label.CENTER);
		}
		return valueView;
	}

	/**
	 * Action for the update notification.
	 * 
	 * @param evt sra.smalltalk.DependentEvent
	 */
	public void update_(DependentEvent evt) {
		StSymbol aSymbol = evt.getAspect();
		if (aSymbol == $("value")) {
			this.updateValueView();
		} else {
			super.update_(evt);
		}
	}

	/**
	 * Update the value view.
	 */
	public void updateValueView() {
		this.valueView().setText(this.getSimpleGaugeModel().valueString());
	}
}
