package sra.jun.goodies.images.streams;

import java.io.*;

/**
 * JunBmpImageStream class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/01/20 (by Hirotsugu Kondo)
 *  @updated   2000/11/12 (by Mitsuhiro Asada)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBmpImageStream.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public abstract class JunBmpImageStream extends JunImageStream {
	/**
	 * Constractor with input stream.
	 * 
	 * @return sra.jun.goodies.images.streams.JunImageStream
	 * @param stream java.io.InputStream
	 * @exception java.io.IOException
	 * @category Instance creation
	 */
	public static JunImageStream On_(InputStream stream) throws IOException {
		return On_(_CreateImageStream(), stream);
	}

	/**
	 * Constractor with output stream.
	 * 
	 * @return sra.jun.goodies.images.streams.JunImageStream
	 * @param stream java.io.OutputStream
	 * @exception java.io.IOException
	 * @category Instance creation
	 */
	public static JunImageStream On_(OutputStream stream) throws IOException {
		return On_(_CreateImageStream(), stream);
	}

	/**
	 * Answer an instance of bmp image stream.
	 * 
	 * @return sra.jun.goodies.images.streams.IsrImageStream
	 * @category Instance creation
	 */
	protected static JunImageStream _CreateImageStream() {
		JunImageStream imageStream = null;
		try {
			Class.forName("com.sun.media.jai.codec.ImageCodec");
			imageStream = (JunImageStream) Class.forName("sra.jun.goodies.images.streams.JunJaiBmpImageStream").newInstance();
		} catch (Throwable e) {
			try {
				Class.forName("com.sun.jimi.core.Jimi");
				imageStream = (JunImageStream) Class.forName("sra.jun.goodies.images.streams.JunJimiBmpImageStream").newInstance();
			} catch (Throwable ex) {
				try {
					imageStream = new JunSraBmpImageStream();
				} catch (Throwable exception) {
				}
			}
		}
		return imageStream;
	}
}
