package sra.jun.goodies.images.streams;

import java.io.*;

/**
 * JunPngImageStream class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2000/11/16 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPngImageStream.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public abstract class JunPngImageStream extends JunImageStream {
	/**
	 * Constractor with input stream.
	 * 
	 * @return sra.jun.goodies.images.streams.JunImageStream
	 * @param stream java.io.InputStream
	 * @exception java.io.IOException
	 * @category Instance creation
	 */
	public static JunImageStream On_(InputStream stream) throws IOException {
		return On_(_CreateImageStream(), stream);
	}

	/**
	 * Constractor with output stream.
	 * 
	 * @return sra.jun.goodies.images.streams.JunImageStream
	 * @param stream java.io.OutputStream
	 * @exception java.io.IOException
	 * @category Instance creation
	 */
	public static JunImageStream On_(OutputStream stream) throws IOException {
		return On_(_CreateImageStream(), stream);
	}

	/**
	 * Answer an instance of png image stream.
	 * 
	 * @return sra.jun.goodies.images.streams.JunImageStream
	 * @category Instance creation
	 */
	protected static JunImageStream _CreateImageStream() {
		JunImageStream imageStream = null;
		try {
			Class.forName("com.sun.media.jai.codec.ImageCodec");
			imageStream = (JunImageStream) Class.forName("sra.jun.goodies.images.streams.JunJaiPngImageStream").newInstance();
		} catch (Throwable e) {
			try {
				Class.forName("com.sun.jimi.core.Jimi");
				imageStream = (JunImageStream) Class.forName("sra.jun.goodies.images.streams.JunJimiPngImageStream").newInstance();
			} catch (Exception ex) {
			}
		}
		return imageStream;
	}
}
