package sra.jun.goodies.images.support;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunImageToAsciiViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2000/12/13 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunImageToAsciiViewAwt.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public class JunImageToAsciiViewAwt extends StViewPanel implements JunImageToAsciiView {

	protected TextArea textArea;

	/**
	 * Create a new instance of JunImageToAsciiViewAwt and initialize it.
	 *
	 * @param anImageToAscii sra.jun.goodies.images.support.JunImageToAscii
	 */
	public JunImageToAsciiViewAwt(JunImageToAscii anImageToAscii) {
		super(anImageToAscii);
	}

	/**
	 * Answer my model as JunImageToAscii.
	 *
	 * @return sra.jun.goodies.images.support.JunImageToAscii
	 */
	public JunImageToAscii getImageToAscii() {
		return (JunImageToAscii) this.model();
	}

	/**
	 * Receive a change notice from an object of whom the receiver is a dependent.
	 * 
	 * @param evt sra.smalltalk.DependentEvent
	 */
	public void update_(DependentEvent evt) {
		if (evt.getAspect() == $("cursor")) {
			this.getTextArea().setCursor(this.getImageToAscii()._getCursor());
			return;
		} else if (evt.getAspect() == $("text")) {
			this.getTextArea().setText(this.getImageToAscii()._getText());
			return;
		}

		super.update_(evt);
	}

	/**
	 * Build the component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());
		this.add(this.getTextArea(), BorderLayout.CENTER);
	}

	/**
	 * Answer a default model.
	 * 
	 * @return sra.smalltalk.StModel
	 */
	protected StModel defaultModel() {
		return new JunImageToAscii();
	}

	/**
	 * Answer the text area.
	 * 
	 * @return java.awt.TextArea
	 */
	protected TextArea getTextArea() {
		if (textArea == null) {
			textArea = new TextArea("", 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY) {
				public Dimension getPreferredSize() {
					return new Dimension(600, 400);
				}
			};

			textArea.setFont(JunImageToAscii.Font());
		}

		return textArea;
	}
}
