package sra.jun.goodies.images.support;

import java.awt.*;
import javax.swing.*;
import sra.smalltalk.*;

/**
 * JunImageToAsciiViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2001/04/13 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunImageToAsciiViewSwing.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public class JunImageToAsciiViewSwing extends StViewJPanel implements JunImageToAsciiView {

	protected JTextArea textArea;

	/**
	 * Create a new instance of JunImageToAsciiViewSwing and initialize it.
	 *
	 * @param anImageToAscii sra.jun.goodies.images.support.JunImageToAscii
	 */
	public JunImageToAsciiViewSwing(JunImageToAscii anImageToAscii) {
		super(anImageToAscii);
	}

	/**
	 * Answer my model as JunImageToAscii.
	 *
	 * @return sra.jun.goodies.images.support.JunImageToAscii
	 */
	public JunImageToAscii getImageToAscii() {
		return (JunImageToAscii) this.model();
	}

	/**
	 * Receive a change notice from an object of whom the receiver is a dependent.
	 * 
	 * @param evt sra.smalltalk.DependentEvent
	 */
	public void update_(DependentEvent evt) {
		if (evt.getAspect() == $("cursor")) {
			this.getTextArea().setCursor(this.getImageToAscii()._getCursor());
			return;
		} else if (evt.getAspect() == $("text")) {
			this.getTextArea().setText(this.getImageToAscii()._getText());
			return;
		}

		super.update_(evt);
	}

	/**
	 * Build the component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());

		JScrollPane scrollPane = new JScrollPane(this.getTextArea());
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane.setPreferredSize(new Dimension(600, 400));
		this.add(scrollPane, BorderLayout.CENTER);
	}

	/**
	 * Answer a default model.
	 * 
	 * @return sra.smalltalk.StModel
	 */
	protected StModel defaultModel() {
		return new JunImageToAscii();
	}

	/**
	 * Answer the text area.
	 * 
	 * @return javax.swing.JTextArea
	 */
	protected JTextArea getTextArea() {
		if (textArea == null) {
			textArea = new JTextArea();
			textArea.setFont(JunImageToAscii.Font());
		}

		return textArea;
	}
}
