package sra.jun.goodies.milliseconds;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JButton;
import sra.smalltalk.*;

/**
 * JunMillisecondDialogViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2003/05/28 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun433 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMillisecondDialogViewSwing.java,v 6.0 2003/10/28 10:52:11 nisinaka Exp $
 */
public class JunMillisecondDialogViewSwing extends StSimpleDialogViewSwing implements JunMillisecondDialogView {

	protected JunMillisecondViewSwing millisecondView;
	protected JButton acceptButton;
	protected JButton cancelButton;

	/**
	 * Create a new instance of JunMillisecondDialogViewSwing and initialize it.
	 *
	 * @param aMillisecondDialog sra.jun.goodies.milliseconds.JunMillisecondDialog
	 */
	public JunMillisecondDialogViewSwing(JunMillisecondDialog aMillisecondDialog) {
		super(aMillisecondDialog);
	}

	/**
	 * Answer my model as a JunMillisecondDialog.
	 *
	 * @return sra.jun.goodies.milliseconds.JunMillisecondDialog
	 */
	public JunMillisecondDialog getMillisecondDialog() {
		return (JunMillisecondDialog) this.model();
	}

	/**
	 * Answer my accpet button.
	 *
	 * @return javax.swing.JButton
	 */
	protected JButton acceptButton() {
		if (acceptButton == null) {
			acceptButton = new JButton("Accept");
			acceptButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getMillisecondDialog().acceptButtonPressed()) {
						getMillisecondDialog().accept().value_(true);
					}
				}
			});
		}
		return acceptButton;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.millisecondView()._onBorderedPanel(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -102, 1f, -1));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.setPreferredSize(new Dimension(250, 100));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my cancel button.
	 *
	 * @return javax.swing.JButton
	 */
	protected JButton cancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton("Cancel");
			cancelButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (getMillisecondDialog().cancelButtonPressed()) {
						getMillisecondDialog().cancel().value_(true);
					}
				}
			});
		}
		return cancelButton;
	}

	/**
	 * Answer my millisecond view.
	 *
	 * @return sra.jun.goodies.milliseconds.JunMillisecondViewSwing
	 */
	protected JunMillisecondViewSwing millisecondView() {
		if (millisecondView == null) {
			millisecondView = new JunMillisecondViewSwing(this.getMillisecondDialog().millisecondModel());
		}
		return millisecondView;
	}
}
