package sra.jun.goodies.movie;

import sra.smalltalk.StView;

/**
 * JunMovieView interface
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2001/01/24 (by NISHIHARA Satoshi)
 *  @updated   2003/03/24 (by nisinaka)
 *  @version   406b (with StPL6.0) based on Jun490 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMovieView.java,v 6.0 2003/10/28 10:52:12 nisinaka Exp $
 */
public interface JunMovieView extends StView {

	/**
	 * Answer my model as a JunMoviePlayer.
	 * 
	 * @return sra.jun.goodies.movie.JunMoviePlayer
	 */
	public JunMoviePlayer getMoviePlayer();

	/**
	 * Ansewr true if the view has a movie, otherwise false.
	 * 
	 * @return boolean
	 */
	public boolean hasMovie();

	/**
	 * Ansewr true if the view has a tracker, otherwise false.
	 * 
	 * @return boolean
	 */
	public boolean hasTracker();

	/**
	 * Ansewr true if the view has a second tracker, otherwise false.
	 * 
	 * @return boolean
	 */
	public boolean hasTracker2();

	/**
	 * Answer my movie handle.
	 * 
	 * @return sra.jun.goodies.JunMovieHandle
	 */
	public JunMovieHandle movieHandle();

	/**
	 * Set the movie view.
	 */
	public void setMovieView();
}
