package sra.jun.goodies.multimedia;

import java.io.File;
import sra.jun.goodies.files.*;
import sra.jun.system.support.JunSystem;

/**
 * JunMultiMediaMovieModelTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2003/03/20 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun490 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMultiMediaMovieModelTestExamples.java,v 6.0 2003/10/28 10:52:12 nisinaka Exp $
 */
public class JunMultiMediaMovieModelTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Example1: Open a JunMultiMediaViewer.
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunFileModel.FileType[] fileTypes =
			new JunFileModel.FileType[] { new JunFileModel.FileType("Movie files", JunSystem.DefaultMovieExtensionPatterns()), new JunFileModel.FileType("Sound files", JunSystem.DefaultSoundExtensionPatterns()), JunFileModel.FileType.All("All files")};
		File aFile = JunFileDialog.Request("Select a movie file.", fileTypes, fileTypes[0]);
		if (aFile == null) {
			return false;
		}

		JunMultiMediaMovieModel movieModel = new JunMultiMediaMovieModel(aFile);
		movieModel.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunMultiMediaMovieModelTestExamples();
	}
}
