package sra.jun.goodies.multimedia;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunMultiMediaTextViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2003/03/18 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun490 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMultiMediaTextViewAwt.java,v 6.0 2003/10/28 10:52:12 nisinaka Exp $
 */
public class JunMultiMediaTextViewAwt extends StViewPanel implements JunMultiMediaTextView {
	protected TextArea textArea;

	/**
	 * Create a new instance of JunMultiMediaTextViewAwt and initialize it.
	 *
	 * @param aMultiMediaTextModel sra.jun.goodies.multimedia.JunMultiMediaTextModel
	 */
	public JunMultiMediaTextViewAwt(JunMultiMediaTextModel aMultiMediaTextModel) {
		super(aMultiMediaTextModel);
	}

	/**
	 * Answer my model as JunMultiMediaTextModel.
	 *
	 * @return sra.jun.goodies.multimedia.JunMultiMediaTextModel
	 */
	public JunMultiMediaTextModel getTextModel() {
		return (JunMultiMediaTextModel) this.model();
	}

	/**
	 * Answer my text area.
	 *
	 * @return java.awt.TextArea
	 */
	public TextArea textArea() {
		if (textArea == null) {
			textArea = new TextArea((String) this.getTextModel().textHolder().value()) {
				public Dimension getPreferredSize() {
					return new Dimension(200, 150);
				}
			};
			textArea.setEditable(false);

			this.getTextModel().textHolder().compute_(new StBlockClosure() {
				public Object value_(Object newValue) {
					textArea.setText((String) newValue);
					return null;
				}
			});
		}
		return textArea;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());
		this.add(this.textArea(), BorderLayout.CENTER);
		// this.setSize(200, 150);
	}
}
