package sra.jun.goodies.multimedia;

import java.awt.*;
import javax.swing.*;
import sra.smalltalk.*;

/**
 * JunMultiMediaTextViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2003/03/19 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun490 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMultiMediaTextViewSwing.java,v 6.0 2003/10/28 10:52:12 nisinaka Exp $
 */
public class JunMultiMediaTextViewSwing extends StViewJPanel implements JunMultiMediaTextView {

	protected JTextArea textArea;

	/**
	 * Create a new instance of JunMultiMediaTextViewSwing and initialize it.
	 *
	 * @param aMultiMediaTextModel sra.jun.goodies.multimedia.JunMultiMediaTextModel
	 */
	public JunMultiMediaTextViewSwing(JunMultiMediaTextModel aMultiMediaTextModel) {
		super(aMultiMediaTextModel);
	}

	/**
	 * Answer my model as JunMultiMediaTextModel.
	 *
	 * @return sra.jun.goodies.multimedia.JunMultiMediaTextModel
	 */
	public JunMultiMediaTextModel getTextModel() {
		return (JunMultiMediaTextModel) this.model();
	}

	/**
	 * Answer my text area.
	 *
	 * @return javax.swing.JTextArea
	 */
	public JTextArea textArea() {
		if (textArea == null) {
			textArea = new JTextArea((String) this.getTextModel().textHolder().value());
			textArea.setFont(new Font("monospaced", Font.PLAIN, 12));
			textArea.setEditable(false);

			this.getTextModel().textHolder().compute_(new StBlockClosure() {
				public Object value_(Object newValue) {
					textArea.setText((String) newValue);
					return null;
				}
			});
		}
		return textArea;
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());
		this.add(new JScrollPane(this.textArea()), BorderLayout.CENTER);
		this.setPreferredSize(new Dimension(200, 150));
	}
}
