package sra.jun.goodies.sound;

import java.awt.Dimension;
import sra.smalltalk.*;

/**
 * JunSoundMeterViewSwing class
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/29 (by Hoshi Takanori)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun433 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSoundMeterViewSwing.java,v 6.0 2003/10/28 10:52:14 nisinaka Exp $
 */
public class JunSoundMeterViewSwing extends StViewJPanel implements JunSoundMeterView {

	protected JunSoundLevelMeterViewSwing soundLevelMeterView;
	protected JunSoundWaveMeterViewSwing soundWaveMeterView;

	/**
	 * Create a new instance of JunSoundMeterViewSwing and initialize it.
	 *
	 * @param aSoundMeterModel sra.jun.goodies.sound.JunSoundMeterModel
	 */
	public JunSoundMeterViewSwing(JunSoundMeterModel aSoundMeterModel) {
		super(aSoundMeterModel);
	}

	/**
	 * Answer my model as JunSoundMeterModel.
	 *
	 * @return sra.jun.goodies.sound.JunSoundMeterModel
	 */
	public JunSoundMeterModel getSoundMeterModel() {
		return (JunSoundMeterModel) this.model();
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.soundWaveMeterView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -11));
		this.add(this.soundLevelMeterView(), WindowSpecLayout.Position(0f, 1, 1f, -10, 1f, -1, 1f, -1));
		this.setPreferredSize(new Dimension(500, 64));
	}

	/**
	 * Answer the sound level meter view.
	 *
	 * @return sra.jun.goodies.sound.JunSoundLevelMeterViewSwing
	 */
	protected JunSoundLevelMeterViewSwing soundLevelMeterView() {
		if (soundLevelMeterView == null) {
			soundLevelMeterView = new JunSoundLevelMeterViewSwing(this.getSoundMeterModel());
		}
		return soundLevelMeterView;
	}

	/**
	 * Answer the sound wave meter view.
	 *
	 * @return sra.jun.goodies.sound.JunSoundWaveMeterViewSwing
	 */
	protected JunSoundWaveMeterViewSwing soundWaveMeterView() {
		if (soundWaveMeterView == null) {
			soundWaveMeterView = new JunSoundWaveMeterViewSwing(this.getSoundMeterModel());
		}
		return soundWaveMeterView;
	}
}
