package sra.jun.goodies.track;

import sra.smalltalk.StBlockClosure;

/**
 * JunTrackerModelTestExamples class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1998/11/24 (by MATSUDA Ryouichi)
 *  @updated   2002/10/27 (by nisinaka)
 *  @updated   2003/03/24 (by nisinaka)
 *  @version   406b (with StPL6.0) based on Jun472 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTrackerModelTestExamples.java,v 6.0 2003/10/28 10:52:14 nisinaka Exp $
 */
public class JunTrackerModelTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Example1.
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.open();

		return true;
	}

	/**
	 * Example2.
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.loop();
		tracker.open();

		return true;
	}

	/**
	 * Example3.
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.backAndForth();
		tracker.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunTrackerModelTestExamples();
	}
}
