package sra.jun.goodies.utilities;

import java.util.*;
import sra.smalltalk.*;

/**
 * JunStringUtility class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/05/27 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun500 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunStringUtility.java,v 6.0 2003/10/28 10:52:14 nisinaka Exp $
 */
public class JunStringUtility {

	/**
	 * Answer separated strings.
	 *
	 * @return java.lang.String[]
	 * @param separateCollection java.lang.String
	 * @param dividerCollection char[]
	 */
	public static String[] Separate_dividers_(String separateCollection, char[] dividerCollection) {
		Vector indexCollection = new Vector();
		indexCollection.add(new Integer(-1));
		for (int index = 0; index < separateCollection.length(); index++) {
			char each = separateCollection.charAt(index);
			for (int j = 0; j < dividerCollection.length; j++) {
				if (dividerCollection[j] == each) {
					indexCollection.add(new Integer(index));
				}
			}
		}
		indexCollection.add(new Integer(separateCollection.length()));

		Vector intervalCollection = new Vector();
		for (int i = 0; i < indexCollection.size() - 1; i++) {
			int s = ((Integer) indexCollection.get(i)).intValue();
			int e = ((Integer) indexCollection.get(i + 1)).intValue();
			intervalCollection.add(new StInterval(s + 1, e - 1));
		}

		Vector result = new Vector();
		for (int i = 0; i < intervalCollection.size(); i++) {
			StInterval interval = (StInterval) intervalCollection.get(i);
			if (interval.size() > 0) {
				String part = separateCollection.substring((int) interval.first(), (int) interval.last() + 1);
				result.add(part);
			}
		}

		String[] strings = new String[result.size()];
		result.copyInto(strings);
		return strings;
	}

	/**
	 * Answer the separator charactors.
	 *
	 * @return char[]
	 */
	public static char[] Separators() {
		char[] separators = new char[5];
		separators[0] = ' ';
		separators[1] = '\t';
		separators[2] = '\r';
		separators[3] = '\f';
		separators[4] = '\n';
		return separators;
	}
}
