package sra.jun.goodies.wheels;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunThumbWheelViewSwing class
 * 
 *  @author    He Weijie
 *  @created   1998/10/23 (by He Weijie)
 *  @updated   1999/12/17 (by MATSUDA Ryouichi)
 *  @updated   2000/11/16 (by Mitsuhiro Asada)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunThumbWheelViewSwing.java,v 6.0 2003/10/28 10:52:14 nisinaka Exp $
 */
public class JunThumbWheelViewSwing extends StViewJPanel implements JunThumbWheelView {
	//
	protected static Image ThumbWheelImage1;
	protected static Image ThumbWheelImage2;
	protected static Image ThumbWheelImage3;
	protected static Image ThumbWheelImage4;
	protected static Image ThumbWheelImage5;
	protected static Image ThumbWheelImage6;
	protected static Image ThumbWheelImage7;
	protected static Image ThumbWheelImage8;
	protected Image[] thumbWheelImages;
	protected int currentIndex;
	protected boolean isVertical;

	/**
	 * Create a new instance of JunThumbWheelViewSwing and initialize it.
	 * 
	 * @param newThumbWheel
	 */
	public JunThumbWheelViewSwing(JunThumbWheel newThumbWheel) {
		super(newThumbWheel);
	}

	/**
	 * Create a new instance of JunThumbWheelViewSwing and initialize it.
	 *
	 * @param newThumbWheel sra.jun.goodies.wheels.JunThumbWheel
	 * @param isVertical boolean
	 */
	public JunThumbWheelViewSwing(JunThumbWheel newThumbWheel, boolean isVertical) {
		super(newThumbWheel);
		this.setVertical(isVertical);
	}

	/**
	 * create verticalThumbWheelImages
	 * 
	 * @return java.awt.Image[]
	 */
	private static Image[] _HorizontalThumbWheelImages() {
		return new Image[] { _ThumbWheelImage1(), _ThumbWheelImage2(), _ThumbWheelImage3(), _ThumbWheelImage4()};
	}

	/**
	 * create thumbWheelImage1
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage1() {
		if (ThumbWheelImage1 == null) {
			ThumbWheelImage1 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage1.jpg");
		}

		return ThumbWheelImage1;
	}

	/**
	 * create thumbWheelImage2
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage2() {
		if (ThumbWheelImage2 == null) {
			ThumbWheelImage2 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage2.jpg");
		}

		return ThumbWheelImage2;
	}

	/**
	 * create thumbWheelImage3
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage3() {
		if (ThumbWheelImage3 == null) {
			ThumbWheelImage3 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage3.jpg");
		}

		return ThumbWheelImage3;
	}

	/**
	 * create thumbWheelImage4
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage4() {
		if (ThumbWheelImage4 == null) {
			ThumbWheelImage4 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage4.jpg");
		}

		return ThumbWheelImage4;
	}

	/**
	 * create thumbWheelImage5
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage5() {
		if (ThumbWheelImage5 == null) {
			ThumbWheelImage5 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage5.jpg");
		}

		return ThumbWheelImage5;
	}

	/**
	 * create thumbWheelImage6
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage6() {
		if (ThumbWheelImage6 == null) {
			ThumbWheelImage6 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage6.jpg");
		}

		return ThumbWheelImage6;
	}

	/**
	 * create thumbWheelImage7
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage7() {
		if (ThumbWheelImage7 == null) {
			ThumbWheelImage7 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage7.jpg");
		}

		return ThumbWheelImage7;
	}

	/**
	 * create thumbWheelImage8
	 * 
	 * @return java.awt.Image
	 */
	private static Image _ThumbWheelImage8() {
		if (ThumbWheelImage8 == null) {
			ThumbWheelImage8 = SystemResourceSupport.createImage("/sra/jun/goodies/wheels/ThumbWheelImage8.jpg");
		}

		return ThumbWheelImage8;
	}

	/**
	 * create verticalThumbWheelImages
	 * 
	 * @return java.awt.Image[]
	 */
	private static Image[] _VerticalThumbWheelImages() {
		return new Image[] { _ThumbWheelImage5(), _ThumbWheelImage6(), _ThumbWheelImage7(), _ThumbWheelImage8()};
	}

	/**
	 * Update the view.
	 * 
	 * @param aGraphics java.awt.Graphics
	 */
	public void displayOn_(Graphics aGraphics) {
		Rectangle box;
		Rectangle area = this.thumbWheelArea();

		if ((area.width == 0) || (area.height == 0)) {
			return;
		}

		if (this.isVertical()) {
			box = new Rectangle(area.x - 3, area.y - 6, area.width + 6, area.height + 12);
		} else {
			box = new Rectangle(area.x - 6, area.y - 3, area.width + 12, area.height + 6);
		}

		aGraphics.clipRect(box.x, box.y, box.width, box.height);
		aGraphics.setColor(new Color(76, 76, 76));
		aGraphics.fillRect(box.x, box.y, box.width, box.height);
		aGraphics.setColor(Color.black);
		aGraphics.drawRect(box.x + 2, box.y + 2, box.width - 4, box.height - 4);
		aGraphics.setColor(new Color(178, 178, 178));
		aGraphics.drawRect(box.x + 1, box.y + 1, box.width - 2, box.height - 2);
		this.displayCurrentImageOn_(aGraphics);
	}

	/**
	 * model property.
	 * 
	 * @return sra.jun.goodies.wheels.JunThumbWheel
	 */
	public JunThumbWheel getModel() {
		return (JunThumbWheel) model();
	}

	/**
	 * Answer ture if it is a Horzontal wheel.
	 * 
	 * @return boolean
	 */
	public boolean isHorizontal() {
		return !isVertical();
	}

	/**
	 * Vertical property.
	 * 
	 * @return boolean
	 */
	public boolean isVertical() {
		return isVertical;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param deltaPoint java.awt.Point
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public void rotateDelta_(Point deltaPoint) {
		double radius;
		int diameter;
		double angle;

		if (this.isVertical()) {
			radius = diameter = this.currentImage().getHeight(null) / 2;

			if (deltaPoint.y > diameter) {
				deltaPoint.y = diameter;
			}

			angle = (double) (Math.atan(deltaPoint.y / radius) / Math.PI * 180);
		} else {
			radius = diameter = this.currentImage().getWidth(null) / 2;

			if (deltaPoint.x > diameter) {
				deltaPoint.x = diameter;
			}

			angle = (double) (Math.atan(deltaPoint.x / radius) / Math.PI * 180);
		}

		if (angle == 0) {
			return;
		}

		if (this.model().respondsTo_("angularValue")) {
			try {
				this.model().perform_with_("angularValue_", new Double(angle));
			} catch (Exception e) {
				throw new SmalltalkException(e);
			}
		} else {
			this.update_(new DependentEvent(this, $("value"), new Double(angle)));
		}
	}

	/**
	 * model property accessing
	 * 
	 * @param aModel sra.jun.goodies.wheels.JunThumbWheel
	 */
	public void setModel(JunThumbWheel aModel) {
		this.model_(aModel);
	}

	/**
	 * Vertical property.
	 * 
	 * @param aBoolean boolean
	 */
	public void setVertical(boolean aBoolean) {
		Dimension size = this.vertical_(aBoolean);
		setPreferredSize(size);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param evt sra.smalltalk.DependentEvent
	 */
	public void update_(DependentEvent evt) {
		if (evt.getAspect() == $("value")) {
			this.updateValue_(((Number) evt.getParameter()).doubleValue());
		}
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		setVertical(false);
	}

	/**
	 * Return the current Image.
	 * 
	 * @return java.awt.Image
	 */
	protected Image currentImage() {
		return thumbWheelImages()[currentIndex()];
	}

	/**
	 * Return the current Index.
	 * 
	 * @return int
	 */
	protected int currentIndex() {
		return currentIndex;
	}

	/**
	 * Decrease the current Index.
	 * 
	 * @return int
	 */
	protected int decreaseIndex() {
		if (currentIndex <= 0) {
			currentIndex = this.thumbWheelImages().length - 1;
		} else {
			currentIndex--;
		}

		return currentIndex;
	}

	/**
	 * Answer my default controller.
	 * 
	 * @return sra.smalltalk.StController
	 */
	protected StController defaultController() {
		return new JunThumbWheelController();
	}

	/**
	 * Answer a default model.
	 * 
	 * @return sra.smalltalk.StModel
	 */
	protected StModel defaultModel() {
		return new JunThumbWheel();
	}

	/**
	 * Display an current image on a graphics.
	 * 
	 * @param aGraphics java.awt.Graphics
	 */
	protected void displayCurrentImageOn_(Graphics aGraphics) {
		Rectangle area = this.thumbWheelArea();
		aGraphics.clipRect(area.x, area.y, area.width, area.height);
		aGraphics.drawImage(this.currentImage(), area.x, area.y, null);
	}

	/**
	 * Increase the current Index.
	 * 
	 * @return int
	 */
	protected int increaseIndex() {
		if (currentIndex >= (this.thumbWheelImages().length - 1)) {
			currentIndex = 0;
		} else {
			currentIndex++;
		}

		return currentIndex;
	}

	/**
	 * Answer wheel area.
	 * 
	 * @return java.awt.Rectangle
	 */
	protected Rectangle thumbWheelArea() {
		Image image = this.currentImage();
		int imageWidth = image.getWidth(null);
		int imageHeight = image.getHeight(null);
		Dimension size = this.getSize();
		Rectangle bounds = new Rectangle(0, 0, size.width, size.height);
		int x = bounds.x + ((bounds.width - imageWidth) / 2);
		int y = bounds.y + ((bounds.height - imageHeight) / 2);

		return new Rectangle(x, y, imageWidth, imageHeight);
	}

	/**
	 * Answer the Vector which is stored the wheel images.
	 * 
	 * @return java.awt.Image[]
	 */
	protected Image[] thumbWheelImages() {
		if (thumbWheelImages == null) {
			if (this.isVertical()) {
				thumbWheelImages = _VerticalThumbWheelImages();
			} else {
				thumbWheelImages = _HorizontalThumbWheelImages();
			}
		}

		return thumbWheelImages;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param anglevalue double
	 */
	protected void updateValue_(double anglevalue) {
		Graphics gc = this.getGraphics();
		int times = ((int) Math.abs(anglevalue) / 10) + 1;

		if (anglevalue > 0) {
			for (int i = 0; i < times; i++) {
				this.increaseIndex();
				this.displayCurrentImageOn_(gc);
			}
		} else {
			for (int i = 0; i < times; i++) {
				this.decreaseIndex();
				this.displayCurrentImageOn_(gc);
			}
		}

		gc.dispose();
	}

	/**
	 * vertical property accessing
	 * 
	 * @param aBoolean boolean
	 * 
	 * @return java.awt.Dimension
	 */
	protected Dimension vertical_(boolean aBoolean) {
		isVertical = aBoolean;
		thumbWheelImages = null;

		Rectangle box = this.thumbWheelArea();

		if (isVertical) {
			box = new Rectangle(box.x - 3, box.y - 6, box.width + 6, box.height + 12);
		} else {
			box = new Rectangle(box.x - 6, box.y - 3, box.width + 12, box.height + 6);
		}

		return new Dimension(box.width, box.height);
	}
}
