package sra.jun.metaball.abstracts;

import sra.jun.csg.atoms.*;
import sra.jun.geometry.basic.*;
import sra.jun.geometry.transformations.*;
import sra.jun.metaball.atoms.*;
import sra.jun.metaball.solid.*;
import sra.smalltalk.*;

/**
 * JunMetaball class
 * 
 *  @author    nishihara
 *  @created   1999/11/05 (by nishihara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMetaball.java,v 6.0 2003/10/28 10:52:16 nisinaka Exp $
 */
public abstract class JunMetaball extends StObject {

	/**
	 * Answer the JunTransformedMetaball which is applied the specified
	 * transformation.
	 * 
	 * @param aNumber
	 * 
	 * @return aJunSolidCSG sra.jun.metaball.solid.JunMetaballSolid
	 */
	public JunSolidCSG asCSGSolidThreshold_(double aNumber) {
		return (JunMetaballSolid.With_threshold_(this, aNumber)).asCSGSolid();
	}

	/**
	 * Answer the JunTransformedMetaball which is applied the specified
	 * transformation.
	 * 
	 * @param aJun3dTransformation
	 * 
	 * @return sra.jun.metaball.solid.JunTransformedMetaball
	 */
	public JunTransformedMetaball transform_(Jun3dTransformation aJun3dTransformation) {
		return JunTransformedMetaball.On_transform_(this, aJun3dTransformation);
	}

	/**
	 * All subclasses must implement distance_(Jun3dPoint aJun3dPoint). Answer
	 * a value at the specified point.
	 * 
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		throw SmalltalkException.SubclassResponsibility();
	}
}
