package sra.jun.metaball.atoms;

import sra.jun.geometry.basic.*;
import sra.jun.metaball.abstracts.*;
import sra.smalltalk.*;

/**
 * JunBlockMetaball class
 * 
 *  @author    nishihara
 *  @created   1999/11/05 (by nishihara)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBlockMetaball.java,v 6.0 2003/10/28 10:52:16 nisinaka Exp $
 */
public class JunBlockMetaball extends JunMetaball {
	/** block. */
	protected StBlockClosure block = null;

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return ((Number) block.value_(aJun3dPoint)).doubleValue();
	}

	/**
	 * Answer the block.
	 * 
	 * @return sra.smalltalk.StBlockClosure
	 */
	StBlockClosure block() {
		return this.block;
	}

	/**
	 * Set the block.
	 * 
	 * @param valueBlock
	 */
	void block_(StBlockClosure valueBlock) {
		this.block = valueBlock;
	}
}
