package sra.jun.opengl.chart;

import java.awt.Color;
import sra.jun.system.support.JunTestExamples;

/**
 * JunChartPlotTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1999/01/14 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunChartPlotTestExamples.java,v 6.0 2003/10/28 10:52:17 nisinaka Exp $
 */
public class JunChartPlotTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples());
		aChart.displayObject();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples());
		aChart.showXAxis();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples(), 1);
		aChart.pointSize_(0.05);
		aChart.showXAxis();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples2(), 1);
		aChart.showXAxis();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example4() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples2(), 1);
		aChart.leftMargin_(0.1);
		aChart.rightMargin_(0.1);
		aChart.interval_(0.1);
		aChart.thickness_(0.1);
		aChart.valueRangeFrom_to_(0, 350);
		aChart.colors_(new Color[] { new Color(255, 127, 0), new Color(127, 63, 63)});
		aChart.showXAxis();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example5() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples2(), 1);
		aChart.valueRangeFrom_to_(0, 350);
		aChart.colors_(new Color[] { new Color(255, 127, 0), new Color(127, 63, 63)});
		aChart.axisColor_(Color.red);
		aChart.labelForegroundColor_(Color.red);
		aChart.labelBackgroundColor_(Color.green);
		aChart.showXAxisWithLabels();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example6() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples2(), 1);
		aChart.valueRangeFrom_to_(0, 350);
		aChart.colors_(new Color[] { new Color(255, 127, 0), new Color(127, 63, 63)});
		aChart.axisColor_(Color.red);
		aChart.labelForegroundColor_(Color.red);
		aChart.labelBackgroundColor_(Color.green);
		aChart.xAxisLabels_(new String[] { "April", "May", "June", "July" });
		aChart.showXAxisWithLabels();
		aChart.showYAxisWithLabels();
		aChart.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ExampleX() {
		JunChartPlot aChart = new JunChartPlot(JunChartDataTestExamples.SampleSamples2(), 1);
		aChart.valueRangeFrom_to_(0, 350);
		aChart.colors_(new Color[] { new Color(255, 127, 0), new Color(127, 63, 63)});
		aChart.axisColor_(Color.red);
		aChart.labelForegroundColor_(Color.red);
		aChart.labelBackgroundColor_(Color.green);
		aChart.showXAxis();
		aChart.showYAxis();
		aChart.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunChartPlotTestExamples();
	}
}
