package sra.jun.opengl.display;

import java.awt.*;
import sra.jun.geometry.basic.*;
import sra.jun.geometry.transformations.*;
import sra.jun.opengl.objects.*;

/**
 * JunOpenGL3dModelTestExamples class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/06 (by MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dModelTestExamples.java,v 6.0 2003/10/28 10:52:17 nisinaka Exp $
 */
public class JunOpenGL3dModelTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example8() {
		JunOpenGL3dModel displayModel = new JunOpenGL3dModel();
		displayModel.openGL3dObject_(C6H6());
		displayModel.viewFactor_(1.2);
		displayModel.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example8a() {
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(C6H6());
		displayModel.viewFactor_(1.2);

		//displayModel.open();
		JunOpenGL3dView view = (JunOpenGL3dView) new JunOpenGL3dModel().defaultView();
		JunOpenGLDisplayController controller = new JunOpenGLDisplayController();
		controller.view_(view);
		displayModel.pickButton().value_(true);
		displayModel.openView_(view);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example8b() {
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(C6H6());
		displayModel.viewFactor_(1.2);

		//displayModel.open();
		JunOpenGL3dView view = (JunOpenGL3dView) new JunOpenGL3dModel().defaultView();
		JunOpenGLDisplayController controller = new JunOpenGLDisplayController();
		controller.view_(view);
		displayModel.grabButton().value_(true);
		displayModel.openView_(view);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example8c() {
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(C6H6());
		displayModel.viewFactor_(1.2);

		//displayModel.open();
		JunOpenGL3dView view = (JunOpenGL3dView) new JunOpenGL3dModel().defaultView();
		JunOpenGLDisplayController controller = new JunOpenGLDisplayController();
		controller.view_(view);
		displayModel.dragButton().value_(true);
		displayModel.openView_(view);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example8d() {
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(C6H6());
		displayModel.viewFactor_(1.2);

		//displayModel.open();
		JunOpenGL3dView view = (JunOpenGL3dView) new JunOpenGL3dModel().defaultView();
		JunOpenGLDisplayController controller = new JunOpenGLDisplayController();
		controller.view_(view);
		displayModel.focusButton().value_(true);
		displayModel.openView_(view);

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGL3dModelTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	protected static JunOpenGL3dObject C6H6() {
		JunOpenGL3dObject aC = JunOpenGL3dObject.Globe_(30);
		aC.paint_(new Color(127, 127, 255));

		JunOpenGL3dObject aH = aC.transform_(Jun3dTransformation.Scale_(0.6));
		aH = aH.transform_(Jun3dTransformation.Translate_(new Jun3dPoint(0.75, 0, 0)));
		aH.paint_(new Color(127, 255, 127));

		JunOpenGL3dObject aCH = JunOpenGL3dCompoundObject.With_with_(aH, aC);
		aCH = aCH.transform_(Jun3dTransformation.Translate_(new Jun3dPoint(0.75, 0, 0)));

		JunOpenGL3dCompoundObject displayObject = new JunOpenGL3dCompoundObject();

		for (int each = 60; each <= 360; each += 60) {
			Jun3dTransformation aT = Jun3dTransformation.Rotate_(JunAngle.FromDeg_(each));
			displayObject.add_(aCH.transform_(aT));
		}

		displayObject.name_("benzene");

		return displayObject;
	}
}
