package sra.jun.opengl.display;

import java.awt.*;
import sra.jun.geometry.basic.*;

/**
 * JunOpenGLDisplayLightTestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   2003/05/06 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLDisplayLightTestExamples.java,v 6.0 2003/10/28 10:52:17 nisinaka Exp $
 */
public class JunOpenGLDisplayLightTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Example1: Create a JunOpenGLDisplayLight and open it.
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunOpenGLDisplayLight displayLight = new JunOpenGLDisplayLight();
		displayLight.open();

		return true;
	}

	/**
	 * Example2: Create a JunOpenGLDisplayLight and open it as a position light.
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunOpenGLDisplayLight displayLight = new JunOpenGLDisplayLight();
		displayLight.lightName_("Position Light");
		displayLight.openPositionLight();

		return true;
	}

	/**
	 * Example3: Open an ambient light.
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunOpenGLDisplayLight displayLight = JunOpenGLDisplayLight.AmbientLight_color_(true, Color.red);
		displayLight.lightName_("Ambient Light");
		displayLight.openAmbientLight();

		return true;
	}

	/**
	 * Example4: Create a parallel light and open it.
	 * 
	 * @return boolean
	 */
	public static boolean Example4() {
		JunOpenGLDisplayLight displayLight = JunOpenGLDisplayLight.ParallelLight_color_position_(true, Color.green, new Jun3dPoint(1, 0, -1));
		displayLight.lightName_("Parallel Light");
		displayLight.openParallelLight();

		return true;
	}

	/**
	 * Example5: Create a spot light and open it.
	 * 
	 * @return boolean
	 */
	public static boolean Example5() {
		JunOpenGLDisplayLight displayLight = JunOpenGLDisplayLight.SpotLight_color_position_direction_cutoffAngle_(true, Color.gray, new Jun3dPoint(1, 1, -1), new Jun3dPoint(-1, -1, 1), JunAngle.FromDeg_(10));
		displayLight.lightName_("Spot Light");
		displayLight.open();

		return true;
	}

	/**
	 * Example6: Create a point light and open it.
	 * 
	 * @return boolean
	 */
	public static boolean Example6() {
		JunOpenGLDisplayLight displayLight = JunOpenGLDisplayLight.PointLight_color_position_(true, Color.blue, new Jun3dPoint(1, 1, 0));
		displayLight.lightName_("Point Light");
		displayLight.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args) {
		new JunOpenGLDisplayLightTestExamples();
	}
}
