package sra.jun.opengl.display;

import java.awt.*;
import sra.smalltalk.*;
import sra.jun.goodies.button.*;
import sra.jun.goodies.cursors.*;

/**
 * JunOpenGLDisplayModelWithCamera class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/05/22 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLDisplayModelWithCamera.java,v 6.0 2003/10/28 10:52:17 nisinaka Exp $
 */
public class JunOpenGLDisplayModelWithCamera extends JunOpenGLDisplayModel {
	protected JunButtonModel cameraButton = null;

	/**
	 * JunOpenGLDisplayModelWithCamera constructor comment.
	 */
	public JunOpenGLDisplayModelWithCamera() {
		super();
	}

	/**
	 * Answer a default view.
	 * 
	 * @return sra.smalltalk.StView
	 */
	public StView defaultView() {
		if (GetDefaultViewMode() == VIEW_AWT) {
			return new JunOpenGLDisplayViewWithCameraAwt(this);
		} else {
			return new JunOpenGLDisplayViewWithCameraSwing(this);
		}
	}

	/**
	 * fetch key-frame image.
	 * 
	 * @param view DOCUMENT ME!
	 * 
	 * @return Image
	 */
	public Image getFrameImage(final JunOpenGLDisplayView view) {
		JunOpenGL3dViewAwt aview = (JunOpenGL3dViewAwt) view.getOpenGLView();
		Dimension d = aview.getSize();
		Image pixmap = aview.createImage(d.width, d.height);
		Graphics gc = pixmap.getGraphics();
		aview.render(gc);
		this.changed_with_($("snapkeyframe"), pixmap);

		return pixmap;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return DOCUMENT ME!
	 */
	public Frame open() {
		return this.openView_((StView) this.defaultView());
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param view DOCUMENT ME!
	 * 
	 * @return sra.jun.goodies.button.JunButtonModel
	 */
	protected JunButtonModel cameraButton(final JunOpenGLDisplayView view) {
		if (cameraButton == null) {
			JunButtonModel button = new JunButtonModel();
			button.value_(false);
			button.visual_(JunCursors.CameraCursor());

			final JunOpenGLDisplayModelWithCamera self = this;
			button.action_(new StBlockClosure() {
				public Object value_(Object o) {
					JunButtonModel model = (JunButtonModel) o;

					//cameraButton has NOT toggle mode.
					//model.value_(!model.value());
					self.getFrameImage(view);

					//System.out.println("cameraButton pressed");
					return model;
				}
			});
			cameraButton = button;
		}

		return cameraButton;
	}
}
