package sra.jun.opengl.display;

import java.awt.Dimension;
import sra.smalltalk.*;
import sra.jun.goodies.button.*;
import sra.jun.goodies.wheels.*;

/**
 * JunOpenGLDisplayViewWithCameraSwing class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/05/22 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLDisplayViewWithCameraSwing.java,v 6.0 2003/10/28 10:52:17 nisinaka Exp $
 */
public class JunOpenGLDisplayViewWithCameraSwing extends JunOpenGLDisplayViewSwing {

	protected JunButtonViewSwing cameraButtonView;

	/**
	 * Create a new instance of JunOpenGLDisplayViewWithCameraSwing and initialize it.
	 *
	 * @param anOpenGLDisplayModelWithCamera sra.jun.opengl.display.JunOpenGLDisplayModelWithCamera
	 */
	public JunOpenGLDisplayViewWithCameraSwing(JunOpenGLDisplayModelWithCamera anOpenGLDisplayModelWithCamera) {
		super(anOpenGLDisplayModelWithCamera);
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.openGLView()._onBorderedPanel(), WindowSpecLayout.Position(0f, 20, 0f, 1, 1f, -20, 1f, -20));
		this.add(new JunButtonViewSwing(this.getOpenGLDisplayModel().pickButton()), WindowSpecLayout.Position(0f, 1, 0f, 1, 0f, 19, 0f, 19));
		this.add(new JunButtonViewSwing(this.getOpenGLDisplayModel().grabButton()), WindowSpecLayout.Position(0f, 1, 0f, 20, 0f, 19, 0f, 38));
		this.add(new JunButtonViewSwing(this.getOpenGLDisplayModel().dragButton()), WindowSpecLayout.Position(0f, 1, 0f, 39, 0f, 19, 0f, 57));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLDisplayModel().xThumbWheel(), true), WindowSpecLayout.Position(0f, 1, 0.5f, -61, 0f, 19, 0.5f, 61));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLDisplayModel().yThumbWheel(), false), WindowSpecLayout.Position(0.5f, -61, 1f, -19, 0.5f, 61, 1f, -1));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLDisplayModel().zThumbWheel(), true), WindowSpecLayout.Position(1f, -19, 0.5f, -61, 1f, -1, 0.5f, 61));
		this.add(new JunButtonViewSwing(this.getOpenGLDisplayModel().focusButton()), WindowSpecLayout.Position(1f, -19, 0.5f, -80, 1f, -1, 0.5f, -62));
		this.add(new JunButtonViewSwing(this.getOpenGLDisplayModel().dollyButton()), WindowSpecLayout.Position(1f, -19, 0.5f, 62, 1f, -1, 0.5f, 80));
		this.setPreferredSize(new Dimension(300, 280 - 2));
	}
}
