package sra.jun.opengl.flux;

import java.awt.*;
import java.util.*;
import sra.jun.geometry.basic.*;
import sra.jun.geometry.transformations.*;
import sra.jun.opengl.objects.*;

/**
 * JunOpenGLFluxMakerTestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLFluxMakerTestExamples.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGLFluxMakerTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		Vector lineSegments;
		JunOpenGLFluxMaker fluxMaker;
		JunOpenGL3dCompoundObject compoundObject;
		JunOpenGL3dPolyline aPolyline;

		lineSegments = _ExampleSegments();
		fluxMaker = JunOpenGLFluxMaker.LineSegments_(lineSegments);
		fluxMaker.segmentTransformations();
		compoundObject = new JunOpenGL3dCompoundObject();

		for (int index = 0; index < fluxMaker.lineSegments().size(); index++) {
			Jun3dPoint[] aSegment;

			aSegment = (Jun3dPoint[]) fluxMaker.lineSegments().elementAt(index);
			aPolyline = (JunOpenGL3dPolyline) JunOpenGL3dPolyline.Vertexes_(aSegment);
			aPolyline.paint_(Color.getHSBColor((float) ((double) index / (double) fluxMaker.lineSegments.size()), (float) 1.0d, (float) 1.0d));
			compoundObject.add_(aPolyline);
		}

		compoundObject.add_(JunOpenGL3dObject.Axes().transform_(Jun3dTransformation.Scale_(5)));
		compoundObject.show();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args) {
		new JunOpenGLFluxMakerTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1() {
		class FluxMakerTest {
			// segmentsBlock
			public Vector segmentsBlock() {
				Vector lineSegments; // (Jun3dPoint[2])[]
				int angleDegrees;

				lineSegments = new Vector();
				angleDegrees = 15;

				for (int degrees = 0; degrees <= (360 - angleDegrees); degrees += angleDegrees) {
					Jun3dTransformation aT;
					Jun3dPoint[] segment;

					aT = Jun3dTransformation.RotateX_(JunAngle.FromDeg_(degrees));
					segment = new Jun3dPoint[] {(Jun3dPoint) new Jun3dPoint(0, 1.5, 0).transform_(aT), (Jun3dPoint) new Jun3dPoint(0, 1.2, 0).transform_(aT)};
					lineSegments.addElement(segment);
				}

				return lineSegments;
			}

			// show1Block
			public void show1Block() {
				JunOpenGL3dObject axesObject;
				JunOpenGL3dCompoundObject compoundObject;
				Vector lineSegments; // (Jun3dPoint[2])[]

				axesObject = JunOpenGL3dObject.Axes().scaledBy_(2);
				compoundObject = JunOpenGL3dCompoundObject.With_(axesObject);
				lineSegments = segmentsBlock();

				for (int i = 0; i < lineSegments.size(); i++) {
					Jun3dPoint[] segment = (Jun3dPoint[]) lineSegments.elementAt(i);
					JunOpenGL3dPolyline polyline;

					polyline = (JunOpenGL3dPolyline) JunOpenGL3dPolyline.Vertexes_(segment);
					polyline.paint_(Color.gray);
					compoundObject.add_(polyline);
				}

				compoundObject.show();
			}

			// show2Block
			public void show2Block() {
				JunOpenGLFluxMaker fluxMaker;
				JunOpenGL3dObject axesObject;
				JunOpenGLFluxMutableObject mutableObject;
				JunOpenGLFluxImmutableObject immutableObject;
				JunOpenGL3dCompoundObject compoundObject;
				JunOpenGLFluxObject fluxObject;

				fluxMaker = JunOpenGLFluxMaker.LineSegments_(segmentsBlock());
				axesObject = JunOpenGL3dObject.Axes2();
				mutableObject = JunOpenGLFluxMutableObject.Object_(axesObject);

				for (int i = 0; i < fluxMaker.segmentTransformations().length; i++) {
					Jun3dTransformation aT = fluxMaker.segmentTransformations()[i];
					mutableObject.add_(aT);
				}

				axesObject = JunOpenGL3dObject.Axes().scaledBy_(2);
				immutableObject = JunOpenGLFluxImmutableObject.Object_(axesObject);
				compoundObject = new JunOpenGL3dCompoundObject();
				compoundObject.add_(mutableObject.compoundObject());
				compoundObject.add_(immutableObject.compoundObject());
				compoundObject.show();
				fluxObject = new JunOpenGLFluxObject();
				fluxObject.addImmutable_(immutableObject);
				fluxObject.addMutable_(mutableObject);
				fluxObject.show();
			}

			// satelliteBlock
			public JunOpenGL3dObject satelliteBlock() {
				JunOpenGL3dObject box1;
				JunOpenGL3dObject box2;
				JunOpenGL3dCompoundObject satellite;

				box1 = JunOpenGL3dObject.Box_(new Jun3dPoint(0.4, 0.4, 0.4));
				box1.paint_(Color.gray);
				box2 = JunOpenGL3dObject.Box_(new Jun3dPoint(0.4, 0.4, 0.4));
				box2 = box2.translatedBy_(new Jun3dPoint(0, 0, 0.4));
				box2.paint_(Color.yellow);
				satellite = JunOpenGL3dCompoundObject.With_with_(box1, box2);

				return satellite.translatedBy_(new Jun3dPoint(-0.2, -0.2, 0));
			}

			// show3Block
			public void show3Block() {
				JunOpenGLFluxMaker fluxMaker;
				JunOpenGLFluxMutableObject mutableObject;
				JunOpenGL3dObject axesObject;
				JunOpenGLFluxImmutableObject immutableObject;
				JunOpenGL3dCompoundObject compoundObject;
				JunOpenGLFluxObject fluxObject;

				fluxMaker = JunOpenGLFluxMaker.LineSegments_(segmentsBlock());
				mutableObject = JunOpenGLFluxMutableObject.Object_(satelliteBlock());

				for (int i = 0; i < fluxMaker.segmentTransformations().length; i++) {
					Jun3dTransformation aT = fluxMaker.segmentTransformations()[i];
					mutableObject.add_(aT);
				}

				axesObject = JunOpenGL3dObject.Axes().scaledBy_(2);
				immutableObject = JunOpenGLFluxImmutableObject.Object_(axesObject);
				compoundObject = new JunOpenGL3dCompoundObject();
				compoundObject.add_(mutableObject.compoundObject());
				compoundObject.add_(immutableObject.compoundObject());
				compoundObject.show();
				fluxObject = new JunOpenGLFluxObject();
				fluxObject.addImmutable_(immutableObject);
				fluxObject.addMutable_(mutableObject);
				fluxObject.show();
			}

			// earthBlock
			public JunOpenGL3dObject earthBlock() {
				JunOpenGL3dObject earthObject;

				earthObject = JunOpenGL3dObject.Sphere_(20);
				earthObject.paint_(Color.cyan);

				return earthObject;
			}

			// show4Block
			public void show4Block() {
				JunOpenGLFluxMaker fluxMaker;
				JunOpenGLFluxMutableObject mutableObject;
				JunOpenGLFluxImmutableObject immutableObject;
				JunOpenGL3dCompoundObject compoundObject;
				JunOpenGLFluxObject fluxObject;
				JunOpenGLFluxModel fluxModel;

				fluxMaker = JunOpenGLFluxMaker.LineSegments_(segmentsBlock());
				mutableObject = JunOpenGLFluxMutableObject.Object_(satelliteBlock());

				for (int i = 0; i < fluxMaker.segmentTransformations().length; i++) {
					Jun3dTransformation aT = fluxMaker.segmentTransformations()[i];
					mutableObject.add_(aT);
				}

				immutableObject = JunOpenGLFluxImmutableObject.Object_(earthBlock());
				compoundObject = new JunOpenGL3dCompoundObject();
				compoundObject.add_(mutableObject.compoundObject());
				compoundObject.add_(immutableObject.compoundObject());
				compoundObject.show();
				fluxObject = new JunOpenGLFluxObject();
				fluxObject.addImmutable_(immutableObject);
				fluxObject.addMutable_(mutableObject);
				fluxModel = JunOpenGLFluxModel.FluxObject_(fluxObject);
				fluxModel.trackerModel().loop();
				fluxModel.open();
			}
		}

		FluxMakerTest test = new FluxMakerTest();
		test.show1Block();
		test.show2Block();
		test.show3Block();
		test.show4Block();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	protected static Vector _ExampleSegments() {
		return _ExampleSegments_(10);
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param angleDegrees DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	protected static Vector _ExampleSegments_(int angleDegrees) {
		return _ExampleSegments_rotationSelector_(angleDegrees, "RotateY_");
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param angleDegrees DOCUMENT ME!
	 * @param messageSelector DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	protected static Vector _ExampleSegments_rotationSelector_(int angleDegrees, String messageSelector) {
		Jun3dPoint fromPoint;
		Jun3dPoint toPoint;
		Jun3dPoint aVector;
		Jun3dTransformation aT;
		Jun3dTransformation originalTranslation;
		Vector segmentCollection;

		fromPoint = new Jun3dPoint(0, 0, 0);
		toPoint = new Jun3dPoint(1, 1, 1);
		aT = Jun3dTransformation.Translate_(new Jun3dPoint(0, 0, 2));
		fromPoint = (Jun3dPoint) fromPoint.transform_(aT);
		toPoint = (Jun3dPoint) toPoint.transform_(aT);
		aVector = (Jun3dPoint) toPoint.minus_(fromPoint);
		originalTranslation = Jun3dTransformation.Translate_(fromPoint);
		segmentCollection = new Vector();

		for (int degrees = 0; degrees <= (360 - angleDegrees); degrees += angleDegrees) {
			Jun3dTransformation rotationT;
			Jun3dTransformation scalingT;
			Jun3dTransformation translationT;
			Jun3dPoint aPoint0;
			Jun3dPoint aPoint1;
			Jun3dPoint[] aSegment;

			rotationT = Jun3dTransformation.Unity();

			if (messageSelector.equals("RotateX_")) {
				rotationT = (Jun3dTransformation) rotationT.product_(Jun3dTransformation.RotateX_(JunAngle.FromDeg_(degrees)));
			} else if (messageSelector.equals("RotateY_")) {
				rotationT = (Jun3dTransformation) rotationT.product_(Jun3dTransformation.RotateY_(JunAngle.FromDeg_(degrees)));
			} else if (messageSelector.equals("RotateZ_")) {
				rotationT = (Jun3dTransformation) rotationT.product_(Jun3dTransformation.RotateZ_(JunAngle.FromDeg_(degrees)));
			}

			scalingT = Jun3dTransformation.Scale_(new Jun3dPoint(1, 1, (1 + (1 * ((double) degrees / 360.0d)))));
			translationT = Jun3dTransformation.Translate_(new Jun3dPoint(4 * ((double) degrees / 360.0d), 0, 0));
			aT = Jun3dTransformation.Unity();
			aT = (Jun3dTransformation) aT.product_(scalingT);
			aT = (Jun3dTransformation) aT.product_(originalTranslation);
			aT = (Jun3dTransformation) aT.product_(rotationT);
			aT = (Jun3dTransformation) aT.product_(translationT);
			aPoint0 = (Jun3dPoint) new Jun3dPoint(0, 0, 0).transform_(aT);
			aPoint1 = (Jun3dPoint) aVector.transform_(aT);
			aSegment = new Jun3dPoint[2];
			aSegment[0] = aPoint0;
			aSegment[1] = aPoint1;
			segmentCollection.addElement(aSegment);
		}

		return segmentCollection;
	}
}
