package sra.jun.opengl.flux;

import java.awt.*;
import sra.jun.geometry.basic.*;
import sra.jun.geometry.transformations.*;
import sra.jun.opengl.objects.*;

/**
 * JunOpenGLFluxObjectTestExamples class
 * 
 *  @author    BNR
 *  @created   1999/07/26 (by BNR)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLFluxObjectTestExamples.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGLFluxObjectTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args) {
		new JunOpenGLFluxObjectTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1() {
		JunOpenGL3dCompoundObject anObject;
		JunOpenGLFluxMutableObject mutableObject;
		JunOpenGLFluxObject fluxObject;
		JunOpenGLFluxModel fluxModel;

		anObject = (JunOpenGL3dCompoundObject) JunOpenGL3dObject.Box();

		for (int i = 0; i < anObject.components().length; i++) {
			anObject.components()[i].paint_(Color.red);
		}

		mutableObject = JunOpenGLFluxMutableObject.Object_(anObject);
		fluxObject = new JunOpenGLFluxObject();
		fluxObject.addMutable_(mutableObject);
		fluxModel = JunOpenGLFluxModel.FluxObject_(fluxObject);
		fluxModel.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample2() {
		JunOpenGL3dObject moonObject;
		int angleDegrees;
		JunOpenGLFluxMutableObject mutableObject;
		JunOpenGLFluxObject fluxObject;
		JunOpenGLFluxModel fluxModel;

		moonObject = JunOpenGL3dObject.Sphere_(30);
		moonObject = moonObject.scaledBy_(0.3);
		moonObject = moonObject.translatedBy_(new Jun3dPoint(0, 5, 0));
		moonObject.paint_(Color.yellow);
		mutableObject = JunOpenGLFluxMutableObject.Object_(moonObject);
		angleDegrees = 10;

		for (int degrees = 0; degrees < (360 - angleDegrees); degrees += angleDegrees) {
			Jun3dTransformation aT = Jun3dTransformation.RotateZ_(JunAngle.FromDeg_(degrees));
			mutableObject.add_(aT);
		}

		fluxObject = new JunOpenGLFluxObject();
		fluxObject.addMutable_(mutableObject);
		fluxModel = JunOpenGLFluxModel.FluxObject_(fluxObject);
		fluxModel.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample3() {
		JunOpenGL3dObject earthObject;
		JunOpenGLFluxImmutableObject immutableObject;
		JunOpenGLFluxObject fluxObject;
		JunOpenGLFluxModel fluxModel;

		earthObject = JunOpenGL3dObject.Sphere_(20);
		earthObject.paint_(Color.cyan);
		immutableObject = JunOpenGLFluxImmutableObject.Object_(earthObject);
		fluxObject = new JunOpenGLFluxObject();
		fluxObject.addImmutable_(immutableObject);
		fluxModel = JunOpenGLFluxModel.FluxObject_(fluxObject);
		fluxModel.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample4() {
		JunOpenGL3dObject earthObject;
		JunOpenGL3dObject moonObject;
		JunOpenGLFluxImmutableObject immutableObject;
		JunOpenGLFluxMutableObject mutableObject;
		int angleDegrees;
		JunOpenGLFluxObject fluxObject;
		JunOpenGLFluxModel fluxModel;

		earthObject = JunOpenGL3dObject.Sphere_(20);
		earthObject.paint_(Color.cyan);
		immutableObject = JunOpenGLFluxImmutableObject.Object_(earthObject);
		moonObject = JunOpenGL3dObject.Sphere_(30);
		moonObject = moonObject.scaledBy_(0.3);
		moonObject = moonObject.translatedBy_(new Jun3dPoint(0, 5, 0));
		moonObject.paint_(Color.yellow);
		mutableObject = JunOpenGLFluxMutableObject.Object_(moonObject);
		angleDegrees = 10;

		for (int degrees = 0; degrees < (360 - angleDegrees); degrees += angleDegrees) {
			Jun3dTransformation aT = Jun3dTransformation.RotateZ_(JunAngle.FromDeg_(degrees));
			mutableObject.add_(aT);
		}

		fluxObject = new JunOpenGLFluxObject();
		fluxObject.addImmutable_(immutableObject);
		fluxObject.addMutable_(mutableObject);
		fluxModel = JunOpenGLFluxModel.FluxObject_(fluxObject);
		fluxModel.trackerModel().loop();
		fluxModel.open();

		return true;
	}
}
