package sra.jun.opengl.flux;

import java.awt.*;
import sra.smalltalk.*;
import sra.jun.goodies.button.JunButtonViewAwt;
import sra.jun.goodies.track.JunTrackSliderViewAwt;
import sra.jun.opengl.display.JunOpenGLDisplayViewAwt;

/**
 * JunOpenGLFluxViewAwt class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/06/02 (by MATSUDA Ryouichi)
 *  @updated   2000/01/20 (by MATSUDA Ryouichi)
 *  @updated   2003/03/24 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLFluxViewAwt.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGLFluxViewAwt extends StViewPanel implements JunOpenGLFluxView {

	protected JunOpenGLDisplayViewAwt displayView;
	protected JunButtonViewAwt playButtonView;
	protected JunButtonViewAwt loopButtonView;
	protected JunTrackSliderViewAwt sliderView;
	protected JunButtonViewAwt previousButtonView;
	protected JunButtonViewAwt nextButtonView;

	/**
	 * Create a new instance of JunOpenGLFluxViewAwt and initialize it.
	 *
	 * @param aFluxModel sra.jun.opengl.flux.JunOpenGLFluxModel
	 */
	public JunOpenGLFluxViewAwt(JunOpenGLFluxModel aFluxModel) {
		super(aFluxModel);
	}

	/**
	 * model property accessing.
	 * 
	 * @return sra.jun.opengl.flux.JunOpenGLFluxModel
	 * @deprecated since Jun379, use getOpenGLFluxModel()
	 */
	public JunOpenGLFluxModel getModel() {
		return (JunOpenGLFluxModel) this.model();
	}

	/**
	 * Answer my model as JunOpenGLFluxModel.
	 * 
	 * @return sra.jun.opengl.flux.JunOpenGLFluxModel
	 */
	public JunOpenGLFluxModel getOpenGLFluxModel() {
		return (JunOpenGLFluxModel) this.model();
	}

	/**
	 * Call noticeOfComponentRemove() before removeNotify().
	 */
	public void removeNotify() {
		this.getOpenGLFluxModel().end();
		super.removeNotify();
	}

	/**
	 * model property accessing.
	 * 
	 * @param aModel sra.jun.opengl.flux.JunOpenGLFluxModel
	 * @deprecated since Jun379
	 */
	public void setModel(JunOpenGLFluxModel aModel) {
		this.model_(aModel);
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		this.setLayout(new BorderLayout());

		final Dimension buttonSize = new Dimension(18, 18);

		// center
		displayView = new JunOpenGLDisplayViewAwt(this.getOpenGLFluxModel());
		this.add(displayView, "Center");

		// buttom
		Panel trackSliderPanel = new Panel(new BorderLayout());

		//
		Panel westPanel = new Panel(new GridLayout(1, 2));
		playButtonView = new JunButtonViewAwt(this.getOpenGLFluxModel().trackerModel().playButton());
		playButtonView.setSize(buttonSize);
		westPanel.add(playButtonView);
		loopButtonView = new JunButtonViewAwt(this.getOpenGLFluxModel().trackerModel().loopButton());
		loopButtonView.setSize(buttonSize);
		westPanel.add(loopButtonView);
		trackSliderPanel.add("West", westPanel);

		//
		Panel centerPanel = new Panel(new BorderLayout());
		sliderView = new JunTrackSliderViewAwt(this.getOpenGLFluxModel().trackerModel());
		centerPanel.add(sliderView);
		trackSliderPanel.add("Center", centerPanel);

		//
		Panel eastPanel = new Panel(new GridLayout(1, 2));
		previousButtonView = new JunButtonViewAwt(this.getOpenGLFluxModel().trackerModel().previousButton());
		previousButtonView.setSize(buttonSize);
		eastPanel.add(previousButtonView);
		nextButtonView = new JunButtonViewAwt(this.getOpenGLFluxModel().trackerModel().nextButton());
		nextButtonView.setSize(buttonSize);
		eastPanel.add(nextButtonView);
		trackSliderPanel.add("East", eastPanel);

		//
		this.add(trackSliderPanel, "South");
	}

	/**
	 * Answer a default model.
	 * 
	 * @return sra.smalltalk.StModel
	 */
	protected StModel defaultModel() {
		return new JunOpenGLFluxModel();
	}
}
