package sra.jun.opengl.grapher;

import sra.jun.geometry.basic.*;
import sra.jun.goodies.lisp.*;
import sra.jun.opengl.display.*;
import sra.jun.opengl.objects.*;
import sra.jun.system.support.*;

/**
 * JunOpenGL3dArcTestExamples class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1998/12/15 (by Hirotsugu Kondo)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dArcTestExamples.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGL3dArcTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunOpenGL3dNode node1 = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(10, 0, 0), new Jun3dPoint(1, 1, 1), JunOpenGL3dObject.SampleColor());
		JunOpenGL3dNode node2 = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(0, 0, 20), new Jun3dPoint(1, 1, 1), JunOpenGL3dObject.SampleColor());
		JunOpenGL3dArc arc = JunOpenGL3dArc.From_to_color_(node1, node2, JunOpenGL3dObject.SampleColor());
		JunOpenGLDisplayModel.Show_(arc);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunOpenGL3dNode node1 = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(10, 0, 0), new Jun3dPoint(1, 1, 1), JunOpenGL3dObject.SampleColor());
		JunOpenGL3dNode node2 = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(0, 0, 20), new Jun3dPoint(1, 1, 1), JunOpenGL3dObject.SampleColor());
		JunOpenGL3dArc arc = JunOpenGL3dArc.From_to_color_(node1, node2, JunOpenGL3dObject.SampleColor());
		arc.crank_(true);

		JunLispList list = arc.showLispList();
		arc = (JunOpenGL3dArc) JunOpenGL3dArc.FromLispList_(list);
		arc.showLispList();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(java.lang.String[] args) {
		new JunOpenGL3dArcTestExamples();
	}
}
