package sra.jun.opengl.grapher;

import java.awt.Color;
import sra.jun.geometry.basic.*;
import sra.jun.goodies.lisp.*;
import sra.jun.opengl.display.*;
import sra.jun.opengl.objects.*;
import sra.jun.opengl.texture.*;
import sra.jun.system.support.*;

/**
 * JunOpenGL3dNodeTestExamples class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1998/12/15 (by Hirotsugu Kondo)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dNodeTestExamples.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGL3dNodeTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunOpenGL3dNode node = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(10, 20, 30), new Jun3dPoint(1, 2, 3), JunOpenGL3dObject.SampleColor());
		JunOpenGLDisplayModel.Show_(node);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunOpenGL3dNode node = JunOpenGL3dNode.Location_extent_color_(new Jun3dPoint(10, 20, 30), new Jun3dPoint(1, 2, 3), JunOpenGL3dObject.SampleColor());
		JunLispList list = node.showLispList();
		node = (JunOpenGL3dNode) JunOpenGL3dNode.FromLispList_(list);
		node.showLispList();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		String string = "Smalltalk";
		JunOpenGLTexture texture = JunOpenGLTexture.TextureForString_foreColor_backColor_(string, Color.red, Color.green);
		JunOpenGL3dNode node = JunOpenGL3dNode.Location_extent_entity_(new Jun3dPoint(10, 20, 30), new Jun3dPoint(texture.width(), texture.height(), 10), string);
		node.texture_(texture);
		JunOpenGLDisplayModel.Show_(node);

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(java.lang.String[] args) {
		new JunOpenGL3dNodeTestExamples();
	}
}
