package sra.jun.opengl.lights;

import java.awt.Color;
import sra.jun.geometry.basic.*;
import sra.jun.opengl.display.*;
import sra.jun.opengl.objects.*;
import sra.jun.opengl.projection.*;
import sra.jun.opengl.support.*;

/**
 * JunOpenGLLightTestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLLightTestExamples.java,v 6.0 2003/10/28 10:52:18 nisinaka Exp $
 */
public class JunOpenGLLightTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGLLightTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aCube;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(10, 10, 10));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aCube = JunOpenGL3dObject.Cube();
				aCube.paint_(Color.magenta);
				aProjector.project_on_(aCube, aRenderingContext);
				aCube.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aCube;
				JunOpenGLAmbientLight anAmbientLight;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(10, 10, 10));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aCube = JunOpenGL3dObject.Cube();
				aCube.paint_(Color.magenta);
				anAmbientLight = JunOpenGLAmbientLight.Color_(Color.lightGray);
				aProjector.project_on_(aCube, aRenderingContext);
				anAmbientLight.lightingOn_(aRenderingContext);
				aCube.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample2a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aGlobe.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample2b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;
				JunOpenGLParallelLight aParallelLight;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aParallelLight = JunOpenGLParallelLight.At3dPoint_color_(new Jun3dPoint(1.0, 1.0, 1.0), Color.lightGray);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aParallelLight.lightingOn_(aRenderingContext);
				aGlobe.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample3a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aGlobe.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample3b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;
				JunOpenGLSpotLight aSpotLight;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aSpotLight = JunOpenGLSpotLight.At3dPoint_color_(new Jun3dPoint(0.0, 0.0, 10.0), Color.lightGray);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aSpotLight.lightingOn_(aRenderingContext);
				aGlobe.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}
}
