package sra.jun.opengl.objects;

import java.awt.Image;
import sra.smalltalk.StImage;

/**
 * JunOpenGL3dObjectTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/10/13 (by nisinaka)
 *  @updated   2001/11/20 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dObjectTestExamples.java,v 6.0 2003/10/28 10:52:19 nisinaka Exp $
 */
public class JunOpenGL3dObjectTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Show the typical object: Axes
	 * 
	 * @return boolean
	 */
	public static boolean ExampleAxes() {
		JunOpenGL3dObject.Axes().show();
		return true;
	}

	/**
	 * Show the typical object: Axes2
	 * 
	 * @return boolean
	 */
	public static boolean ExampleAxes2() {
		JunOpenGL3dObject.Axes2().show();
		return true;
	}

	/**
	 * Show the typical object: Box
	 * 
	 * @return boolean
	 */
	public static boolean ExampleBox() {
		JunOpenGL3dObject.Box().show();
		return true;
	}

	/**
	 * Show the typical object: ChunkOfPie
	 * 
	 * @return boolean
	 */
	public static boolean ExampleChunkOfPie() {
		JunOpenGL3dObject aChunkOfPie = JunOpenGL3dObject.ChunkOfPieFrom_to_by_radius_thickness_(0, 90, 10, 0.8, 0.2);
		aChunkOfPie.paint_(java.awt.Color.red);
		JunOpenGL3dCompoundObject.With_with_(aChunkOfPie, JunOpenGL3dObject.Axes2()).show();
		return true;
	}

	/**
	 * Show the typical object: Cone
	 * 
	 * @return boolean
	 */
	public static boolean ExampleCone() {
		JunOpenGL3dObject.Cone().show();
		return true;
	}

	/**
	 * Show the typical object: Cube
	 * 
	 * @return boolean
	 */
	public static boolean ExampleCube() {
		JunOpenGL3dObject.Cube().show();
		return true;
	}

	/**
	 * Show the typical object: Eddy
	 * 
	 * @return boolean
	 */
	public static boolean ExampleEddy() {
		JunOpenGL3dObject.Eddy().show();
		return true;
	}

	/**
	 * Show the typical object: Globe
	 * 
	 * @return boolean
	 */
	public static boolean ExampleGlobe() {
		JunOpenGL3dObject.Globe().show();
		return true;
	}

	/**
	 * Show the typical object: SlicedPie
	 * 
	 * @return boolean
	 */
	public static boolean ExampleSlicedPie() {
		JunOpenGL3dObject aSliecedPie = JunOpenGL3dObject.SlicedPieFrom_to_by_radius_thickness_(0, 270, 10, 0.8, 0.2);
		aSliecedPie.paint_(java.awt.Color.red);
		JunOpenGL3dCompoundObject.With_with_(aSliecedPie, JunOpenGL3dObject.Axes2()).show();
		return true;
	}

	/**
	 * Show the typical object: Stack
	 * 
	 * @return boolean
	 */
	public static boolean ExampleStack() {
		JunOpenGL3dObject.Stack().show();
		return true;
	}

	/**
	 * Show the 2D text.
	 * 
	 * @return boolean
	 */
	public static boolean ExampleText2d() {
		JunOpenGL3dObject.Text2d_("Jun").show();
		JunOpenGL3dObject.Text2d_weight_("Jun", 0.1).show();
		JunOpenGL3dObject.Text2d_weight_("Jun", 0.9).show();
		return true;
	}

	/**
	 * Show the 3D text.
	 * 
	 * @return boolean
	 */
	public static boolean ExampleText3d() {
		JunOpenGL3dObject.Text3d_("Jun").show();
		JunOpenGL3dObject.Text3d_weight_("Jun", 0.1).show();
		JunOpenGL3dObject.Text3d_weight_("Jun", 0.9).show();
		return true;
	}

	/**
	 * Convert to an image.
	 * 
	 * @return boolean
	 */
	public static boolean Example_asImage() {
		JunOpenGL3dObject anObject = JunOpenGL3dObject.Eddy();
		Image anImage = anObject.asImage();
		StImage.Display_(new StImage(anImage));
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGL3dObjectTestExamples();
	}
}
