package sra.jun.opengl.objects;

import java.awt.Color;
import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.goodies.lisp.JunLispCons;
import sra.jun.opengl.display.JunOpenGLDisplayModel;

/**
 * JunOpenGL3dVertexesTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/10/20 (by nisinaka)
 *  @updated   2001/11/20 (by nisinaka)
 *  @updated   2003/09/09 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dVertexesTestExamples.java,v 6.0 2003/10/28 10:52:19 nisinaka Exp $
 */
public class JunOpenGL3dVertexesTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGL3dVertexesTestExamples();
	}

	/**
	 * Example1: Check if the preferred normal vector is correct.
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		Jun3dPoint p0 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint p1 = new Jun3dPoint(0, 0, 1);
		Jun3dPoint p2 = new Jun3dPoint(0, 1, 0);
		Jun3dPoint p3 = new Jun3dPoint(0, 1, 1);
		Jun3dPoint[] points = { p0, p1, p3, p2 };
		JunOpenGL3dPolygon aPolygon = JunOpenGL3dPolygon.Vertexes_(points);
		Jun3dPoint vector = aPolygon.normalVector();
		return (vector.x() == -1.0d) && (vector.y() == 0.0d) && (vector.z() == 0.0d);
	}

	/**
	 * Example5: Check if the colors can be specified.
	 * 
	 * @return boolean
	 */
	public static boolean Example5() {
		JunOpenGL3dPolygon polygon = ColoredPolygon();
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(polygon);
		displayModel.smoothShading();
		displayModel.open();
		return true;
	}

	/**
	 * Example6: Check if the preferred normal vector is correct.
	 * 
	 * @return boolean
	 */
	public static boolean Example6() {
		JunOpenGL3dPolygon polygon = ColoredPolygon();
		polygon = (JunOpenGL3dPolygon) JunOpenGL3dPolygon.FromLispList_((JunLispCons) polygon.toLispList());
		JunOpenGLDisplayModel displayModel = new JunOpenGLDisplayModel();
		displayModel.displayObject_(polygon);
		displayModel.smoothShading();
		displayModel.open();
		return true;
	}

	/**
	 * Answer the colored polygon.
	 * 
	 * @return sra.jun.opengl.objects.JunOpenGL3dPolygon
	 */
	protected static JunOpenGL3dPolygon ColoredPolygon() {
		JunOpenGL3dPolygon polygon = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0, 0, 1), new Jun3dPoint(1, 0, 1), new Jun3dPoint(1, 1, 1), new Jun3dPoint(0, 1, 1)});
		polygon.colors_(new Color[] { Color.red, Color.yellow, Color.red, Color.blue });
		return polygon;
	}

}
