package sra.jun.opengl.picking;

import java.awt.*;
import sra.gl4jun.*;
import sra.jun.geometry.basic.*;
import sra.jun.opengl.support.*;
import sra.jun.opengl.texture.*;
import sra.smalltalk.*;

/**
 * JunOpenGLPickingRenderingContext class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1998/11/12 (by MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLPickingRenderingContext.java,v 6.0 2003/10/28 10:52:19 nisinaka Exp $
 */
public class JunOpenGLPickingRenderingContext extends JunOpenGLRenderingContext {
	protected int selectionBufferSize;

	/**
	 * Creates a new JunOpenGLPickingRenderingContext object.
	 */
	public JunOpenGLPickingRenderingContext() {
		super(new GLjImageSource(1, 1));
		this.selectionBufferSize_(this.defaultSelectionBufferSize());
	}

	/**
	 * Answer the receiver modulo.
	 * 
	 * @param aReceiver int
	 * @param aNumber int
	 * 
	 * @return int
	 */
	private static int Modulo(int aReceiver, int aNumber) {
		return aReceiver - (aReceiver / aNumber * aNumber);
	}

	/**
	 * Clear the DepthBuffer and ColorBuffer.
	 */
	public void clear() {
		super.clear();

		//
		super.disableBlending();
		super.disableLighting();
		super.disableFog();
		super.disablePolygonSmooth();
		super.disableLineSmooth();
		super.flatShading();
		super.disableNormalize();
		super.disableDithering();
		super.enableDepthTest();
	}

	/**
	 * Clear the ColorBuffer of OpenGL with background color.
	 */
	public void clearColorBuffer() {
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public int defaultSelectionBufferSize() {
		return 1024;
	}

	/**
	 * Disable the Blending of OpenGL.
	 */
	public void disableBlending() {
	}

	/**
	 * Disable the ColorMaterial of OpenGL.
	 */
	public void disableColorMaterial() {
	}

	/**
	 * Disable the Dithering of OpenGL.
	 */
	public void disableDithering() {
	}

	/**
	 * Disable the Fog of OpenGL.
	 */
	public void disableFog() {
	}

	/**
	 * Disable the Light at index of OpenGL.
	 * 
	 * @param index0to7 int
	 */
	public void disableLightIndex_(int index0to7) {
	}

	/**
	 * Disable the Lighting of OpenGL.
	 */
	public void disableLighting() {
	}

	/**
	 * Disable the LineSmooth of OpenGL.
	 */
	public void disableLineSmooth() {
	}

	/**
	 * Disable the Normalize of OpenGL.
	 */
	public void disableNormalize() {
	}

	/**
	 * Disable the PolygonSmooth of OpenGL.
	 */
	public void disablePolygonSmooth() {
	}

	/**
	 * Display Polygon to OpenGL.
	 * 
	 * @param aCollectionOfPoints sra.jun.geometry.basic.Jun3dPoint[]
	 */
	public void displayPolygon_(final Jun3dPoint[] aCollectionOfPoints) {
		OpenGLInterface.glBegin(OpenGLInterface.GL_POLYGON);

		for (int i = 0; i < aCollectionOfPoints.length; i++) {
			Jun3dPoint a3dPoint = aCollectionOfPoints[i];
			OpenGLInterface.glVertex3d(a3dPoint.x(), a3dPoint.y(), a3dPoint.z());
		}

		OpenGLInterface.glEnd();
	}

	/**
	 * Enable the Blending of OpenGL.
	 */
	public void enableBlending() {
	}

	/**
	 * Enable the ColorMaterial of OpenGL.
	 */
	public void enableColorMaterial() {
	}

	/**
	 * Enable the Dithering of OpenGL.
	 */
	public void enableDithering() {
	}

	/**
	 * Enable the Fog of OpenGL.
	 */
	public void enableFog() {
	}

	/**
	 * Enable the Light with index of OpenGL.
	 * 
	 * @param index0to7 int
	 */
	public void enableLightIndex_(int index0to7) {
	}

	/**
	 * Enable the Lighting of OpenGL.
	 */
	public void enableLighting() {
	}

	/**
	 * Enable the LineSmooth of OpenGL.
	 */
	public void enableLineSmooth() {
	}

	/**
	 * Enable the Normalize of OpenGL.
	 */
	public void enableNormalize() {
	}

	/**
	 * Enable the PolygonSmooth of OpenGL.
	 */
	public void enablePolygonSmooth() {
	}

	/**
	 * Enable the PolygonStipple of OpenGL.
	 */
	public void enablePolygonStipple() {
	}

	/**
	 * Enable the Texture-2d of OpenGL.
	 */
	public void enableTexture2d() {
	}

	/**
	 * Change shading of OpenGL to flat.
	 */
	public void flatShading() {
	}

	/**
	 * Call the glFogfv() of OpenGL with a Color.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void fogColor_(Color aColorValue) {
	}

	/**
	 * Call the glFog of OpenGL with EXP2.
	 * 
	 * @param aNumber float
	 */
	public void fogExp2Density_(float aNumber) {
	}

	/**
	 * Call the glFog() of OpenGL with EXP.
	 * 
	 * @param aNumber float
	 */
	public void fogExpDensity_(float aNumber) {
	}

	/**
	 * Call the glFog() of OpenGL with StartDensity and EndDensity.
	 * 
	 * @param aNumber1 float
	 * @param aNumber2 float
	 */
	public void fogLinearStartDensity_endDensity_(float aNumber1, float aNumber2) {
	}

	/**
	 * Set a color as LightAmbient.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void lightAmbientColor_(Color aColorValue) {
	}

	/**
	 * Set a color as LightAmbient and a number as alpha.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void lightAmbientColor_alpha_(Color aColorValue, float aNumber) {
	}

	/**
	 * Call the glLightModel() of OpenGL with ambientColor and alpha and
	 * boolean of two side.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 * @param aBoolean boolean
	 */
	public void lightAmbientColor_alpha_twoSide_(Color aColorValue, float aNumber, boolean aBoolean) {
	}

	/**
	 * Set index of Light with 3d-position.
	 * 
	 * @param index0to7 int
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 */
	public void lightIndex_position_(int index0to7, Jun3dPoint a3dPoint) {
	}

	/**
	 * Set index of Light with 3d-position with color.
	 * 
	 * @param index0to7 int
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * @param aColorValue java.awt.Color
	 */
	public void lightIndex_position_color_(int index0to7, Jun3dPoint a3dPoint, Color aColorValue) {
	}

	/**
	 * Set index of Light with 3d-position with boolean as parallel with color.
	 * 
	 * @param index0to7 int
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * @param aBoolean boolean
	 * @param aColorValue java.awt.Color
	 */
	public void lightIndex_position_parallel_color_(int index0to7, Jun3dPoint a3dPoint, boolean aBoolean, Color aColorValue) {
	}

	/**
	 * Set index of Light with 3d-position with boolean as parallel with color
	 * with alpha.
	 * 
	 * @param index0to7 int
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * @param aBoolean boolean
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void lightIndex_position_parallel_color_alpha_(int index0to7, Jun3dPoint a3dPoint, boolean aBoolean, Color aColorValue, float aNumber) {
	}

	/**
	 * Call the glHint() of OpenGL with lineSmoothDontCare.
	 */
	public void lineSmoothDontCare() {
	}

	/**
	 * Call the glHint() of OpenGL with lineSmoothNicest.
	 */
	public void lineSmoothNicest() {
	}

	/**
	 * Set color as materialAmbient.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void materialAmbient_(Color aColorValue) {
	}

	/**
	 * Call the glMaterial() with color of materialAmbient with alpha.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void materialAmbient_alpha_(Color aColorValue, float aNumber) {
	}

	/**
	 * Set color of materialDiffuse.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void materialDiffuse_(Color aColorValue) {
	}

	/**
	 * Set color of materialDiffuse with alpha.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void materialDiffuse_alpha_(Color aColorValue, float aNumber) {
	}

	/**
	 * Set color of materialEmission.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void materialEmission_(Color aColorValue) {
	}

	/**
	 * Call glMaterial() of OpenGL with color of materialEmission with alpha.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void materialEmission_alpha_(Color aColorValue, float aNumber) {
	}

	/**
	 * Call glMaterial() of OpenGL with number of materialShininess.
	 * 
	 * @param aNumber float
	 */
	public void materialShininess_(float aNumber) {
	}

	/**
	 * Set color of materialSpecular.
	 * 
	 * @param aColorValue java.awt.Color
	 */
	public void materialSpecular_(Color aColorValue) {
	}

	/**
	 * Call glMaterial() of OpenGL with color of materialSpecular with alpha.
	 * 
	 * @param aColorValue java.awt.Color
	 * @param aNumber float
	 */
	public void materialSpecular_alpha_(Color aColorValue, float aNumber) {
	}

	/**
	 * Answer 3d-point as normalUnitVector of 3d-points.
	 * 
	 * @param anArrayOfPoints sra.jun.geometry.basic.Jun3dPoint[]
	 * 
	 * @return sra.jun.geometry.basic.Jun3dPoint
	 */
	public Jun3dPoint normalUnitVectorOfPoints_(Jun3dPoint[] anArrayOfPoints) {
		//1,1,1 / 3 sqrt
		return new Jun3dPoint(0.57735027955204d, 0.57735027955204d, 0.57735027955204d);
	}

	/**
	 * Answer 3d-point as normalVector of 3d-points.
	 * 
	 * @param anArrayOfPoints sra.jun.geometry.basic.Jun3dPoint[]
	 * 
	 * @return sra.jun.geometry.basic.Jun3dPoint
	 */
	public Jun3dPoint normalVectorOfPoints_(Jun3dPoint[] anArrayOfPoints) {
		return new Jun3dPoint(1, 1, 1);
	}

	/**
	 * Call glColor4() of OpenGL with color of paint with number of alpha.
	 * 
	 * @param aPaint java.awt.Color
	 * @param aNumber float
	 */
	public void paint_alpha_(Color aPaint, float aNumber) {
		paint = aPaint;
		alpha = aNumber;
	}

	/**
	 * Call the glHint() of OpenGL with polygonSmoothDontCare.
	 */
	public void polygonSmoothDontCare() {
	}

	/**
	 * Call the glHint() of OpenGL with polygonSmoothFastest.
	 */
	public void polygonSmoothFastest() {
	}

	/**
	 * Call the glHint() of OpenGL with polygonSmoothNicest.
	 */
	public void polygonSmoothNicest() {
	}

	/**
	 * Call the glPolygonStipple() of OpenGL with a JunOpenGLStipple.
	 * 
	 * @param aJunOpenGLStipple sra.jun.opengl.texture.JunOpenGLStipple
	 */
	public void polygonStipple_(JunOpenGLStipple aJunOpenGLStipple) {
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return int
	 */
	public int selectionBufferSize() {
		return selectionBufferSize;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param anInteger int
	 */
	public void selectionBufferSize_(int anInteger) {
		selectionBufferSize = anInteger;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aBlock DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public int selectNearestObjectWhile_(StBlockClosure aBlock) {
		int handle;
		int status;
		int bufferSize = this.selectionBufferSize();
		int[] selectionBuffer = new int[bufferSize];
		handle = OpenGLInterface.glSelectBufferStart(selectionBuffer);

		try {
			OpenGLInterface.glRenderMode(OpenGLInterface.GL_SELECT);
			OpenGLInterface.glPushName(0);
			aBlock.value();
			status = OpenGLInterface.glRenderMode(OpenGLInterface.GL_RENDER);
		} finally {
			OpenGLInterface.glSelectBufferEnd(selectionBuffer, handle);
		}

		int maxIndex = (status != -1) ? status : bufferSize;
		int pickedIndex = 0;
		int pickedDepth = this.maxID();
		int index = 1;
		int offset = 0;

		while (index <= maxIndex) {
			int numNames = selectionBuffer[offset];
			int minDepth = selectionBuffer[offset + 1];
			int name = selectionBuffer[offset + 3];

			if (minDepth < pickedDepth) {
				pickedIndex = name;
				pickedDepth = minDepth;
			}

			offset = offset + 3 + numNames;
			index = index + 1;
		}

		return pickedIndex - 1;
	}

	/**
	 * Set color (id) to OpenGL.
	 * 
	 * @param anInteger lintg
	 */
	public void setId_(int anInteger) {
		OpenGLInterface.glLoadName(Modulo(anInteger + 1, this.maxID()));
	}

	/**
	 * Call the glShadeModel() of OpenGL with smooth.
	 */
	public void smoothShading() {
	}

	/**
	 * Set the texture.
	 * 
	 * @param aJunOpenGLTexture sra.jun.opengl.texture.JunOpenGLTexture
	 */
	public void texture_(JunOpenGLTexture aJunOpenGLTexture) {
	}

	/**
	 * Asnwer the max int.
	 * 
	 * @return int
	 */
	private int maxID() {
		// OpenGLInterface GLuint baseType maxVal (4294967295L)
		return 2147483647;
	}
}
