package sra.jun.opengl.rotation;

import java.awt.*;
import sra.jun.geometry.basic.Jun2dPoint;
import sra.smalltalk.StView;

/**
 * JunOpenGLRotationView interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/20 (by MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLRotationView.java,v 6.0 2003/10/28 10:52:21 nisinaka Exp $
 */
public interface JunOpenGLRotationView extends StView {

	/**
	 * Answer the de-scaled vertex at the specified Point.
	 * 
	 * @param aPoint java.awt.Point
	 * 
	 * @return sra.jun.geometry.basic.Jun2dPoint
	 */
	public Jun2dPoint descaledPoint_(Point aPoint);

	/**
	 * Answer the scaled point of the Jun2dPoint.
	 * 
	 * @param aJun2dPoint sra.jun.geometry.basic.Jun2dPoint
	 * 
	 * @return java.awt.Point
	 */
	public Point scaledPoint_(Jun2dPoint aJun2dPoint);

	/**
	 * Answer the index of the vertex at the specified point. If there is no
	 * such vertex, return -1.
	 * 
	 * @param aPoint java.awt.Point
	 * 
	 * @return int
	 */
	public int scaledVertexIndex_(Point aPoint);
}
