package sra.jun.opengl.support;

import java.awt.*;
import sra.jun.geometry.basic.*;
import sra.jun.opengl.display.*;
import sra.jun.opengl.lights.*;
import sra.jun.opengl.objects.*;
import sra.jun.opengl.projection.*;
import sra.jun.opengl.texture.*;

/**
 * JunOpenGLRenderingContextTestExamples class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/04/07 (MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLRenderingContextTestExamples.java,v 6.0 2003/10/28 10:52:21 nisinaka Exp $
 */
public class JunOpenGLRenderingContextTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGLRenderingContextTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample1a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				renderingContext.paint_(Color.red);
				aProjector.projectOn_(renderingContext);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample1b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				anObject.paint_(Color.red);
				aProjector.projectOn_(renderingContext);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample2a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				Image anImage;
				JunOpenGLTexture aTexture;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				anImage = JunOpenGLTextureTestExamples.ImageSmalltalkBalloon();
				aTexture = JunOpenGLTexture.Image_(anImage);
				aTexture.coordinates_(new Jun2dPoint[] { new Jun2dPoint(0.0, 0.0), new Jun2dPoint(1.0, 0.0), new Jun2dPoint(1.0, 1.0), new Jun2dPoint(0.0, 1.0)});
				renderingContext.texture_(aTexture);
				renderingContext.enableTexture2d();
				aProjector.projectOn_(renderingContext);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample2b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				Image anImage;
				JunOpenGLTexture aTexture;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				anImage = JunOpenGLTextureTestExamples.ImageSmalltalkBalloon();
				aTexture = JunOpenGLTexture.Image_(anImage);
				aTexture.coordinates_(new Jun2dPoint[] { new Jun2dPoint(0.0, 0.0), new Jun2dPoint(1.0, 0.0), new Jun2dPoint(1.0, 1.0), new Jun2dPoint(0.0, 1.0)});
				aProjector.projectOn_(renderingContext);
				anObject.texture_(aTexture);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample3a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLStipple aStipple;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				aStipple = JunOpenGLStipple.Halftone();
				renderingContext.polygonStipple_(aStipple);
				renderingContext.enablePolygonStipple();
				aProjector.projectOn_(renderingContext);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample3b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLStipple aStipple;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.clear();
				aStipple = JunOpenGLStipple.Halftone();
				anObject.stipple_(aStipple);
				aProjector.projectOn_(renderingContext);
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample4a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLParallelLight aLight;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aLight = JunOpenGLParallelLight.At3dPoint_color_(new Jun3dPoint(0, 0, 10), Color.white);
				aProjector.addLight_(aLight);
				anObject = JunOpenGL3dObject.Sphere();
				anObject.paint_(Color.red);
				renderingContext.clear();
				renderingContext.materialSpecular_(Color.green);
				renderingContext.materialShininess_(2.0f);
				aProjector.project_on_(anObject, renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample4b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLParallelLight aLight;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				aLight = JunOpenGLParallelLight.At3dPoint_color_(new Jun3dPoint(0, 0, 10), Color.white);
				aProjector.addLight_(aLight);
				anObject = JunOpenGL3dObject.Sphere();
				anObject.paint_(Color.red);
				renderingContext.clear();
				renderingContext.materialEmission_(Color.blue);
				aProjector.project_on_(anObject, renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample5a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjection aProjection;
				JunOpenGL3dObject anObject;

				aProjection = JunOpenGLProjection.Default();
				aProjection.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjection.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjection.upVector_(new Jun3dPoint(0, 0, 1));
				aProjection.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.red);
				renderingContext.clear();
				renderingContext.perspective_(aProjection.asPerspective());
				anObject.renderOn_(renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample5b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.red);
				renderingContext.clear();
				aProjector.parallelProjection();
				aProjector.project_on_(anObject, renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample6a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				renderingContext.clear();
				aProjector.projectOn_(renderingContext);
				renderingContext.paint_(Color.red);
				renderingContext.displayPolygon_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample6b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(final JunOpenGLRenderingContext renderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.red);
				renderingContext.clear();
				aProjector.project_on_(anObject, renderingContext);
				renderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample7a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.lightGray);
				aRenderingContext.clear();
				aProjector.projectOn_(aRenderingContext);
				aRenderingContext.lightAmbientColor_alpha_twoSide_(Color.red, 1.0f, false);
				aRenderingContext.enableLighting();
				anObject.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample7b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLLight aLight;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.lightGray);
				aRenderingContext.clear();
				aLight = JunOpenGLAmbientLight.Color_(Color.red);
				aProjector.addLight_(aLight);
				aProjector.project_on_(anObject, aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample8a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				int index;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.lightGray);
				aRenderingContext.clear();
				aProjector.projectOn_(aRenderingContext);
				index = aRenderingContext.getLightIndex();
				aRenderingContext.lightIndex_position_parallel_color_alpha_(index, new Jun3dPoint(0.0, 0.0, 5.0), true, Color.red, 1.0f);
				aRenderingContext.enableLightIndex_(index);
				aRenderingContext.enableLighting();
				anObject.renderOn_(aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean ManualExample8b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject anObject;
				JunOpenGLLight aLight;

				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(3, 3, 3));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0.5));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.viewFactor_(10);
				anObject = JunOpenGL3dPolygon.Vertexes_(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
				anObject.paint_(Color.lightGray);
				aRenderingContext.clear();
				aLight = JunOpenGLParallelLight.At3dPoint_color_(new Jun3dPoint(0.0d, 0.0d, 5.0d), Color.red);
				aProjector.addLight_(aLight);
				aProjector.project_on_(anObject, aRenderingContext);
				aRenderingContext.flush();
			}
		}
		.open();

		return true;
	}
}
