package sra.jun.opengl.texture;

import java.awt.Color;
import sra.jun.geometry.basic.*;
import sra.jun.opengl.objects.*;
import sra.jun.system.support.*;

/**
 * JunOpenGLStippleTestExamples class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1998/11/19 (by Hirotsugu Kondo)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLStippleTestExamples.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public class JunOpenGLStippleTestExamples extends JunTestExamples {

	/**
	 * Example:
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunOpenGLStipple aStipple = JunOpenGLStipple.Halftone_(0.5);
		Jun3dPoint[] points = new Jun3dPoint[4];
		points[0] = new Jun3dPoint(0.0, 0.0, 1.0);
		points[1] = new Jun3dPoint(1.0, 0.0, 1.0);
		points[2] = new Jun3dPoint(1.0, 1.0, 1.0);
		points[3] = new Jun3dPoint(0.0, 1.0, 1.0);

		JunOpenGL3dPolygon aPolygon = JunOpenGL3dPolygon.Vertexes_(points);
		aPolygon.name_("example");
		aPolygon.paint_(Color.blue);
		aPolygon.stipple_(aStipple);
		aPolygon.show();

		return true;
	}

	/**
	 * Example:
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		Jun3dPoint[] points = new Jun3dPoint[4];
		points[0] = new Jun3dPoint(0.0, 0.0, 1.0);
		points[1] = new Jun3dPoint(1.0, 0.0, 1.0);
		points[2] = new Jun3dPoint(1.0, 1.0, 1.0);
		points[3] = new Jun3dPoint(0.0, 1.0, 1.0);

		for (int each = 1; each < 9; each++) {
			JunOpenGL3dPolygon aPolygon = JunOpenGL3dPolygon.Vertexes_(points);
			aPolygon.name_("example");
			aPolygon.paint_(Color.red);

			JunOpenGLStipple aStipple = JunOpenGLStipple.Halftone_(each / 8.0);
			System.out.print(each / 8.0);
			aPolygon.stipple_(aStipple);
			aPolygon.show();
		}

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunOpenGLStippleTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1() {
		JunOpenGL3dPolygon aPolygon;
		JunOpenGL3dObject aSphere;
		JunOpenGL3dCompoundObject aCompoundObject;

		aPolygon = new JunOpenGL3dPolygon(new Jun3dPoint[] { new Jun3dPoint(0.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 0.0d, 1.0d), new Jun3dPoint(1.0d, 1.0d, 1.0d), new Jun3dPoint(0.0d, 1.0d, 1.0d)});
		aPolygon.paint_(Color.red);
		aPolygon.halftone_(0.5f);
		aSphere = JunOpenGL3dObject.Sphere_radius_center_(15, 0.5, new Jun3dPoint(0.5, 0.5, 0.5));
		aSphere.paint_(Color.green);
		aCompoundObject = JunOpenGL3dCompoundObject.With_with_(aPolygon, aSphere);
		aCompoundObject.show();

		return true;
	}
}
