package sra.jun.solid.abstracts;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.threeDImage.support.Jun3dGraphicsContext;
import sra.smalltalk.StObject;

/**
 * JunSolid class
 * 
 *  @author    kondo
 *  @created   1999/09/08 (by kondo)
 *  @updated   1999/10/18 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSolid.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public abstract class JunSolid extends StObject {

	/**
	 * Answer true if the receiver contains the specified point, otherwise
	 * false.
	 * 
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return boolean
	 */
	public abstract boolean containsPoint_(sra.jun.geometry.basic.Jun3dPoint a3dPoint);

	/**
	 * Display the receiver on a specified graphics context.
	 * 
	 * @param aGraphicsContext sra.jun.threeDImage.support.Jun3dGraphicsContext
	 */
	public void displayOn_(Jun3dGraphicsContext aGraphicsContext) {
		aGraphicsContext.displaySolid_at_(this, Jun3dPoint.Zero());
	}

	/**
	 * Display the receiver on a specified graphics context.
	 * 
	 * @param aGraphicsContext sra.jun.threeDImage.support.Jun3dGraphicsContext
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 */
	public void displayOn_at_(Jun3dGraphicsContext aGraphicsContext, Jun3dPoint aJun3dPoint) {
		aGraphicsContext.displaySolid_at_(this, aJun3dPoint);
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public abstract double valueAt_(Jun3dPoint aJun3dPoint);
}
