package sra.jun.system.framework;

import sra.smalltalk.StSimpleDialog;

/**
 * JunDialog class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/03/17 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on Jun467 for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDialog.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public class JunDialog extends StSimpleDialog {

	/**
	 * Show the dialog for confirming.
	 *
	 * @return boolean
	 * @param messageString java.lang.String
	 */
	public static boolean Confirm_(String messageString) {
		return Confirm_(messageString, true);
	}

	/**
	 * Show the dialog for confirming.
	 *
	 * @return boolean
	 * @param messageString java.lang.String
	 * @param initialAnswer boolean
	 */
	public static boolean Confirm_(String messageString, boolean initialAnswer) {
		JunDialog aDialog = new JunDialog();
		Object result = aDialog.choose_labels_values_default_(messageString, new String[] { "Yes", "No" }, new Object[] { Boolean.TRUE, Boolean.FALSE }, new Boolean(initialAnswer));
		return ((Boolean) result).booleanValue();
	}

	/**
	 * Show the dialog for requesting a user input.
	 *
	 * @return java.lang.String
	 * @param messageString java.lang.String
	 */
	public static String Request_(String messageString) {
		return Request_(messageString, new String());
	}

	/**
	 * Show the dialog for requesting a user input.
	 *
	 * @return java.lang.String
	 * @param messageString java.lang.String
	 * @param aString java.lang.String
	 */
	public static String Request_(String messageString, String aString) {
		JunDialog aDialog = new JunDialog();
		return (String) aDialog.request_initialAnswer_onCancel_(messageString, aString, null);
	}

	/**
	 * Show the dialog for warning.
	 *
	 * @return java.lang.Object
	 * @param messageString java.lang.String
	 */
	public static Object Warn_(String messageString) {
		JunDialog aDialog = new JunDialog();
		aDialog.choose_labels_values_default_(messageString, new String[] { "Accept" }, new Object[] { null }, null);
		return null;
	}

	/**
	 * Answer the string for the accept button label.
	 *
	 * @return java.lang.String
	 */
	protected String _acceptButtonLabelString() {
		return "Accept";
	}
}
