package sra.jun.system.support;

import java.awt.Dimension;
import sra.smalltalk.*;

/**
 * JunLauncherView interface
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/03/20 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLauncherView.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public interface JunLauncherView extends StView {

	/**
	 * Open a dialog.
	 *
	 * @param java.lang.String title
	 * @param java.lang.Object visual
	 * @param java.awt.Dimension size
	 */
	public void _openDialog_(final String title, final Object visual, final Dimension size);

	/**
	 * Open a text viewer.
	 *
	 * @param java.lang.String title
	 * @param java.lang.String message
	 * @param java.awt.Dimension size
	 */
	public void _openTextViewer_(final String title, final String message, final Dimension size);
}
