package sra.jun.system.support;

import java.awt.*;
import java.awt.event.*;
import sra.jun.goodies.display.*;
import sra.smalltalk.*;

/**
 * JunLauncherViewAwt class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/11/11 (by MATSUDA Ryouichi)
 *  @updated   2002/11/21 (by nisinaka)
 *  @updated   2003/03/19 (by nisinaka)
 *  @updated   2003/03/20 (by Mitsuhiro Asada)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLauncherViewAwt.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public class JunLauncherViewAwt extends JunDisplayViewAwt implements JunLauncherView {

	/**
	 * Create a new instance of JunLauncherViewAwt and initialize it.
	 * 
	 * @param aLauncher sra.jun.system.support.JunLauncher
	 */
	public JunLauncherViewAwt(JunLauncher aLauncher) {
		super(aLauncher);
	}

	/**
	 * Open a dialog.
	 *
	 * @param java.lang.String title
	 * @param java.lang.Object visual
	 * @param java.awt.Dimension size
	 */
	public void _openDialog_(final String title, final Object visual, final Dimension size) {
		JunDisplayModel aModel = new JunDisplayModel(visual);
		aModel._isScrollable(false);
		JunDisplayViewAwt aComponent = new JunDisplayViewAwt(aModel);

		Frame aFrame = new Frame(title);
		aFrame.add(aComponent);
		aFrame.pack();
		aFrame.setResizable(false);
		if (size != null) {
			aFrame.setSize(size);
		}
		aFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				e.getWindow().dispose();
			}
		});
		aFrame.pack();

		StApplicationModel._ShowAtCenterPoint(aFrame);
	}

	/**
	 * Open a text viewer.
	 *
	 * @param java.lang.String title
	 * @param java.lang.String message
	 * @param java.awt.Dimension size
	 */
	public void _openTextViewer_(final String title, final String message, final Dimension size) {
		TextArea aTextArea = new TextArea(message, 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY) {
			public Dimension getPreferredSize() {
				return size;
			}
		};
		aTextArea.setFont(new Font("Monospaced", Font.PLAIN, 12));
		aTextArea.setBackground(Color.white);
		aTextArea.setEditable(false);

		Frame aFrame = new Frame(title);
		aFrame.add(aTextArea);
		aFrame.pack();
		aFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				e.getWindow().dispose();
			}
		});

		StApplicationModel._ShowAtCenterPoint(aFrame);
	}

	/**
	 * Build this component.
	 */
	protected void buildComponent() {
		super.buildComponent();

		this.canvas().setBackground(Color.white);
	}
}
