package sra.jun.terrain.display;

import java.awt.*;
import java.awt.event.MouseEvent;
import sra.jun.goodies.cursors.JunCursors;
import sra.jun.opengl.display.JunOpenGLDisplayView;
import sra.jun.opengl.microcosm.JunOpenGLMicrocosmController;
import sra.smalltalk.StSymbol;

/**
 * JunTerrainDisplayController class
 * 
 *  @author    nisinaka
 *  @created   2002/01/22 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTerrainDisplayController.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public class JunTerrainDisplayController extends JunOpenGLMicrocosmController {
	protected Cursor _savedCursor;

	/**
	 * Invoked when a mouse is entered on a component.
	 * 
	 * @param e java.awt.event.MouseEvent
	 */
	public void mouseEntered(MouseEvent e) {
		StSymbol state = ((JunTerrainDisplayModel) this.model()).buttonState();

		if (state == null) {
			return;
		}

		Component theView = (Component) ((JunOpenGLDisplayView) this.view()).getOpenGLView();
		_savedCursor = theView.getCursor();

		if (state == $("pick")) {
			theView.setCursor(JunCursors.CrossCursor());
		} else if (state == $("grab")) {
			theView.setCursor(JunCursors.ReadCursor());
		} else if (state == $("drag")) {
			theView.setCursor(JunCursors.QuartersCursor());
		} else if (state == $("focus")) {
			theView.setCursor(JunCursors.GlassCursor());
		}
	}

	/**
	 * Invoked when a mouse is exited on a component.
	 * 
	 * @param e java.awt.event.MouseEvent
	 */
	public void mouseExited(MouseEvent e) {
		((Component) ((JunOpenGLDisplayView) this.view()).getOpenGLView()).setCursor(_savedCursor);
	}
}
