package sra.jun.terrain.display;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.opengl.projection.*;

/**
 * JunTerrainProjection class
 * 
 *  @author    nisinaka
 *  @created   2002/01/22 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTerrainProjection.java,v 6.0 2003/10/28 10:52:22 nisinaka Exp $
 */
public class JunTerrainProjection extends JunOpenGLPerspective {

	/**
	 * Create a new default projection and answer it.
	 * 
	 * @return sra.jun.opengl.projection.JunOpenGLProjection
	 */
	public static JunOpenGLProjection Default() {
		JunTerrainProjection projection = new JunTerrainProjection();
		projection.setEyePoint_sightPoint_upVector_fovy_near_far_(DefaultEyePoint(), DefaultSightPoint(), DefaultUpVector(), DefaultFovy(), DefaultNear(), DefaultFar());

		return projection;
	}

	/**
	 * Set my eye point.
	 * 
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 */
	public void eyePoint_(Jun3dPoint a3dPoint) {
		eyePoint = a3dPoint;
		this.normalizeUpVector();
	}

	/**
	 * Set my sight point.
	 * 
	 * @param a3dPoint sra.jun.geometry.basic.Jun3dPoint
	 */
	public void sightPoint_(Jun3dPoint a3dPoint) {
		sightPoint = a3dPoint;
		this.normalizeUpVector();
	}
}
