package sra.jun.topology.abstracts;

import sra.jun.topology.elements.JunBody;

/**
 * JunTopologicalElementOrProxy interface
 * 
 *  @author    nisinaka
 *  @created   1998/11/06 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTopologicalElementOrProxy.java,v 6.0 2003/10/28 10:52:24 nisinaka Exp $
 */
public interface JunTopologicalElementOrProxy {

	/**
	 * Convert the receiver as a proxy in aBody.
	 * 
	 * @param aBody sra.jun.topology.elements.JunBody
	 * @param aTopologicalElementProxy
	 *        sra.jun.topology.abstracts.JunTopologicalElementProxy
	 * 
	 * @return sra.jun.topology.abstracts.JunTopologicalElementProxy
	 */
	JunTopologicalElementProxy asProxyIn_advise_(JunBody aBody, JunTopologicalElementProxy aTopologicalElementProxy);

	/**
	 * Answer true if the receiver is a kind of geometry, otherwise false.
	 * 
	 * @return boolean
	 */
	boolean isTopologicalProxy();
}
