package sra.jun.topology.elements;

import sra.jun.geometry.basic.*;

/**
 * JunBodyTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1999/01/05 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBodyTestExamples.java,v 6.0 2003/10/28 10:52:24 nisinaka Exp $
 */
public class JunBodyTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunBodyTestExamples();
	}

	/**
	 * Test for JunBody#RotationSweep2dPoints_divisions_(Jun2dPoint[], int).
	 * 
	 * @return boolean
	 */
	public static boolean Test1() {
		int divisions = 30;
		Jun2dPoint[] points = new Jun2dPoint[divisions + 1];

		for (int i = 0; i <= divisions; i++) {
			JunAngle angle = JunAngle.FromDeg_((360 * i) / divisions);
			points[i] = new Jun2dPoint(angle.cos(), angle.sin() + 2.0d);
		}

		JunBody body = JunBody.RotationSweep2dPoints_divisions_(points, divisions);
		body.show();

		return false;
	}

	/**
	 * Test for JunBody#copy().
	 * 
	 * @return boolean
	 */
	public static boolean Test2() {
		Jun3dPoint[] points = { new Jun3dPoint(0, 0, 0), new Jun3dPoint(1.5, 0, 0), new Jun3dPoint(0, 1.5, 0), new Jun3dPoint(0, 0, 1.5)};
		JunBody body = JunBody.Tetrahedron_(points);
		body.showLispList();

		JunBody body2 = (JunBody) body.copy();
		body2.asJunOpenGL3dObject().show();

		return false;
	}
}
