package sra.jun.topology.euleroperators;

import sra.jun.geometry.basic.*;
import sra.jun.system.support.*;
import sra.jun.topology.elements.*;

/**
 * JunKVETestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKVETestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunKVETestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean example1() {
		/*        "JunKVE example1"
		*
		*        | mevvl body v000 v001 edge000001 mve mev1 v010 edge001010 mev2 v100 edge010100 loop1 mel edge100000 loop2 |
		*        body := JunBody new.
		*         mevvl := JunMEVVL
		*                                body: body
		*                                point: 0 , 0 , 0
		*                         point: 0 , 0 , 1.
		*         mevvl do.
		*        v000 := mevvl vertex1.
		*        v001 := mevvl vertex2.
		*        edge000001 := mevvl edge.
		*        loop1 := mevvl loop.
		*        edge000001 yourself.
		*        mev1 := JunMEV
		*                                body: body
		*                                vertex: v001
		*                                loop: loop1
		*                                point: 0 , 1 , 0.
		*        mev1 do.
		*        v010 := mev1 vertex1.
		*        edge001010 := mev1 edge.
		*        edge001010 yourself.
		*        mev2 := JunMEV
		*                                body: body
		*                                vertex: v010
		*                                loop: loop1
		*                                point: 1 , 0 , 0.
		*        mev2 do.
		*        v100 := mev2 vertex1.
		*        edge010100 := mev2 edge.
		*        edge010100 yourself.
		*        mel := JunMEL
		*                                body: body
		*                                loop: loop1
		*                                vertex: v100
		*                                vertex: v000.
		*        mel do.
		*        edge100000 := mel edge.
		*        loop2 := mel loop1.
		*        edge100000 yourself.
		*        loop2 yourself.
		*        mve := JunMVE
		*                                body: body
		*                                edge: edge001010
		*                                point: 1 , 1 , 1.
		*        mve do.
		*        "100
		*                timesRepeat:
		*                        [| kve |
		*                        kve := mve inverse.
		*                        kve do.
		*                        mve := kve inverse.
		*                        mve do]."
		*        100
		*                timesRepeat:
		*                        [mve undo.
		*                        mve do].
		*        ^mve! !
		*/
		JunMEVVL mevvl;
		JunBody body;
		JunVertex v000;
		JunVertex v001;
		JunEdge edge000001;
		JunMVE mve;
		JunMEV mev1;
		JunVertex v010;
		JunEdge edge001010;
		JunMEV mev2;
		JunVertex v100;
		JunEdge edge010100;
		JunLoop loop1;
		JunMEL mel;
		JunEdge edge100000;
		JunLoop loop2;
		JunKVE kve;
		int i;

		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();
		v000 = mevvl.vertex1();
		v001 = mevvl.vertex2();
		edge000001 = mevvl.edge();
		loop1 = mevvl.loop();

		//edge000001.yourself();
		mev1 = JunMEV.Body_vertex_loop_point_(body, v001, loop1, new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		v010 = mev1.vertex1();
		edge001010 = mev1.edge();

		//edge001010.yourself();
		mev2 = JunMEV.Body_vertex_loop_point_(body, v010, loop1, new Jun3dPoint(1, 0, 0));
		mev2.doOperation();
		v100 = mev2.vertex1();
		edge010100 = mev2.edge();

		//edge010100.yourself();
		mel = JunMEL.Body_loop_vertex_vertex_(body, loop1, v100, v000);
		mel.doOperation();
		edge100000 = mel.edge();
		loop2 = mel.loop1();

		//edge100000.yourself();
		//loop2.yourself();
		mve = JunMVE.Body_edge_point_(body, edge001010, new Jun3dPoint(1, 1, 1));
		mve.doOperation();

		/*JunBody Junbody=mve.body();
		JunLoop[] temploop=mve.body().loops();
		JunLoop looptemp=temploop[0];
		JunEdge[] tempedge=temploop[0].edges();*/
		/*for(i=0;i<100;i++)
		{
		kve=(JunKVE)(mve.inverse());
		kve.doOperation();
		mve=(JunMVE)(kve.inverse());
		mve.doOperation();
		}*/
		for (i = 0; i < 1; i++) {
			mve.undoOperation();
			mve.doOperation();
		}

		mve.body().show();

		//	return mve;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunKVETestExamples();
	}
}
