package sra.jun.topology.euleroperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.topology.elements.*;

/**
 * JunMEKLTestExamples class
 * 
 *  @author    BNR, ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMEKLTestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunMEKLTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunBody body;
		JunVertex v000;
		JunVertex v100;
		JunLoop loop0_0;
		JunVertex v010;
		JunVertex v001;
		JunVertex v101;
		JunLoop loop1_0;
		JunVertex v011;
		JunLoop loop0_1;
		JunMEVVL mevvl1;
		JunMEV mev1;
		JunMEL mel1;
		JunMEVVL mevvl2;
		JunMEV mev2;
		JunMEL mel2;
		JunMEKL mekl;
		JunMEL mel3;
		body = new JunBody();
		mevvl1 = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl1.doOperation();
		v000 = mevvl1.vertex1();
		v100 = mevvl1.vertex2();
		loop0_0 = mevvl1.loop();
		mev1 = JunMEV.Body_vertex_loop_point_(body, v100, loop0_0, new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		v010 = mev1.newVertex();
		mel1 = JunMEL.Body_loop_vertex_vertex_(body, loop0_0, v010, v000);
		mel1.doOperation();
		loop0_1 = mel1.newLoop();
		mevvl2 = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 1), new Jun3dPoint(1, 0, 1));
		mevvl2.doOperation();
		v001 = mevvl2.vertex1();
		v101 = mevvl2.vertex2();
		loop1_0 = mevvl2.loop();
		mev2 = JunMEV.Body_vertex_loop_point_(body, v101, loop1_0, new Jun3dPoint(0, 1, 1));
		mev2.doOperation();
		v011 = mev2.newVertex();
		mel2 = JunMEL.Body_loop_vertex_vertex_(body, loop1_0, v011, v001);
		mel2.doOperation();
		mekl = JunMEKL.Body_loop_loop_vertex_vertex_(body, loop0_1, loop1_0, v000, v001);
		mekl.doOperation();
		mel3 = JunMEL.Body_loop_vertex_vertex_(body, mekl.aliveLoop(), v100, v101);
		mel3.doOperation();

		int i;
		JunVertex[] tempVertex = mel3.loop2().vertexes();

		for (i = 0; i < tempVertex.length; i++) {
			if (tempVertex[i] == v010) {
				(JunMEL.Body_loop_vertex_vertex_(body, mel3.loop2(), v010, v011)).doOperation();

				break;
			}
		}

		if (i == tempVertex.length) {
			(JunMEL.Body_loop_vertex_vertex_(body, mel3.loop1(), v010, v011)).doOperation();
		}

		body.show();

		//#?# mekl
		System.out.println("-------- #edge3");
		System.out.println(mekl.edge3());
		System.out.println("-------- #edge2");
		System.out.println(mekl.edge2());
		System.out.println("-------- #vertex2");
		System.out.println(mekl.vertex2());
		System.out.println("-------- #vertex1");
		System.out.println(mekl.vertex1());
		System.out.println("-------- #killedLoop");
		System.out.println(mekl.killedLoop());
		System.out.println("-------- #aliveLoop");
		System.out.println(mekl.aliveLoop());
		System.out.println("-------- #newEdge");
		System.out.println(mekl.newEdge());

		/*if((mel3.loop2().vertexes().includes_(v010))==true)
		{
		(JunMEL.Body_loop_vertex_vertex_(body,mel3.loop2(), 
		v010, v011)).doOperation();
		}
		else
		{
		(JunMEL.Body_loop_vertex_vertex_(body, 
		mel3.loop1(), v010, v011)).doOperation();
		}*/
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunMEKLTestExamples();
	}
}
