package sra.jun.topology.euleroperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.topology.elements.*;
import sra.jun.topology.geometricoperators.JunTV;

/**
 * JunMVETestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMVETestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunMVETestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunMEVVL mevvl;
		JunBody body;
		JunVertex v000;
		JunVertex v550;
		JunEdge edge;
		JunMVE mve;
		JunMEV mev;
		JunVertex v010;
		JunVertex v100;
		JunLoop loop;
		JunMEL mel;
		JunTV tv;
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();
		loop = mevvl.newLoop();
		edge = mevvl.newEdge();
		v100 = mevvl.newVertex1();
		v010 = mevvl.newVertex2();
		mev = JunMEV.Body_vertex_loop_point_(body, v100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		v000 = mev.newVertex();
		mel = JunMEL.Body_loop_vertex_vertex_(body, loop, v010, v000);
		mel.doOperation();
		mve = JunMVE.Body_edge_point_newEdgeOnVertex_(body, edge, new Jun3dPoint(0.5, 0.5, 0), v100);
		mve.doOperation();
		body.show();
		v550 = mve.newVertex();
		tv = JunTV.Body_vertex_vector_(body, v550, new Jun3dPoint(0.5, 0.5, 0));
		tv.doOperation();
		body.show();

		//#?# mve #newVertex #newEdge #edge2 #point
		System.out.println("-------- #point");
		System.out.println(mve.point());
		System.out.println("-------- #edge2");
		System.out.println(mve.edge2());
		System.out.println("-------- #newEdge");
		System.out.println(mve.newEdge());
		System.out.println("-------- #newVertex");
		System.out.println(mve.newVertex());

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		JunMEVVL mevvl;
		JunBody body;
		JunVertex v000;
		JunVertex v001;
		JunEdge edge000001;
		JunMVE mve;
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();
		v000 = mevvl.vertex1();
		v001 = mevvl.vertex2();

		//	v000.yourself();
		//	v001.yourself();
		edge000001 = mevvl.edge();
		mve = JunMVE.Body_edge_point_(body, edge000001, new Jun3dPoint(0, 1, 0));
		mve.doOperation();
		body.show();

		//return mve;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example3() {
		JunMEVVL mevvl;
		JunBody body;
		JunVertex v000;
		JunVertex v001;
		JunEdge edge000001;
		JunMVE mve;
		JunMEV mev1;
		JunVertex v010;
		JunEdge edge001010;
		JunMEV mev2;
		JunVertex v100;
		JunEdge edge010100;
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();
		v000 = mevvl.vertex1();
		v001 = mevvl.vertex2();
		edge000001 = mevvl.edge();

		//	v000.yourself();
		// 	v001.yourself();
		// 	edge000001.yourself();
		mev1 = JunMEV.Body_vertex_loop_point_(body, v001, mevvl.loop(), new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		v010 = mev1.vertex1();
		edge001010 = mev1.edge();

		//	v010.yourself();
		// 	edge001010.yourself();
		mev2 = JunMEV.Body_vertex_loop_point_(body, v010, mevvl.loop(), new Jun3dPoint(1, 0, 0));
		mev2.doOperation();
		v100 = mev2.vertex1();
		edge010100 = mev2.edge();

		//	v100.yourself();
		//	edge010100.yourself();
		mve = JunMVE.Body_edge_point_(body, edge001010, new Jun3dPoint(1, 1, 1));
		mve.doOperation();
		body.show();

		//return mve;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example4() {
		JunMEVVL mevvl;
		JunBody body;
		JunVertex v000;
		JunVertex v001;
		JunEdge edge000001;
		JunMVE mve;
		JunMEV mev1;
		JunVertex v010;
		JunEdge edge001010;
		JunMEV mev2;
		JunVertex v100;
		JunEdge edge010100;
		JunLoop loop1;
		JunMEL mel;
		JunEdge edge100000;
		JunLoop loop2;
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();
		v000 = mevvl.vertex1();
		v001 = mevvl.vertex2();
		edge000001 = mevvl.edge();
		loop1 = mevvl.loop();

		//	v000.yourself();
		//	v001.yourself();
		//	edge000001.yourself();
		mev1 = JunMEV.Body_vertex_loop_point_(body, v001, loop1, new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		v010 = mev1.vertex1();
		edge001010 = mev1.edge();

		// 	v010.yourself();
		//	edge001010.yourself();
		mev2 = JunMEV.Body_vertex_loop_point_(body, v010, loop1, new Jun3dPoint(1, 0, 0));
		mev2.doOperation();
		v100 = mev2.vertex1();
		edge010100 = mev2.edge();

		// 	v100.yourself();
		// 	edge010100.yourself();
		mel = JunMEL.Body_loop_vertex_vertex_(body, loop1, v100, v000);
		mel.doOperation();
		edge100000 = mel.edge();
		loop2 = mel.loop1();

		// 	edge100000.yourself();
		// 	loop2.yourself();
		mve = JunMVE.Body_edge_point_(body, edge001010, new Jun3dPoint(1, 1, 1));
		mve.doOperation();
		body.show();

		//return mve;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunMVETestExamples();
	}
}
