package sra.jun.topology.geometricoperators;

import sra.jun.collections.sequences.JunMatrix;
import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.geometry.surfaces.JunNurbsSurface;
import sra.jun.topology.elements.*;
import sra.jun.topology.euleroperators.*;

/**
 * JunMSFTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMSFTestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunMSFTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunBody body;
		JunMEVVL mevvl;
		JunMEL mel;
		JunMVE mve;
		JunMatrix matrix;
		JunNurbsSurface surface;
		JunMSF msf;
		JunLoop loop;

		//
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();
		loop = mevvl.newLoop();

		JunVertex v100 = mevvl.newVertex1();
		JunVertex v010 = mevvl.newVertex2();
		JunMEV mev = JunMEV.Body_vertex_loop_point_(body, v100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();

		JunVertex v000 = mev.newVertex();
		mel = JunMEL.Body_loop_vertex_vertex_(body, loop, v010, v000);
		mel.doOperation();
		loop = mel.newLoop();
		body.show();
		matrix = new JunMatrix(3);
		matrix._put(0, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(0, 1, new Jun3dPoint(0.5, 0, 0));
		matrix._put(0, 2, new Jun3dPoint(1, 0, 0));
		matrix._put(1, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(1, 1, new Jun3dPoint(0.3, 0.3, 0.5));
		matrix._put(1, 2, new Jun3dPoint(0.5, 0.5, 1));
		matrix._put(2, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(2, 1, new Jun3dPoint(0, 0.5, 0));
		matrix._put(2, 2, new Jun3dPoint(0, 1, 0));
		surface = JunNurbsSurface.BezierControlPoints_(matrix);
		msf = JunMSF.Body_loop_surface_(body, loop, surface);
		msf.doOperation();
		body.show();

		//#?# msf
		System.out.println("-------- #surface");
		System.out.println(msf.surface());
		System.out.println("-------- #loop");
		System.out.println(msf.loop());

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		JunBody body;
		JunMEVVL mevvl;
		JunMEL mel;
		JunMVE mve;
		JunMatrix matrix;
		JunNurbsSurface surface;
		JunMSF msf;
		JunLoop loop;

		//
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mel = JunMEL.Body_loop_vertex_vertex_(body, mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();
		loop = mel.newLoop();
		mve = JunMVE.Body_edge_point_(body, mel.newEdge(), new Jun3dPoint(0, -1, 0));
		mve.doOperation();
		body.show();
		matrix = new JunMatrix(3);
		matrix._put(0, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(0, 1, new Jun3dPoint(0.5, 0, 0));
		matrix._put(0, 2, new Jun3dPoint(1, 0, 0));
		matrix._put(1, 0, new Jun3dPoint(0.25, -0.25, 0));
		matrix._put(1, 1, new Jun3dPoint(0.375, -0.375, 1));
		matrix._put(1, 2, new Jun3dPoint(0.5, -0.5, 0));
		matrix._put(2, 0, new Jun3dPoint(0, -0.5, 0));
		matrix._put(2, 1, new Jun3dPoint(0, -0.75, 0));
		matrix._put(2, 2, new Jun3dPoint(0, -1, 0));
		surface = JunNurbsSurface.BezierControlPoints_(matrix);
		msf = JunMSF.Body_loop_surface_(body, loop, surface);
		msf.doOperation();
		body.show();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args) {
		new JunMSFTestExamples();
	}
}
