package sra.jun.topology.geometricoperators;

import java.awt.*;
import sra.jun.collections.sequences.*;
import sra.jun.geometry.basic.*;
import sra.jun.geometry.surfaces.*;
import sra.jun.opengl.objects.*;
import sra.jun.system.support.*;
import sra.jun.topology.elements.*;
import sra.jun.topology.euleroperators.*;

/**
 * JunTSFTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTSFTestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunTSFTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunBody body;
		JunMEVVL mevvl;
		JunMEL mel;
		JunMVE mve;
		JunMatrix matrix;
		JunNurbsSurface surface;
		JunMSF msf;
		JunLoop loop;
		JunTSF tsf;
		JunOpenGL3dObject object;

		//
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mel = JunMEL.Body_loop_vertex_vertex_(body, mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();
		loop = mel.newLoop();
		mve = JunMVE.Body_edge_point_(body, mel.newEdge(), new Jun3dPoint(0, -1, 0));
		mve.doOperation();
		matrix = new JunMatrix(3);
		matrix._put(0, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(0, 1, new Jun3dPoint(0.5, 0, 0));
		matrix._put(0, 2, new Jun3dPoint(1, 0, 0));
		matrix._put(1, 0, new Jun3dPoint(0.25, -0.25, 0));
		matrix._put(1, 1, new Jun3dPoint(0.375, -0.375, 1));
		matrix._put(1, 2, new Jun3dPoint(0.5, -0.5, 0));
		matrix._put(2, 0, new Jun3dPoint(0, -0.5, 0));
		matrix._put(2, 1, new Jun3dPoint(0, -0.75, 0));
		matrix._put(2, 2, new Jun3dPoint(0, -1, 0));
		surface = JunNurbsSurface.BezierControlPoints_(matrix);
		msf = JunMSF.Body_loop_surface_(body, loop, surface);
		msf.doOperation();
		body.show();

		//
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mel = JunMEL.Body_loop_vertex_vertex_(body, mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();
		loop = mel.newLoop();
		mve = JunMVE.Body_edge_point_(body, mel.newEdge(), new Jun3dPoint(0, -1, 0));
		mve.doOperation();
		matrix = new JunMatrix(3);
		matrix._put(0, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(0, 1, new Jun3dPoint(0.5, 0, 0));
		matrix._put(0, 2, new Jun3dPoint(1, 0, 0));
		matrix._put(1, 0, new Jun3dPoint(0.25, -0.25, 0));
		matrix._put(1, 1, new Jun3dPoint(0.375, -0.375, 1));
		matrix._put(1, 2, new Jun3dPoint(0.5, -0.5, 0));
		matrix._put(2, 0, new Jun3dPoint(0, -0.5, 0));
		matrix._put(2, 1, new Jun3dPoint(0, -0.75, 0));
		matrix._put(2, 2, new Jun3dPoint(0, -1, 0));
		surface = JunNurbsSurface.BezierControlPoints_(matrix);
		msf = JunMSF.Body_loop_surface_(body, loop, surface);
		msf.doOperation();

		//body.show();
		tsf = JunTSF.Body_loop_number_vector_(body, loop, new Point(1, 1), new Jun3dPoint(0, 0, -3));
		tsf.doOperation();
		body.show();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args DOCUMENT ME!
	 */
	public static void main(String[] args) {
		new JunTSFTestExamples();
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean ManualExample1() {
		JunBody body;
		JunMEVVL mevvl;
		JunLoop loop;
		JunMEV mev;
		JunMEL mel;
		JunMatrix matrix;
		JunMSF msf;
		JunTSF tsf;
		JunNurbsSurface surface;
		JunVertex vertex100;
		JunVertex vertex010;
		JunVertex vertex000;

		body = new JunBody();

		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();
		loop = mevvl.newLoop();
		vertex100 = mevvl.newVertex1();
		vertex010 = mevvl.newVertex2();

		mev = JunMEV.Body_vertex_loop_point_(body, vertex100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		vertex000 = mev.newVertex();

		mel = JunMEL.Body_loop_vertex_vertex_(body, loop, vertex010, vertex000);
		mel.doOperation();

		matrix = new JunMatrix(3);
		matrix._put(0, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(0, 1, new Jun3dPoint(0.5, 0, 0));
		matrix._put(0, 2, new Jun3dPoint(1, 0, 0));
		matrix._put(1, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(1, 1, new Jun3dPoint(0.3, 0.3, -0.3));
		matrix._put(1, 2, new Jun3dPoint(0.5, 0.5, -0.5));
		matrix._put(2, 0, new Jun3dPoint(0, 0, 0));
		matrix._put(2, 1, new Jun3dPoint(0, 0.5, 0));
		matrix._put(2, 2, new Jun3dPoint(0, 1, 0));
		surface = JunNurbsSurface.BezierControlPoints_(matrix);

		msf = JunMSF.Body_loop_surface_(body, loop, surface);
		msf.doOperation();

		body.show();
		tsf = JunTSF.Body_loop_number_vector_(body, loop, new Point(1, 2), new Jun3dPoint(0, 0, 1));
		tsf.doOperation();
		body.show();

		System.out.println("-------- loop");
		System.out.println(tsf.loop());
		System.out.println("-------- number");
		System.out.println(tsf.number());
		System.out.println("-------- vector");
		System.out.println(tsf.vector());

		return true;
	}
}
