package sra.jun.topology.geometricoperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.topology.abstracts.*;

/*
 * @(#)JunTV.java        1.0 98/9/17
 */
import sra.jun.topology.elements.*;

/**
 * JunTV class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTV.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunTV extends JunGeometricOperator {
	protected JunVertexProxy vertexProxy;
	protected Jun3dPoint vector;

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aBody sra.jun.topology.elements.JunBody
	 * @param aVertex sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return sra.jun.topology.geometricoperators.JunTV
	 */
	public static final JunTV Body_vertex_vector_(JunBody aBody, JunTopologicalElementOrProxy aVertex, Jun3dPoint aPoint) {
		JunTV anOperator = new JunTV();
		anOperator.body_(aBody);
		anOperator.vertex_(aVertex); //Or Proxy ????
		anOperator.vector_(aPoint);

		return anOperator;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 */
	public void execute() {
		JunVertex vertex = this.vertex();
		vertex.point_((Jun3dPoint) ((vertex.point()).plus_(this.vector())));
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return sra.jun.topology.abstracts.JunAbstractOperator
	 */
	public JunAbstractOperator inverse() {
		return (JunAbstractOperator) (JunTV.Body_vertex_vector_(this.body(), vertexProxy, (Jun3dPoint) (this.vector().negated())));
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return boolean
	 */
	public boolean precondition() {
		return (this.vertex() != null && super.precondition());
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return sra.jun.geometry.basic.Jun3dPoint
	 */
	public Jun3dPoint vector() {
		return vector;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aPoint sra.jun.geometry.basic.Jun3dPoint
	 */
	public void vector_(Jun3dPoint aPoint) {
		vector = aPoint;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return sra.jun.topology.elements.JunVertex
	 */
	public JunVertex vertex() {
		return (JunVertex) this.getTopologicalElement_(vertexProxy);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aVertexOrProxy
	 *        sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void vertex_(JunTopologicalElementOrProxy aVertexOrProxy) {
		vertexProxy = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aVertexOrProxy, vertexProxy);
	}
}
