package sra.jun.topology.globaloperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.system.support.JunTestExamples;
import sra.jun.topology.elements.*;
import sra.jun.topology.euleroperators.*;

/**
 * JunADDTestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunADDTestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunADDTestExamples extends JunTestExamples {

	/**
	 * JunADD example1.
	 * 
	 * @return boolean.
	 */
	public static boolean Example1() {
		Jun3dPoint point1 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint point2 = new Jun3dPoint(-1, -1, -1);
		Jun3dPoint point3 = new Jun3dPoint(1, 1, 1);
		JunBody body1 = JunBody.GlobeLatitudes_longitudes_center_radius_(9, 18, point1, 1.5);
		JunBody body2 = JunBody.CubeOrigin_corner_(point2, point3);
		JunADD add = new JunADD(body1, body2);
		add.doOperation();
		add.body().show();

		return true;
	}

	/**
	 * JunADD example2.
	 * 
	 * @return boolean.
	 */
	public static boolean Example2() {
		Jun3dPoint point1 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint point2 = new Jun3dPoint(-1, -1, -1);
		Jun3dPoint point3 = new Jun3dPoint(1, 1, 1);
		JunBody body1 = JunBody.GlobeLatitudes_longitudes_center_radius_(9, 18, point1, 1.5);
		JunBody body2 = JunBody.CubeOrigin_corner_(point2, point3);
		JunADD add = new JunADD(body1, body2);
		add.doOperation();
		add.inverse().doOperation();
		add.body().show();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunADDTestExamples();
	}

	/**
	 * JunADD example1.
	 * 
	 * @return boolean.
	 */
	public static boolean ManualExample1() {
		JunBody body1 = new JunBody();

		//
		JunMEVVL mevvl = JunMEVVL.Body_point_point_(body1, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();

		JunLoop loop1 = mevvl.loop();
		JunVertex vertex100 = mevvl.newVertex1();
		JunVertex vertex001 = mevvl.newVertex2();

		//
		JunMEV mev = JunMEV.Body_vertex_loop_point_(body1, vertex100, loop1, new Jun3dPoint(0, 0, 0));
		mev.doOperation();

		JunVertex vertex000 = mev.newVertex();

		//
		JunMEL mel = JunMEL.Body_loop_vertex_vertex_(body1, loop1, vertex001, vertex000);
		mel.doOperation();

		//
		JunBody body2 = new JunBody();

		//
		mevvl = JunMEVVL.Body_point_point_(body2, new Jun3dPoint(0, 1, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();

		JunLoop loop2 = mevvl.loop();
		JunVertex vertex010 = mevvl.newVertex1();
		vertex001 = mevvl.newVertex2();

		//
		mev = JunMEV.Body_vertex_loop_point_(body2, vertex010, loop2, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		vertex000 = mev.newVertex();

		//
		mel = JunMEL.Body_loop_vertex_vertex_(body2, loop2, vertex001, vertex000);
		mel.doOperation();

		//
		body1.show();

		JunADD add = JunADD.Body_body_(body1, body2);
		add.doOperation();
		body1.show();

		//
		System.out.println("-------- body2");
		System.out.println(body2);

		//
		return true;
	}
}
