package sra.jun.topology.globaloperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.topology.elements.*;
import sra.jun.topology.euleroperators.*;

/**
 * JunMIRRORTestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMIRRORTestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunMIRRORTestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunBody body = new JunBody();
		JunMEVVL mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();

		JunLoop loop = mevvl.newLoop();
		JunVertex v100 = mevvl.newVertex1();
		JunVertex v010 = mevvl.newVertex2();
		JunMEV mev = JunMEV.Body_vertex_loop_point_(body, v100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();

		JunVertex v000 = mev.newVertex();
		JunMEL mel = JunMEL.Body_loop_vertex_vertex_(body, loop, v010, v000);
		mel.doOperation();
		body.show();

		JunMIRROR mr = JunMIRROR.Body_point_vector_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(1, 1, 0));
		mr.doOperation();
		body.show();

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		JunBody body;
		JunMIRROR mirror;
		JunSEPARATE separate;
		Jun3dPoint point1 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint point2 = new Jun3dPoint(1, 0, 0);
		Jun3dPoint point3 = new Jun3dPoint(0, 1, 0);
		Jun3dPoint point4 = new Jun3dPoint(0, 0, 1);
		Jun3dPoint vector = new Jun3dPoint(1, 1, 1);
		Jun3dPoint[] a3dPoint = new Jun3dPoint[4];
		a3dPoint[0] = point1;
		a3dPoint[1] = point2;
		a3dPoint[2] = point3;
		a3dPoint[3] = point4;
		body = JunBody.Tetrahedron_(a3dPoint);

		//   body = JunBody.Tetrahedron_((StArray)StArray.With_with_with_with_(StArray.class,point1,point2,point3,point4));
		body.show();
		mirror = JunMIRROR.Body_point_vector_(body, point2, vector);
		mirror.doOperation();
		body.show();

		//return mirror;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunMIRRORTestExamples();
	}
}
