package sra.jun.topology.globaloperators;

import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.topology.elements.*;
import sra.jun.topology.euleroperators.*;

/**
 * JunNEGATETestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNEGATETestExamples.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunNEGATETestExamples extends sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunMEVVL mevvl;
		JunMEV mev;
		JunMEL mel;
		JunBody body;
		JunNEGATE negate;
		JunVertex v000;
		JunVertex v100;
		JunVertex v010;
		JunLoop loop;
		body = new JunBody();
		mevvl = JunMEVVL.Body_point_point_(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();
		loop = mevvl.newLoop();
		v100 = mevvl.newVertex1();
		v010 = mevvl.newVertex2();
		mev = JunMEV.Body_vertex_loop_point_(body, v100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		v000 = mev.newVertex();
		mel = JunMEL.Body_loop_vertex_vertex_(body, loop, v010, v000);
		mel.doOperation();
		body.show();
		negate = JunNEGATE.Body_(body);
		negate.doOperation();
		negate.body().show();

		//#?# body #vertexes
		JunVertex[] vertexes = body.vertexes();

		for (int i = 0; i < vertexes.length; i++) {
			JunVertex vertex = vertexes[i];
			System.out.println("-------- #vertex");
			System.out.println(vertex);
		}

		return true;
	}

	/**
	 * JunNEGATE example2.
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		Jun3dPoint[] points = { new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0), new Jun3dPoint(0, 0, 1)};
		JunBody body = JunBody.Tetrahedron_(points);
		JunNEGATE negate = new JunNEGATE(body);
		negate.doOperation();
		body.show();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunNEGATETestExamples();
	}
}
