package sra.jun.topology.setoperators;

import java.util.Vector;
import sra.jun.topology.abstracts.JunSetOperator;
import sra.jun.topology.elements.JunBody;
import sra.jun.topology.globaloperators.JunNEGATE;
import sra.jun.topology.setoperators.JunUNION;

/**
 * JunINTER class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunINTER.java,v 6.0 2003/10/28 10:52:26 nisinaka Exp $
 */
public class JunINTER extends JunSetOperator {
	//	instanceVariableNames: 'body2 '

	/** Another JunBody on which the receiver operate. */
	protected JunBody body2;

	/**
	 * Create a new instance of JunINTER and initialize it with two bodies.
	 * 
	 * @param aBody1 sra.jun.topology.elements.JunBody
	 * @param aBody2 sra.jun.topology.elements.JunBody
	 */
	public JunINTER(JunBody aBody1, JunBody aBody2) {
		this.body_(aBody1);
		this.body2_(aBody2);
	}

	// JunINTER class methodsFor: 'instance creation'

	/**
	 * Create an instance of JunINTER with two bodies.
	 * 
	 * @param aJunBody1 sra.jun.topology.elements.JunBody
	 * @param aJunBody2 sra.jun.topology.elements.JunBody
	 * 
	 * @return sra.jun.topology.setoperators.JunINTER
	 */
	public static final JunINTER Body_body_(JunBody aJunBody1, JunBody aJunBody2) {
		return new JunINTER(aJunBody1, aJunBody2);
	}

	//!JunINTER methodsFor: 'accessing'!

	/**
	 * Answer the second body of the receiver.
	 * 
	 * @return sra.jun.topology.elements.JunBody
	 */
	public JunBody body2() {
		return body2;
	}

	/**
	 * Set the second body of the receiver.
	 * 
	 * @param aJunBody sra.jun.topology.elements.JunBody
	 * 
	 * @return DOCUMENT ME!
	 */
	public JunBody body2_(JunBody aJunBody) {
		body2 = aJunBody;

		return body2;
	}

	/**
	 * DOCUMENT ME!
	 */
	public void execute() {
		JunNEGATE negate1 = new JunNEGATE(this.body());
		negate1.doOperation();

		JunNEGATE negate2 = new JunNEGATE(this.body2());
		negate2.doOperation();

		JunUNION union = new JunUNION(this.body(), this.body2());
		union.doOperation();

		JunNEGATE negate3 = new JunNEGATE(this.body());
		negate3.doOperation();

		int size = union.suboperators().size();
		suboperators = new Vector(size + 3);
		suboperators.addElement(negate1);
		suboperators.addElement(negate2);

		for (int index = 0; index < size; index++) {
			suboperators.addElement(union.suboperators().elementAt(index));
		}

		suboperators.addElement(negate3);
	}
}
