package sra.jun.voronoi.twoD.diagram;

import java.io.IOException;
import java.io.Writer;
import sra.smalltalk.SmalltalkException;

/**
 * JunVoronoi2dDot class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/25 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVoronoi2dDot.java,v 6.0 2003/10/28 10:52:27 nisinaka Exp $
 */
public class JunVoronoi2dDot extends JunVoronoi2dObject {
	protected double x = Double.NaN;
	protected double y = Double.NaN;

	/**
	 * Create a new instance of JunVoronoi2dDot.
	 * 
	 * @param x
	 * @param y
	 */
	public JunVoronoi2dDot(double x, double y) {
		super();
		this.x_(x);
		this.y_(y);
	}

	/**
	 * functions:
	 * 
	 * @param voronoi2dDot
	 * 
	 * @return JunVoronoi2dLine
	 */
	public JunVoronoi2dLine bisector_(JunVoronoi2dDot voronoi2dDot) {
		final double x1 = this.x;
		final double y1 = this.y;
		final double x2 = voronoi2dDot.x();
		final double y2 = voronoi2dDot.y();
		final double a = x2 - x1;
		final double b = y2 - y1;
		final double c = ((x2 * x2 + y2 * y2) - (x1 * x1 + y1 * y1)) * -0.5d;

		if ((Math.abs(a) < ACCURACY) && (Math.abs(b) < ACCURACY)) {
			throw SmalltalkException.Error("two points are the same.");
		}

		return new JunVoronoi2dLine(a, b, c);
	}

	/**
	 * functions:
	 * 
	 * @param voronoi2dDot
	 * 
	 * @return double
	 */
	public double distance_(JunVoronoi2dDot voronoi2dDot) {
		final double x1 = this.x;
		final double y1 = this.y;
		final double x2 = voronoi2dDot.x();
		final double y2 = voronoi2dDot.y();
		final double x12 = x1 - x2;
		final double y12 = y1 - y2;

		return Math.sqrt((x12 * x12) + (y12 * y12));
	}

	/**
	 * Print my string representation on aStream.
	 * 
	 * @param aWriter java.io.OutputStream
	 * 
	 * @throws IOException DOCUMENT ME!
	 */
	public void printOn_(Writer aWriter) throws IOException {
		aWriter.write("dot ( ");
		aWriter.write(String.valueOf(this.x));
		aWriter.write(" , ");
		aWriter.write(String.valueOf(this.y));
		aWriter.write(" )");
	}

	/**
	 * accessor x.
	 * 
	 * @return double
	 */
	public double x() {
		return this.x;
	}

	/**
	 * accessor x:.
	 * 
	 * @param aNumber
	 */
	public void x_(double aNumber) {
		this.x = aNumber;
	}

	/**
	 * accessor y.
	 * 
	 * @return double
	 */
	public double y() {
		return this.y;
	}

	/**
	 * accessor y:.
	 * 
	 * @param aNumber
	 */
	public void y_(double aNumber) {
		this.y = aNumber;
	}
}
