package sra.jun.voronoi.twoD.diagram;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Writer;
import sra.smalltalk.StBlockClosure;
import sra.smalltalk.StObject;

/**
 * JunVoronoi2dObject class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/25 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVoronoi2dObject.java,v 6.0 2003/10/28 10:52:27 nisinaka Exp $
 */
public abstract class JunVoronoi2dObject extends StObject {
	protected static boolean VoronoiDebugFlag = false;
	static final double ACCURACY = 1.0e-10d;

	/**
	 * Defalut constructor.
	 */
	public JunVoronoi2dObject() {
		this.initialize();
	}

	/**
	 * debug on/off-ing.
	 * 
	 * @param aBoolean
	 */
	public static void Debug_(boolean aBoolean) {
		VoronoiDebugFlag = aBoolean == true;
	}

	/**
	 * debug.
	 * 
	 * @return String
	 */
	public static String debugFileName() {
		return "debug.txt";
	}

	/**
	 * debug.
	 */
	public static void debugInitialize() {
		if (VoronoiDebugFlag) {
			File file = new File(JunVoronoi2dObject.debugFileName());

			if (file.exists()) {
				file.delete();
			}
		}
	}

	/**
	 * debug.
	 * 
	 * @param value
	 */
	public void debug_(String value) {
		if (VoronoiDebugFlag) {
			boolean setAppend = true;
			PrintWriter aPrintWriter;

			try {
				FileOutputStream aFileOutputStream = new FileOutputStream(this.debugFileName(), setAppend);
				aPrintWriter = new PrintWriter(aFileOutputStream);
			} catch (IOException e) {
				PrintStream out = System.out;
				aPrintWriter = new PrintWriter(out);
			}

			String lineSeparator = System.getProperty("line.separator");
			aPrintWriter.print(value + lineSeparator);
			aPrintWriter.flush();
		}
	}

	/**
	 * debug.
	 * 
	 * @param aBlock
	 */
	public void debug_(StBlockClosure aBlock) {
		if (VoronoiDebugFlag) {
			try {
				FileOutputStream f = new FileOutputStream(this.debugFileName());
				java.io.PrintWriter p = new java.io.PrintWriter(f);
			} catch (IOException e) {
			}

			int numberOfArguments = aBlock.numArgs();

			if (numberOfArguments == 0) {
				aBlock.value();
			} else {
				try {
					boolean setAppend = true;
					FileWriter fileWriter = new FileWriter(this.debugFileName(), setAppend);

					try {
						aBlock.value_(fileWriter);
					} finally {
						fileWriter.close();
					}
				} catch (IOException e) {
					aBlock.value_(System.out);
				}
			}
		}
	}

	/**
	 * debug.
	 * 
	 * @param aBlock
	 */
	public void debug_ORG(StBlockClosure aBlock) {
		if (VoronoiDebugFlag) {
			int numberOfArguments = aBlock.numArgs();

			if (numberOfArguments == 0) {
				aBlock.value();
			} else {
				try {
					boolean setAppend = true;
					FileWriter fileWriter = new FileWriter(this.debugFileName(), setAppend);

					try {
						aBlock.value_(fileWriter);
					} finally {
						fileWriter.close();
					}
				} catch (IOException e) {
					aBlock.value_(System.out);
				}
			}
		}
	}

	/**
	 * Answer true if the Object is equal to the receiver, otherwise false.
	 * 
	 * @param other java.lang.Object
	 * 
	 * @return boolean
	 */
	public boolean equals(Object other) {
		// means: ^self == anObject
		return super.equals(other);
	}

	// Hash Function

	/**
	 * Computes a hash code for this object.
	 * 
	 * @return int
	 */
	public int hashCode() {
		// means: ^self == anObject
		return super.hashCode();
	}

	/**
	 * Initialize the receiver.
	 */
	public void initialize() {
		//"do nothing"
	}

	/**
	 * Print my string representation on aStream.
	 * 
	 * @param aWriter java.io.OutputStream
	 * 
	 * @throws IOException DOCUMENT ME!
	 */
	public void printOn_(Writer aWriter) throws IOException {
		String title = this.getClass().getName();
		String vowel = "aeiou";

		if (vowel.indexOf(title.toLowerCase().substring(0, 1)) >= 0) {
			aWriter.write("an ");
		} else {
			aWriter.write("a ");
		}

		aWriter.write(title);
	}

	/**
	 * accessing.
	 * 
	 * @return JunVoronoi2dObject
	 */
	public JunVoronoi2dObject value() {
		return this;
	}
}
