package sra.jun.voronoi.twoD.diagram;

import java.io.IOException;
import java.io.Writer;

/**
 * JunVoronoi2dTriangle class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/25 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVoronoi2dTriangle.java,v 6.0 2003/10/28 10:52:27 nisinaka Exp $
 */
public class JunVoronoi2dTriangle extends JunVoronoi2dObject {
	protected JunVoronoi2dDot dot1 = null;
	protected JunVoronoi2dDot dot2 = null;
	protected JunVoronoi2dDot dot3 = null;

	/**
	 * Create a new instance of JunVoronoi2dTriangle.
	 * 
	 * @param voronoi2dDot1
	 * @param voronoi2dDot2
	 * @param voronoi2dDot3
	 */
	public JunVoronoi2dTriangle(JunVoronoi2dDot voronoi2dDot1, JunVoronoi2dDot voronoi2dDot2, JunVoronoi2dDot voronoi2dDot3) {
		super();
		this.dot1_(voronoi2dDot1);
		this.dot2_(voronoi2dDot2);
		this.dot3_(voronoi2dDot3);
	}

	/**
	 * Create a new instance of JunVoronoi2dTriangle.
	 * 
	 * @param voronoi2dDot1
	 * @param voronoi2dDot2
	 * @param voronoi2dDot3
	 * 
	 * @return JunVoronoi2dTriangle
	 */
	public static JunVoronoi2dTriangle Dot_dot_dot_(JunVoronoi2dDot voronoi2dDot1, JunVoronoi2dDot voronoi2dDot2, JunVoronoi2dDot voronoi2dDot3) {
		return new JunVoronoi2dTriangle(voronoi2dDot1, voronoi2dDot2, voronoi2dDot3);
	}

	/**
	 * functions:
	 * 
	 * @return double
	 */
	public double area() {
		return Math.abs(this.areaWithSign());
	}

	/**
	 * functions:
	 * 
	 * @return double
	 */
	public double areaWithSign() {
		final double x1 = this.dot1().x();
		final double y1 = this.dot1().y();
		final double x2 = this.dot2().x();
		final double y2 = this.dot2().y();
		final double x3 = this.dot3().x();
		final double y3 = this.dot3().y();
		final double area = (((x2 * y3) + (x3 * y1) + (x1 * y2)) - (x2 * y1) - (x3 * y2) - x1 * y3) * 0.5d;

		return area;
	}

	/**
	 * accessor dot1.
	 * 
	 * @return JunVoronoi2dDot
	 */
	public JunVoronoi2dDot dot1() {
		return this.dot1;
	}

	/**
	 * accessor dot1:.
	 * 
	 * @param voronoi2dDot
	 */
	public void dot1_(JunVoronoi2dDot voronoi2dDot) {
		this.dot1 = voronoi2dDot;
	}

	/**
	 * accessor dot2.
	 * 
	 * @return JunVoronoi2dDot
	 */
	public JunVoronoi2dDot dot2() {
		return this.dot2;
	}

	/**
	 * accessor dot2:.
	 * 
	 * @param voronoi2dDot
	 */
	public void dot2_(JunVoronoi2dDot voronoi2dDot) {
		this.dot2 = voronoi2dDot;
	}

	/**
	 * accessor dot3.
	 * 
	 * @return JunVoronoi2dDot
	 */
	public JunVoronoi2dDot dot3() {
		return this.dot3;
	}

	/**
	 * accessor dot3:.
	 * 
	 * @param voronoi2dDot
	 */
	public void dot3_(JunVoronoi2dDot voronoi2dDot) {
		this.dot3 = voronoi2dDot;
	}

	/**
	 * Print my string representation on aStream.
	 * 
	 * @param aWriter java.io.OutputStream
	 * 
	 * @throws IOException DOCUMENT ME!
	 */
	public void printOn_(Writer aWriter) throws IOException {
		aWriter.write("triangle ( ");
		this.dot1().printOn_(aWriter);
		aWriter.write(" , ");
		this.dot2().printOn_(aWriter);
		aWriter.write(" , ");
		this.dot3().printOn_(aWriter);
		aWriter.write(" )");
	}
}
