package sra.jun.voronoi.twoD.diagram;

import sra.jun.system.support.JunTestExamples;

/**
 * JunVoronoi2dTriangleTestExamples class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/25 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVoronoi2dTriangleTestExamples.java,v 6.0 2003/10/28 10:52:27 nisinaka Exp $
 */
public class JunVoronoi2dTriangleTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunVoronoi2dTriangle triangle = new JunVoronoi2dTriangle(new JunVoronoi2dDot(0, 0), new JunVoronoi2dDot(1, 1), new JunVoronoi2dDot(1, -1));
		System.out.println(triangle);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunVoronoi2dTriangle triangle = JunVoronoi2dTriangle.Dot_dot_dot_(new JunVoronoi2dDot(0, 0), new JunVoronoi2dDot(2, 2), new JunVoronoi2dDot(2, -2));
		double areaWithSign = triangle.areaWithSign();

		if (areaWithSign > 0) {
			System.out.println(areaWithSign + " --- counterclockwise (ccw)");
		} else {
			System.out.println(areaWithSign + " --- clockwise (cw)");
		}

		triangle = JunVoronoi2dTriangle.Dot_dot_dot_(new JunVoronoi2dDot(0, 0), new JunVoronoi2dDot(2, -2), new JunVoronoi2dDot(2, 2));
		areaWithSign = triangle.areaWithSign();

		if (areaWithSign > 0) {
			System.out.println(areaWithSign + " --- counterclockwise (ccw)");
		} else {
			System.out.println(areaWithSign + " --- clockwise (cw)");
		}

		System.out.println(triangle.area());
		System.out.println(triangle);

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunVoronoi2dTriangle triangle = JunVoronoi2dTriangle.Dot_dot_dot_(new JunVoronoi2dDot(0, 0), new JunVoronoi2dDot(1, 1), new JunVoronoi2dDot(1, -1));
		System.out.println(triangle);

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * 
	 * @throws Exception DOCUMENT ME!
	 */
	public static void main(String[] args) throws Exception {
		new JunVoronoi2dTriangleTestExamples();
	}
}
