package sra.jun.vrml.field.mf;

import java.util.Vector;
import sra.jun.geometry.basic.Jun2dPoint;

/**
 * JunVrmlMFVec2fField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlMFVec2fField.java,v 6.0 2003/10/28 10:52:27 nisinaka Exp $
 */
public class JunVrmlMFVec2fField extends sra.jun.vrml.field.abstracts.JunVrmlMFField {
	protected float[] value;

	/**
	 * Create a new instance of JunVrmlMFVec2Field and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlMFVec2fField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlMFVec2fField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlMFVec2fField(Object anObject) {
		this((Vector) anObject);
	}

	/**
	 * Create a JunVrmlMFVec2fField and initialize it.
	 * 
	 * @param aVector java.utilVector
	 */
	public JunVrmlMFVec2fField(Vector aVector) {
		this.value_(aVector);
	}

	/**
	 * Convert to an array of Jun2dPoint
	 * 
	 * @return sra.jun.geometry.basic.Jun2dPoint[]
	 */
	public Jun2dPoint[] as2dPoints() {
		Jun2dPoint[] points = new Jun2dPoint[value.length / 2];

		for (int i = 0; i < value.length; i += 2) {
			points[i / 2] = new Jun2dPoint(value[i], value[i + 1]);
		}

		return points;
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Set my value.
	 * 
	 * @param aVector java.util.Vector
	 */
	public void value_(Vector aVector) {
		Number[] numbers = new Number[aVector.size()];
		aVector.copyInto(numbers);
		value = new float[numbers.length];

		for (int i = 0; i < numbers.length; i++) {
			value[i] = numbers[i].floatValue();
		}
	}
}
