package sra.jun.vrml.field.sf;

import java.awt.*;
import java.awt.image.*;
import java.util.Vector;

/**
 * JunVrmlSFImageField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/04/14 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFImageField.java,v 6.0 2003/10/28 10:52:28 nisinaka Exp $
 */
public class JunVrmlSFImageField extends sra.jun.vrml.field.abstracts.JunVrmlSFField {
	protected int[] value;

	/**
	 * Create a new instance of JunVrmlSFImageField and initialize it.
	 * 
	 * @param numbers int[]
	 */
	public JunVrmlSFImageField(int[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlSFImageField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFImageField(Object anObject) {
		this((Vector) anObject);
	}

	/**
	 * Create a JunVrmlSFImageField and initialize it.
	 * 
	 * @param aVector java.utilVector
	 */
	public JunVrmlSFImageField(Vector aVector) {
		this.value_(aVector);
	}

	/**
	 * Convert to an Image.
	 * 
	 * @return java.awt.Image
	 */
	public Image asImage() {
		int type = value[2];

		if (type == 0) {
			return null;
		}

		if (type != 3) {
			this.error_("The type of image is not supported");

			return null;
		}

		int width = value[0];
		int height = value[1];
		DirectColorModel model = new DirectColorModel(24, 255 << 16, 255 << 8, 255);
		int size = value.length - 3;
		int[] pixels = new int[size];

		for (int i = 0; i < size; i++) {
			pixels[i] = value[i + 3];
		}

		MemoryImageSource mis = new MemoryImageSource(width, height, model, pixels, 0, width);
		Image image = Toolkit.getDefaultToolkit().createImage(mis);

		return image;
	}

	/**
	 * Answer my value.
	 * 
	 * @return int[]
	 */
	public int[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers int[]
	 */
	public void value_(int[] numbers) {
		value = numbers;
	}

	/**
	 * Set my value.
	 * 
	 * @param aVector java.util.Vector
	 */
	public void value_(Vector aVector) {
		Number[] numbers = new Number[aVector.size()];
		aVector.copyInto(numbers);
		value = new int[numbers.length];

		for (int i = 0; i < numbers.length; i++) {
			value[i] = numbers[i].intValue();
		}
	}
}
