package sra.jun.vrml.field.sf;

import java.util.Vector;
import sra.jun.geometry.basic.Jun3dPoint;

/**
 * JunVrmlSFVec3fField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFVec3fField.java,v 6.0 2003/10/28 10:52:28 nisinaka Exp $
 */
public class JunVrmlSFVec3fField extends sra.jun.vrml.field.abstracts.JunVrmlSFField {
	protected float[] value;

	/**
	 * Create a new instance of JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlSFVec3fField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFVec3fField(Object anObject) {
		this((Vector) anObject);
	}

	/**
	 * Create a JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param aVector java.utilVector
	 */
	public JunVrmlSFVec3fField(Vector aVector) {
		this.value_(aVector);
	}

	/**
	 * Convert the value to a Jun3dPoint.
	 * 
	 * @return sra.jun.geometry.basic.Jun3dPoint
	 */
	public Jun3dPoint as3dPoint() {
		return new Jun3dPoint(value[0], value[1], value[2]);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set the numbers as a value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Set my value.
	 * 
	 * @param aVector java.util.Vector
	 */
	public void value_(Vector aVector) {
		Number[] numbers = new Number[aVector.size()];
		aVector.copyInto(numbers);
		value = new float[numbers.length];

		for (int i = 0; i < numbers.length; i++) {
			value[i] = numbers[i].floatValue();
		}
	}
}
