package sra.jun.vrml.node.geometry;

import java.util.Hashtable;
import sra.jun.opengl.objects.JunOpenGL3dObject;
import sra.jun.vrml.field.sf.JunVrmlSFFloatField;

/**
 * JunVrmlSphereNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSphereNode.java,v 6.0 2003/10/28 10:52:28 nisinaka Exp $
 */
public class JunVrmlSphereNode extends sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode {
	protected JunVrmlSFFloatField radiusField;

	/**
	 * Create a new instance of JunVrmlSphereNode and initialize it.
	 * 
	 * @param aDictionary java.util.Hashtable
	 */
	public JunVrmlSphereNode(Hashtable aDictionary) {
		if (aDictionary.containsKey($("radius"))) {
			radiusField = new JunVrmlSFFloatField(aDictionary.get($("radius")));
		}
	}

	/**
	 * Answer the default value of radius.
	 * 
	 * @return float
	 */
	public static final float DefaultRadius() {
		return 1;
	}

	/**
	 * Convert to a JunOpenGL3dObject.
	 * 
	 * @return sra.jun.opengl.objects.JunOpenGL3dObject
	 */
	public JunOpenGL3dObject asJunOpenGL3dObject() {
		return JunOpenGL3dObject.Sphere_radius_(10, this.radius());
	}

	/**
	 * Answer the radius.
	 * 
	 * @return float
	 */
	public float radius() {
		return this.radiusField().value();
	}

	/**
	 * Answer the radius.
	 * 
	 * @return sra.jun.vrml.field.sf.JunVrmlSFFloatField
	 */
	protected JunVrmlSFFloatField radiusField() {
		if (radiusField == null) {
			radiusField = new JunVrmlSFFloatField(DefaultRadius());
		}

		return radiusField;
	}
}
