package sra.jun.vrml.node.grouping20;

import java.util.Hashtable;
import sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode;
import sra.jun.vrml.node.property20.JunVrmlAppearanceNode;
import sra.jun.vrml.support.*;

/**
 * JunVrmlShapeNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/04/17 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlShapeNode.java,v 6.0 2003/10/28 10:52:29 nisinaka Exp $
 */
public class JunVrmlShapeNode extends sra.jun.vrml.node.abstracts.JunVrmlAbstractGroupingNode {
	protected JunVrmlAppearanceNode appearance;
	protected JunVrmlAbstractGeometryNode geometry;

	/**
	 * Create a new instance of JunVrmlShapeNode and initialize it.
	 * 
	 * @param aDictionary java.util.Hashtable
	 */
	public JunVrmlShapeNode(Hashtable aDictionary) {
		if (aDictionary.containsKey($("appearance"))) {
			this.appearance_((JunVrmlAppearanceNode) aDictionary.get($("appearance")));
		}

		if (aDictionary.containsKey($("geometry"))) {
			this.geometry_((JunVrmlAbstractGeometryNode) aDictionary.get($("geometry")));
		}
	}

	/**
	 * Answer the appearance node.
	 * 
	 * @return sra.jun.vrml.node.property20.JunVrmlAppearanceNode
	 */
	public JunVrmlAppearanceNode appearance() {
		return appearance;
	}

	/**
	 * Set the appearance node.
	 * 
	 * @param aNode sra.jun.vrml.node.property20.JunVrmlAppearanceNode
	 */
	public void appearance_(JunVrmlAppearanceNode aNode) {
		appearance = aNode;
	}

	/**
	 * Answer the geometry node.
	 * 
	 * @return sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode
	 */
	public JunVrmlAbstractGeometryNode geometry() {
		return geometry;
	}

	/**
	 * Set the geometry node.
	 * 
	 * @param aNode  sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode
	 */
	public void geometry_(JunVrmlAbstractGeometryNode aNode) {
		geometry = aNode;
	}

	/**
	 * Process myself with the generator.
	 * 
	 * @param aVisitor sra.jun.vrml.support.JunVrmlNodeVisitor
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		try {
			aVisitor.perform_with_("doShape_", this);
		} catch (Exception e) {
			super.nodeDo_(aVisitor);
		}
	}
}
