package sra.jun.vrml.node.property20;

import java.util.Hashtable;
import sra.jun.geometry.basic.Jun2dPoint;
import sra.jun.opengl.objects.JunOpenGL3dObject;
import sra.jun.vrml.field.mf.JunVrmlMFVec2fField;
import sra.jun.vrml.support.JunVrmlNodeVisitor;

/**
 * JunVrmlTextureCoordinateNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/04/17 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlTextureCoordinateNode.java,v 6.0 2003/10/28 10:52:31 nisinaka Exp $
 */
public class JunVrmlTextureCoordinateNode extends sra.jun.vrml.node.abstracts.JunVrmlAbstractPropertyNode {
	protected JunVrmlMFVec2fField pointField;

	/**
	 * The default constructor.
	 */
	public JunVrmlTextureCoordinateNode() {
	}

	/**
	 * Create a new instance of JunVrmlTextureCoordinateNode and initialize it.
	 * 
	 * @param aDictionary java.util.Hashtable
	 */
	public JunVrmlTextureCoordinateNode(Hashtable aDictionary) {
		if (aDictionary.containsKey($("point"))) {
			pointField = new JunVrmlMFVec2fField(aDictionary.get($("point")));
		}
	}

	/**
	 * Answer the default value of point.
	 * 
	 * @return float[]
	 */
	public static final float[] DefaultPoint() {
		return new float[] {
		};
	}

	/**
	 * Process myself with the generator.
	 * 
	 * @param aVisitor sra.jun.vrml.support.JunVrmlNodeVisitor
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		try {
			aVisitor.perform_with_("doTextureCoordinate_", this);
		} catch (Exception e) {
			super.nodeDo_(aVisitor);
		}
	}

	/**
	 * Answer the point.
	 * 
	 * @return float[]
	 */
	public float[] point() {
		return this.pointField().value();
	}

	/**
	 * Convert the point field as an array of Jun2dPoint.
	 * 
	 * @return sra.jun.geometry.basic.Jun2dPoint[]
	 */
	public Jun2dPoint[] pointAs2dPoints() {
		return this.pointField().as2dPoints();
	}

	/**
	 * Set my properties on the JunOpenGL3dObject.
	 * 
	 * @param a3dObject sra.jun.opengl.objects.JunOpenGL3dObject
	 */
	public void propertyOn_(JunOpenGL3dObject a3dObject) {
	}

	/**
	 * Answer the point field.
	 * 
	 * @return sra.jun.vrml.field.sf.JunVrmlMFVec2fField
	 */
	protected JunVrmlMFVec2fField pointField() {
		if (pointField == null) {
			pointField = new JunVrmlMFVec2fField(DefaultPoint());
		}

		return pointField;
	}
}
