package sra.jun.vrml.support;

import sra.smalltalk.*;

/**
 * JunVrmlKeywordTable class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   1999/06/22 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlKeywordTable.java,v 6.0 2003/10/28 10:52:31 nisinaka Exp $
 */
public class JunVrmlKeywordTable extends StObject {
	/** The keyword table. */
	protected Object[] table = null;

	/**
	 * Create a new JunVrmlKeywordTable.
	 */
	public JunVrmlKeywordTable() {
		this(0);
	}

	/**
	 * Create a new JunVrmlKeywordTable.
	 * 
	 * @param nSize int
	 */
	public JunVrmlKeywordTable(int nSize) {
		table = new Object[nSize];
	}

	/**
	 * Answer the keyword table.
	 * 
	 * @return sra.jun.vrml.support.JunVrmlKeywordTable
	 */
	public static JunVrmlKeywordTable KeywordTable() {
		return null;
	}

	/**
	 * Answer the object at the specified place.
	 * 
	 * @param index int
	 * 
	 * @return java.lang.Object
	 */
	public Object at(int index) {
		return table[index];
	}

	/**
	 * Answer true if the table contains the symbol as a key.
	 * 
	 * @param aSymbol sra.smalltalk.StSymbol
	 * 
	 * @return boolean
	 */
	public boolean hasSymbol_(StSymbol aSymbol) {
		for (int i = 0; i < table.length; i++) {
			if (table[i] == aSymbol) {
				return true;
			}
		}

		return false;
	}

	/**
	 * Put the object at the specified place. This is a replacement of the
	 * smalltalk method 'at:put:'.
	 * 
	 * @param index int
	 * @param anObject java.lang.Object
	 */
	public void put(int index, Object anObject) {
		table[index] = anObject;
	}

	/**
	 * Answer the size of the table.
	 * 
	 * @return int
	 */
	public int size() {
		return table.length;
	}
}
