package sra.jun.vrml.support;

/**
 * JunVrmlScannerTable97 class
 * 
 *  @author    nisinaka
 *  @created   2000/04/17 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlScannerTable97.java,v 6.0 2003/10/28 10:52:31 nisinaka Exp $
 */
public class JunVrmlScannerTable97 extends JunVrmlScannerTable {
	/** The scanner table for VRML97. */
	protected static JunVrmlScannerTable scanningTable = null;

	//
	static {
		Initialize();
	}

	/**
	 * Create a new instance of JunVrmlScannerTable97.
	 * 
	 * @param nSize int
	 */
	public JunVrmlScannerTable97(int nSize) {
		super(nSize);
	}

	/**
	 * Initialize the scanner table.
	 */
	public static void Initialize() {
		JunVrmlScannerTable97 newTable = new JunVrmlScannerTable97(256);

		for (int i = 0; i < 256; i++) {
			newTable.put(i, $("xBinary"));
		}

		newTable.put(9, $("xDelimiter"));
		newTable.put(10, $("xDelimiter"));
		newTable.put(13, $("xDelimiter"));
		newTable.put(32, $("xDelimiter"));

		for (int i = '0'; i <= '9'; i++) {
			newTable.put(i, $("xDigit"));
		}

		for (int i = 'a'; i <= 'z'; i++) {
			newTable.put(i, $("xSymbol"));
		}

		for (int i = 'A'; i <= 'Z'; i++) {
			newTable.put(i, $("xSymbol"));
		}

		for (int i = 128; i < 256; i++) {
			newTable.put(i, $("xSymbol"));
		}

		newTable.put('\'', $("quote"));
		newTable.put('"', $("xDoubleQuote"));
		newTable.put('#', $("xComment"));
		newTable.put('[', $("leftBracket"));
		newTable.put(']', $("rightBracket"));
		newTable.put('{', $("leftBrace"));
		newTable.put('}', $("rightBrace"));
		newTable.put('+', $("xSign"));
		newTable.put('-', $("xSign"));
		newTable.put('<', $("xSymbol"));
		newTable.put('>', $("xSymbol"));
		newTable.put('=', $("xSymbol"));
		newTable.put('~', $("xSymbol"));
		newTable.put('*', $("xSymbol"));
		newTable.put('/', $("xSymbol"));
		newTable.put('_', $("xSymbol"));
		newTable.put(':', $("xSymbol"));
		newTable.put('%', $("xSymbol"));
		newTable.put('(', $("xSymbol"));
		newTable.put(')', $("xSymbol"));
		newTable.put('!', $("xSymbol"));
		newTable.put(',', $("xDelimiter"));
		newTable.put('.', $("xPeriod"));
		newTable.put('`', $("quote"));
		newTable.put(EndChar, $("eof"));
		scanningTable = newTable;
	}

	/**
	 * Answer the scanner table.
	 * 
	 * @return sra.jun.vrml.support.JunVrmlScannerTable
	 */
	public static JunVrmlScannerTable ScannerTable() {
		return scanningTable;
	}
}
