package sra.jun.vrml.support;

import java.util.Hashtable;
import sra.jun.vrml.node.geometry.JunVrmlSphereNode;
import sra.jun.vrml.node.geometry10.*;
import sra.jun.vrml.node.grouping10.JunVrmlSeparatorNode;
import sra.jun.vrml.node.property.JunVrmlNormalNode;
import sra.jun.vrml.node.property10.*;

/**
 * JunVrmlSyntaxTreeBuilder10 class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/24 (by nisinaka)
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSyntaxTreeBuilder10.java,v 6.0 2003/10/28 10:52:31 nisinaka Exp $
 */
public class JunVrmlSyntaxTreeBuilder10 extends JunVrmlSyntaxTreeBuilder {
	/** The node type table of VRML1.0. */
	protected static Hashtable NodeTypeTable = null;

	//
	static {
		_InitializeNodeTypeTable();
	}

	/**
	 * Initialize the NodeTypeTable of VRML1.0.
	 */
	protected static void _InitializeNodeTypeTable() {
		NodeTypeTable = new Hashtable();
		NodeTypeTable.put($("Coordinate3"), JunVrmlCoordinate3Node.class);
		NodeTypeTable.put($("Cube"), JunVrmlCubeNode.class);
		NodeTypeTable.put($("IndexedFaceSet"), JunVrmlIndexedFaceSetNode10.class);
		NodeTypeTable.put($("IndexedLineSet"), JunVrmlIndexedLineSetNode10.class);
		NodeTypeTable.put($("Material"), JunVrmlMaterialNode10.class);
		NodeTypeTable.put($("Normal"), JunVrmlNormalNode.class);
		NodeTypeTable.put($("Separator"), JunVrmlSeparatorNode.class);
		NodeTypeTable.put($("Sphere"), JunVrmlSphereNode.class);
		NodeTypeTable.put($("Texture2"), JunVrmlTexture2Node.class);
		NodeTypeTable.put($("TextureCoordinate2"), JunVrmlTextureCoordinate2Node.class);
	}

	/**
	 * Answer a node type table.
	 * 
	 * @return java.util.Hashtable
	 */
	public Hashtable nodeTypeTable() {
		return NodeTypeTable;
	}
}
