package sra.jun.vrml.support;

import java.util.Hashtable;
import sra.jun.vrml.node.geometry.JunVrmlSphereNode;
import sra.jun.vrml.node.geometry20.*;
import sra.jun.vrml.node.grouping20.*;
import sra.jun.vrml.node.property.JunVrmlNormalNode;
import sra.jun.vrml.node.property20.*;

/**
 * JunVrmlSyntaxTreeBuilder97 class
 * 
 *  @author    nisinaka
 *  @created   2000/03/24 (by nisinaka)
 *  @updated   N/A
 *  @version   406b (with StPL6.0) based on JunXXX for Smalltalk
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2003 Information-technology Promotion Agency,Japan (IPA)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSyntaxTreeBuilder97.java,v 6.0 2003/10/28 10:52:31 nisinaka Exp $
 */
public class JunVrmlSyntaxTreeBuilder97 extends JunVrmlSyntaxTreeBuilder {
	/** The node type table of VRML97. */
	protected static Hashtable NodeTypeTable = null;

	//
	static {
		_InitializeNodeTypeTable();
	}

	/**
	 * Initialize the NodeTypeTable of VRML97.
	 */
	protected static void _InitializeNodeTypeTable() {
		NodeTypeTable = new Hashtable();
		NodeTypeTable.put($("Appearance"), JunVrmlAppearanceNode.class);
		NodeTypeTable.put($("Box"), JunVrmlBoxNode.class);
		NodeTypeTable.put($("Color"), JunVrmlColorNode.class);
		NodeTypeTable.put($("Cone"), JunVrmlConeNode.class);
		NodeTypeTable.put($("Coordinate"), JunVrmlCoordinateNode.class);
		NodeTypeTable.put($("Cylinder"), JunVrmlCylinderNode.class);
		NodeTypeTable.put($("DirectionalLight"), JunVrmlDirectionalLightNode20.class);
		NodeTypeTable.put($("FontStyle"), JunVrmlFontStyleNode20.class);
		NodeTypeTable.put($("Group"), JunVrmlGroupNode.class);
		NodeTypeTable.put($("Material"), JunVrmlMaterialNode20.class);
		NodeTypeTable.put($("NavigationInfo"), JunVrmlNavigationInfoNode.class);
		NodeTypeTable.put($("Normal"), JunVrmlNormalNode.class);
		NodeTypeTable.put($("IndexedFaceSet"), JunVrmlIndexedFaceSetNode20.class);
		NodeTypeTable.put($("IndexedLineSet"), JunVrmlIndexedLineSetNode20.class);
		NodeTypeTable.put($("PixelTexture"), JunVrmlPixelTextureNode.class);
		NodeTypeTable.put($("PointSet"), JunVrmlPointSetNode20.class);
		NodeTypeTable.put($("Shape"), JunVrmlShapeNode.class);
		NodeTypeTable.put($("Sphere"), JunVrmlSphereNode.class);
		NodeTypeTable.put($("Text"), JunVrmlTextNode.class);
		NodeTypeTable.put($("TextureCoordinate"), JunVrmlTextureCoordinateNode.class);
		NodeTypeTable.put($("Transform"), JunVrmlTransformNode.class);
		NodeTypeTable.put($("Viewpoint"), JunVrmlViewpointNode.class);
		NodeTypeTable.put($("WorldInfo"), JunVrmlWorldInfoNode.class);
	}

	/**
	 * Answer a node type table.
	 * 
	 * @return java.util.Hashtable
	 */
	public Hashtable nodeTypeTable() {
		return NodeTypeTable;
	}
}
