package sra.smalltalk;

/**
 * SmalltalkException class
 * 
 *  @author    nisinaka
 *  @created   1998/10/01 (by nisinaka)
 *  @updated   N/A
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: SmalltalkException.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public class SmalltalkException extends RuntimeException {

	/**
	 * Constructs a <code>SmalltalkException</code> with no detail message.
	 */
	public SmalltalkException() {
		super();
		this.printStackTrace();
	}

	/**
	 * Constructs a <code>SmalltalkException</code> with the specified detail
	 * message.
	 * 
	 * @param e java.lang.String
	 */
	public SmalltalkException(Exception e) {
		super();
		e.printStackTrace();
	}

	/**
	 * Constructs a <code>SmalltalkException</code> with the specified detail
	 * message.
	 * 
	 * @param s java.lang.String
	 */
	public SmalltalkException(String s) {
		super(s);
		this.printStackTrace();
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for Error.
	 * 
	 * @param aString DOCUMENT ME!
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException Error(String aString) {
		return new SmalltalkException("Error: " + aString);
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for Halt.
	 * 
	 * @param aString DOCUMENT ME!
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException Halt(String aString) {
		return new SmalltalkException("Halt: " + aString);
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for MessageNotUnderstood.
	 * 
	 * @param info DOCUMENT ME!
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException MessageNotUnderstood(String info) {
		return new SmalltalkException("message not understood - " + info);
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for ShouldNotImplement.
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException ShouldNotImplement() {
		return Error("This message is not appropriate for this object");
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for SubclassResponsibility.
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException SubclassResponsibility() {
		return new SmalltalkException("subclass responsibility");
	}

	/**
	 * Constructs a <code>SmalltalkException</code> for SubclassResponsibility.
	 * 
	 * @param info DOCUMENT ME!
	 * 
	 * @return sra.smalltalk.SmalltalkException
	 */
	public static SmalltalkException SubclassResponsibility(String info) {
		return new SmalltalkException("subclass responsibility - " + info);
	}
}
