package sra.smalltalk;

import java.io.*;

/**
 * StAssociation class
 * 
 *  @author    nisinaka
 *  @created   1999/06/23 (by nisinaka)
 *  @updated   N/A
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StAssociation.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public class StAssociation extends StObject {
	/** The key object of the association. */
	Object key = null;

	/** The value object of the association. */
	Object value = null;

	/**
	 * Create a new instance of StAssociation.
	 * 
	 * @param keyObject java.lang.Object
	 * @param valueObject java.lang.Object
	 */
	public StAssociation(Object keyObject, Object valueObject) {
		key = keyObject;
		value = valueObject;
	}

	/**
	 * Answer the key object of the receiver.
	 * 
	 * @return java.lang.Object
	 */
	public final Object key() {
		return key;
	}

	/**
	 * Print my string representation on aWriter.
	 * 
	 * @param aWriter java.io.Writer
	 * 
	 * @throws IOException DOCUMENT ME!
	 */
	public void printOn_(Writer aWriter) throws IOException {
		aWriter.write(key + "->" + value);
	}

	/**
	 * Returns a String that represents the value of this object.
	 * 
	 * @return a string representation of the receiver
	 */
	public String toString() {
		// Insert code to print the receiver here.
		// This implementation forwards the message to super. You may replace or supplement this.
		return super.toString();
	}

	/**
	 * Answer the value object of the receiver.
	 * 
	 * @return java.lang.Object
	 */
	public final Object value() {
		return value;
	}
}
