package sra.smalltalk;

import java.awt.*;

/**
 * StDisplayable interface
 * 
 *  @author    nisinaka
 *  @created   2002/11/21 (by nisinaka)
 *  @updated   N/A
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StDisplayable.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public interface StDisplayable {

	/**
	 * Answer the receiver as StImage.
	 *
	 * @return sra.smalltalk.StImage
	 */
	public StImage asImage();

	/**
	 * Answer the bounding box of the receiver.
	 *
	 * @return java.awt.Rectangle
	 */
	public Rectangle bounds();

	/**
	 * Display the receiver on the graphics.
	 *
	 * @param aGraphics java.awt.Graphics
	 */
	public void displayOn_(Graphics aGraphics);

	/**
	 * Display the receiver on the graphics at the specified point.
	 *
	 * @param aGraphics java.awt.Graphics
	 * @param aPoint java.awt.Point
	 */
	public void displayOn_at_(Graphics aGraphics, Point aPoint);
}
