package sra.smalltalk;

import java.util.*;

/**
 * StModel class
 * 
 *  @author    nisinaka
 *  @created   1998/08/05 (by nisinaka)
 *  @updated   1998/10/09 (by nisinaka)
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StModel.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public class StModel extends StObject {
	protected Vector dependents = null;

	/**
	 * Convert the receiver's dependents as an array of StObject.
	 * 
	 * @return sra.smalltalk.StObject[]
	 */
	public StObject[] _dependentsAsArray() {
		if (dependents == null) {
			return null;
		}

		int size = dependents.size();
		StObject[] anArray = new StObject[size];
		dependents.copyInto(anArray);
		return anArray;
	}

	/**
	 * Answer the receiver's dependents.
	 * 
	 * @return java.util.Vector
	 */
	public Vector myDependents() {
		return dependents;
	}

	/**
	 * Set the receiver's dependents.
	 * 
	 * @param dependentsOrNull java.util.Vector
	 */
	public void myDependents_(Vector dependentsOrNull) {
		dependents = dependentsOrNull;
	}

	/**
	 * Do not copy the dependents list.
	 * 
	 * @return sra.smalltalk.StObject
	 */
	public StObject postCopy() {
		super.postCopy();
		this.breakDependents();
		return this;
	}

	/**
	 * Answer the popup menu if exist.
	 *
	 * @return sra.smalltalk.StMenu
	 */
	protected StMenu popupMenu() {
		return null;
	}
}
