package sra.smalltalk;

import java.awt.event.*;

/**
 * StRadioButtonMenuItem class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/09/16 (by MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StRadioButtonMenuItem.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public class StRadioButtonMenuItem extends StCheckBoxMenuItem {
	private StButtonGroup group = null;

	/**
	 * Creates a menuItem with text.
	 * 
	 * @param text java.lang.String
	 */
	public StRadioButtonMenuItem(String text) {
		this(text, false);
	}

	/**
	 * Creates a menuItem with text.
	 * 
	 * @param text java.lang.String
	 * @param selected boolean
	 */
	public StRadioButtonMenuItem(String text, boolean selected) {
		super(text, selected);
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aBoolean boolean
	 */
	public void setSelected(boolean aBoolean) {
		if (aBoolean == true) {
			getGroup().setSelection(this);
		}
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return sra.smalltalk.StButtonGroup
	 */
	StButtonGroup getGroup() {
		return group;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aBoolean boolean
	 */
	protected void selected_(boolean aBoolean) {
		if (selected != aBoolean) {
			selected = aBoolean;

			StSymbol aspect = selected ? $("selected") : $("deselected");
			StMenuItem root = getRoot();

			if (root instanceof StMenuModel) {
				((StMenuModel) root).changed_with_(aspect, this);
			}

			this.fireItemStateChanged(new ItemEvent(this, ItemEvent.ITEM_STATE_CHANGED, this, selected ? ItemEvent.SELECTED : ItemEvent.DESELECTED));
		}
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param aGroup sra.smalltalk.StButtonGroup
	 */
	void setGroup(StButtonGroup aGroup) {
		group = aGroup;
	}
}
