package sra.smalltalk;

import java.awt.*;
import java.awt.event.*;

/**
 * WindowSpecLayoutTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2003/05/08 (by nisinaka)
 *  @updated   N/A
 *  @version   6.0
 *  @copyright 1999-2003 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2003 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: WindowSpecLayoutTestExamples.java,v 6.0 2003/10/28 10:52:32 nisinaka Exp $
 */
public class WindowSpecLayoutTestExamples extends SmalltalkTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		Panel aPanel = new Panel();
		aPanel.setLayout(new WindowSpecLayout());
		aPanel.add(new Button("button1"), WindowSpecLayout.Position(0f, 10, 0f, 10, 0.5f, -10, 0.5f, -10));
		aPanel.setSize(100, 100);

		Frame aFrame = new Frame();
		aFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				e.getWindow().dispose();
			}
		});
		aFrame.add(aPanel);
		aFrame.pack();
		StApplicationModel._ShowAtMousePoint(aFrame);

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new WindowSpecLayoutTestExamples();
	}
}
